# -*- coding: utf-8 -*-
#!/usr/bin/env python3

hl2hm={'P 1':'P 1',
        '-P 1':'P -1',
        'P 2y':'P 1 2 1',
        'P 2':'P 1 1 2',
        'P 2x':'P 2 1 1',
        'P 2yb':'P 1 21 1',
        'P 2c':'P 1 1 21',
        'P 2xa':'P 21 1 1',
        'C 2y':'C 1 2 1',
        'A 2y':'A 1 2 1',
        'I 2y':'I 1 2 1',
        'A 2':'A 1 1 2',
        'B 2':'B 1 1 2',
        'I 2':'I 1 1 2',
        'B 2x':'B 2 1 1',
        'C 2x':'C 2 1 1',
        'I 2x':'I 2 1 1',
        'P -2y':'P 1 m 1',
        'P -2':'P 1 1 m',
        'P -2x':'P m 1 1',
        'P -2yc':'P 1 c 1',
        'P -2yac':'P 1 n 1',
        'P -2ya':'P 1 a 1',
        'P -2a':'P 1 1 a',
        'P -2ab':'P 1 1 n',
        'P -2b':'P 1 1 b',
        'P -2xb':'P b 1 1',
        'P -2xbc':'P n 1 1',
        'P -2xc':'P c 1 1',
        'C -2y':'C 1 m 1',
        'A -2y':'A 1 m 1',
        'I -2y':'I 1 m 1',
        'A -2':'A 1 1 m',
        'B -2':'B 1 1 m',
        'I -2':'I 1 1 m',
        'B -2x':'B m 1 1',
        'C -2x':'C m 1 1',
        'I -2x':'I m 1 1',
        'C -2yc':'C 1 c 1',
        'A -2yac':'A 1 n 1',
        'I -2ya':'I 1 a 1',
        'A -2ya':'A 1 a 1',
        'C -2ybc':'C 1 n 1',
        'I -2yc':'I 1 c 1',
        'A -2a':'A 1 1 a',
        'B -2bc':'B 1 1 n',
        'I -2b':'I 1 1 b',
        'B -2b':'B 1 1 b',
        'A -2ac':'A 1 1 n',
        'I -2a':'I 1 1 a',
        'B -2xb':'B b 1 1',
        'C -2xbc':'C n 1 1',
        'I -2xc':'I c 1 1',
        'C -2xc':'C c 1 1',
        'B -2xbc':'B n 1 1',
        'I -2xb':'I b 1 1',
        '-P 2y':'P 1 2/m 1',
        '-P 2':'P 1 1 2/m',
        '-P 2x':'P 2/m 1 1',
        '-P 2yb':'P 1 21/m 1',
        '-P 2c':'P 1 1 21/m',
        '-P 2xa':'P 21/m 1 1',
        '-C 2y':'C 1 2/m 1',
        '-A 2y':'A 1 2/m 1',
        '-I 2y':'I 1 2/m 1',
        '-A 2':'A 1 1 2/m',
        '-B 2':'B 1 1 2/m',
        '-I 2':'I 1 1 2/m',
        '-B 2x':'B 2/m 1 1',
        '-C 2x':'C 2/m 1 1',
        '-I 2x':'I 2/m 1 1',
        '-P 2yc':'P 1 2/c 1',
        '-P 2yac':'P 1 2/n 1',
        '-P 2ya':'P 1 2/a 1',
        '-P 2a':'P 1 1 2/a',
        '-P 2ab':'P 1 1 2/n',
        '-P 2b':'P 1 1 2/b',
        '-P 2xb':'P 2/b 1 1',
        '-P 2xbc':'P 2/n 1 1',
        '-P 2xc':'P 2/c 1 1',
        '-P 2ybc':'P 1 21/c 1',
        '-P 2yn':'P 1 21/n 1',
        '-P 2yab':'P 1 21/a 1',
        '-P 2ac':'P 1 1 21/a',
        '-P 2n':'P 1 1 21/n',
        '-P 2bc':'P 1 1 21/b',
        '-P 2xab':'P 21/b 1 1',
        '-P 2xn':'P 21/n 1 1',
        '-P 2xac':'P 21/c 1 1',
        '-C 2yc':'C 1 2/c 1',
        '-A 2yac':'A 1 2/n 1',
        '-I 2ya':'I 1 2/a 1',
        '-A 2ya':'A 1 2/a 1',
        '-C 2ybc':'C 1 2/n 1',
        '-I 2yc':'I 1 2/c 1',
        '-A 2a':'A 1 1 2/a',
        '-B 2bc':'B 1 1 2/n',
        '-I 2b':'I 1 1 2/b',
        '-B 2b':'B 1 1 2/b',
        '-A 2ac':'A 1 1 2/n',
        '-I 2a':'I 1 1 2/a',
        '-B 2xb':'B 2/b 1 1',
        '-C 2xbc':'C 2/n 1 1',
        '-I 2xc':'I 2/c 1 1',
        '-C 2xc':'C 2/c 1 1',
        '-B 2xbc':'B 2/n 1 1',
        '-I 2xb':'I 2/b 1 1',
        'P 2 2':'P 2 2 2',
        'P 2c 2':'P 2 2 21',
        'P 2a 2a':'P 21 2 2',
        'P 2 2b':'P 2 21 2',
        'P 2 2ab':'P 21 21 2',
        'P 2bc 2':'P 2 21 21',
        'P 2ac 2ac':'P 21 2 21',
        'P 2ac 2ab':'P 21 21 21',
        'C 2c 2':'C 2 2 21',
        'A 2a 2a':'A 21 2 2',
        'B 2 2b':'B 2 21 2',
        'C 2 2':'C 2 2 2',
        'A 2 2':'A 2 2 2',
        'B 2 2':'B 2 2 2',
        'F 2 2':'F 2 2 2',
        'I 2 2':'I 2 2 2',
        'I 2b 2c':'I 21 21 21',
        'P 2 -2':'P m m 2',
        'P -2 2':'P 2 m m',
        'P -2 -2':'P m 2 m',
        'P 2c -2':'P m c 21',
        'P 2c -2c':'P c m 21',
        'P -2a 2a':'P 21 m a',
        'P -2 2a':'P 21 a m',
        'P -2 -2b':'P b 21 m',
        'P -2b -2':'P m 21 b',
        'P 2 -2c':'P c c 2',
        'P -2a 2':'P 2 a a',
        'P -2b -2b':'P b 2 b',
        'P 2 -2a':'P m a 2',
        'P 2 -2b':'P b m 2',
        'P -2b 2':'P 2 m b',
        'P -2c 2':'P 2 c m',
        'P -2c -2c':'P c 2 m',
        'P -2a -2a':'P m 2 a',
        'P 2c -2ac':'P c a 21',
        'P 2c -2b':'P b c 21',
        'P -2b 2a':'P 21 a b',
        'P -2ac 2a':'P 21 c a',
        'P -2bc -2c':'P c 21 b',
        'P -2a -2ab':'P b 21 a',
        'P 2 -2bc':'P n c 2',
        'P 2 -2ac':'P c n 2',
        'P -2ac 2':'P 2 n a',
        'P -2ab 2':'P 2 a n',
        'P -2ab -2ab':'P b 2 n',
        'P -2bc -2bc':'P n 2 b',
        'P 2ac -2':'P m n 21',
        'P 2bc -2bc':'P n m 21',
        'P -2ab 2ab':'P 21 m n',
        'P -2 2ac':'P 21 n m',
        'P -2 -2bc':'P n 21 m',
        'P -2ab -2':'P m 21 n',
        'P 2 -2ab':'P b a 2',
        'P -2bc 2':'P 2 c b',
        'P -2ac -2ac':'P c 2 a',
        'P 2c -2n':'P n a 21',
        'P 2c -2ab':'P b n 21',
        'P -2bc 2a':'P 21 n b',
        'P -2n 2a':'P 21 c n',
        'P -2n -2ac':'P c 21 n',
        'P -2ac -2n':'P n 21 a',
        'P 2 -2n':'P n n 2',
        'P -2n 2':'P 2 n n',
        'P -2n -2n':'P n 2 n',
        'C 2 -2':'C m m 2',
        'A -2 2':'A 2 m m',
        'B -2 -2':'B m 2 m',
        'C 2c -2':'C m c 21',
        'C 2c -2c':'C c m 21',
        'A -2a 2a':'A 21 m a',
        'A -2 2a':'A 21 a m',
        'B -2 -2b':'B b 21 m',
        'B -2b -2':'B m 21 b',
        'C 2 -2c':'C c c 2',
        'A -2a 2':'A 2 a a',
        'B -2b -2b':'B b 2 b',
        'A 2 -2':'A m m 2',
        'B 2 -2':'B m m 2',
        'B -2 2':'B 2 m m',
        'C -2 2':'C 2 m m',
        'C -2 -2':'C m 2 m',
        'A -2 -2':'A m 2 m',
        'A 2 -2c':'A b m 2',
        'B 2 -2c':'B m a 2',
        'B -2c 2':'B 2 c m',
        'C -2b 2':'C 2 m b',
        'C -2b -2b':'C m 2 a',
        'A -2c -2c':'A c 2 m',
        'A 2 -2a':'A m a 2',
        'B 2 -2b':'B b m 2',
        'B -2b 2':'B 2 m b',
        'C -2c 2':'C 2 c m',
        'C -2c -2c':'C c 2 m',
        'A -2a -2a':'A m 2 a',
        'A 2 -2ac':'A b a 2',
        'B 2 -2bc':'B b a 2',
        'B -2bc 2':'B 2 c b',
        'C -2bc 2':'C 2 c b',
        'C -2bc -2bc':'C c 2 a',
        'A -2ac -2ac':'A c 2 a',
        'F 2 -2':'F m m 2',
        'F -2 2':'F 2 m m',
        'F -2 -2':'F m 2 m',
        'F 2 -2d':'F d d 2',
        'F -2d 2':'F 2 d d',
        'F -2d -2d':'F d 2 d',
        'I 2 -2':'I m m 2',
        'I -2 2':'I 2 m m',
        'I -2 -2':'I m 2 m',
        'I 2 -2c':'I b a 2',
        'I -2a 2':'I 2 c b',
        'I -2b -2b':'I c 2 a',
        'I 2 -2a':'I m a 2',
        'I 2 -2b':'I b m 2',
        'I -2b 2':'I 2 m b',
        'I -2c 2':'I 2 c m',
        'I -2c -2c':'I c 2 m',
        'I -2a -2a':'I m 2 a',
        '-P 2 2':'P m m m',
        'P 2 2 -1n':'P n n n:1',
        '-P 2ab 2bc':'P n n n:2',
        '-P 2 2c':'P c c m',
        '-P 2a 2':'P m a a',
        '-P 2b 2b':'P b m b',
        'P 2 2 -1ab':'P b a n:1',
        '-P 2ab 2b':'P b a n:2',
        'P 2 2 -1bc':'P n c b:1',
        '-P 2b 2bc':'P n c b:2',
        'P 2 2 -1ac':'P c n a:1',
        '-P 2a 2c':'P c n a:2',
        '-P 2a 2a':'P m m a',
        '-P 2b 2':'P m m b',
        '-P 2 2b':'P b m m',
        '-P 2c 2c':'P c m m',
        '-P 2c 2':'P m c m',
        '-P 2 2a':'P m a m',
        '-P 2a 2bc':'P n n a',
        '-P 2b 2n':'P n n b',
        '-P 2n 2b':'P b n n',
        '-P 2ab 2c':'P c n n',
        '-P 2ab 2n':'P n c n',
        '-P 2n 2bc':'P n a n',
        '-P 2ac 2':'P m n a',
        '-P 2bc 2bc':'P n m b',
        '-P 2ab 2ab':'P b m n',
        '-P 2 2ac':'P c n m',
        '-P 2 2bc':'P n c m',
        '-P 2ab 2':'P m a n',
        '-P 2a 2ac':'P c c a',
        '-P 2b 2c':'P c c b',
        '-P 2a 2b':'P b a a',
        '-P 2ac 2c':'P c a a',
        '-P 2bc 2b':'P b c b',
        '-P 2b 2ab':'P b a b',
        '-P 2 2ab':'P b a m',
        '-P 2bc 2':'P m c b',
        '-P 2ac 2ac':'P c m a',
        '-P 2ab 2ac':'P c c n',
        '-P 2ac 2bc':'P n a a',
        '-P 2bc 2ab':'P b n b',
        '-P 2c 2b':'P b c m',
        '-P 2c 2ac':'P c a m',
        '-P 2ac 2a':'P m c a',
        '-P 2b 2a':'P m a b',
        '-P 2a 2ab':'P b m a',
        '-P 2bc 2c':'P c m b',
        '-P 2 2n':'P n n m',
        '-P 2n 2':'P m n n',
        '-P 2n 2n':'P n m n',
        'P 2 2ab -1ab':'P m m n:1',
        '-P 2ab 2a':'P m m n:2',
        'P 2bc 2 -1bc':'P n m m:1',
        '-P 2c 2bc':'P n m m:2',
        'P 2ac 2ac -1ac':'P m n m:1',
        '-P 2c 2a':'P m n m:2',
        '-P 2n 2ab':'P b c n',
        '-P 2n 2c':'P c a n',
        '-P 2a 2n':'P n c a',
        '-P 2bc 2n':'P n a b',
        '-P 2ac 2b':'P b n a',
        '-P 2b 2ac':'P c n b',
        '-P 2ac 2ab':'P b c a',
        '-P 2bc 2ac':'P c a b',
        '-P 2ac 2n':'P n m a',
        '-P 2bc 2a':'P m n b',
        '-P 2c 2ab':'P b n m',
        '-P 2n 2ac':'P c m n',
        '-P 2n 2a':'P m c n',
        '-P 2c 2n':'P n a m',
        '-C 2c 2':'C m c m',
        '-C 2c 2c':'C c m m',
        '-A 2a 2a':'A m m a',
        '-A 2 2a':'A m a m',
        '-B 2 2b':'B b m m',
        '-B 2b 2':'B m m b',
        '-C 2bc 2':'C m c a',
        '-C 2bc 2bc':'C c m b',
        '-A 2ac 2ac':'A b m a',
        '-A 2 2ac':'A c a m',
        '-B 2 2bc':'B b c m',
        '-B 2bc 2':'B m a b',
        '-C 2 2':'C m m m',
        '-A 2 2':'A m m m',
        '-B 2 2':'B m m m',
        '-C 2 2c':'C c c m',
        '-A 2a 2':'A m a a',
        '-B 2b 2b':'B b m b',
        '-C 2b 2':'C m m a',
        '-C 2b 2b':'C m m b',
        '-A 2c 2c':'A b m m',
        '-A 2 2c':'A c m m',
        '-B 2 2c':'B m c m',
        '-B 2c 2':'B m a m',
        ' C 2 2 -1bc':'C c c a:1',
        '-C 2b 2bc':'C c c a:2',
        'C 2 2 -1bc':'C c c b:1',
        '-C 2b 2c':'C c c b:2',
        'A 2 2 -1ac':'A b a a:1',
        '-A 2a 2c':'A b a a:2',
        'A 2 2 -1ac':'A c a a:1',
        '-A 2ac 2c':'A c a a:2',
        'B 2 2 -1bc':'B b c b:1',
        '-B 2bc 2b':'B b c b:2',
        'B 2 2 -1bc':'B b a b:1',
        '-B 2b 2bc':'B b a b:2',
        '-F 2 2':'F m m m',
        'F 2 2 -1d':'F d d d:1',
        '-F 2uv 2vw':'F d d d:2',
        '-I 2 2':'I m m m',
        '-I 2 2c':'I b a m',
        '-I 2a 2':'I m c b',
        '-I 2b 2b':'I c m a',
        '-I 2b 2c':'I b c a',
        '-I 2a 2b':'I c a b',
        '-I 2b 2':'I m m a',
        '-I 2a 2a':'I m m b',
        '-I 2c 2c':'I b m m',
        '-I 2 2b':'I c m m',
        '-I 2 2a':'I m c m',
        '-I 2c 2':'I m a m',
        'P 4':'P 4',
        'P 4w':'P 41',
        'P 4c':'P 42',
        'P 4cw':'P 43',
        'I 4':'I 4',
        'I 4bw':'I 41',
        'P -4':'P -4',
        'I -4':'I -4',
        '-P 4':'P 4/m',
        '-P 4c':'P 42/m',
        'P 4ab -1ab':'P 4/n:1',
        '-P 4a':'P 4/n:2',
        'P 4n -1n':'P 42/n:1',
        '-P 4bc':'P 42/n:2',
        '-I 4':'I 4/m',
        'I 4bw -1bw':'I 41/a:1',
        '-I 4ad':'I 41/a:2',
        'P 4 2':'P 4 2 2',
        'P 4ab 2ab':'P 42 1 2',
        'P 4w 2c':'P 41 2 2',
        'P 4abw 2nw':'P 41 21 2',
        'P 4c 2':'P 42 2 2',
        'P 4n 2n':'P 42 21 2',
        'P 4cw 2c':'P 43 2 2',
        'P 4nw 2abw':'P 43 21 2',
        'I 4 2':'I 4 2 2',
        'I 4bw 2bw':'I 41 2 2',
        'P 4 -2':'P 4 m m',
        'P 4 -2ab':'P 4 b m',
        'P 4c -2c':'P 42 c m',
        'P 4n -2n':'P 42 n m',
        'P 4 -2c':'P 4 c c',
        'P 4 -2n':'P 4 n c',
        'P 4c -2':'P 42 m c',
        'P 4c -2ab':'P 42 b c',
        'I 4 -2':'I 4 m m',
        'I 4 -2c':'I 4 c m',
        'I 4bw -2':'I 41 m d',
        'I 4bw -2c':'I 41 c d',
        'P -4 2':'P -4 2 m',
        'P -4 2c':'P -4 2 c',
        'P -4 2ab':'P -4 21 m',
        'P -4 2n':'P -4 21 c',
        'P -4 -2':'P -4 m 2',
        'P -4 -2c':'P -4 c 2',
        'P -4 -2ab':'P -4 b 2',
        'P -4 -2n':'P -4 n 2',
        'I -4 -2':'I -4 m 2',
        'I -4 -2c':'I -4 c 2',
        'I -4 2':'I -4 2 m',
        'I -4 2bw':'I -4 2 d',
        '-P 4 2':'P 4/m m m',
        '-P 4 2c':'P 4/m c c',
        'P 4 2 -1ab':'P 4/n b m:1',
        '-P 4a 2b':'P 4/n b m:2',
        'P 4 2 -1n':'P 4/n n c:1',
        '-P 4a 2bc':'P 4/n n c:2',
        '-P 4 2ab':'P 4/m b m',
        '-P 4 2n':'P 4/m n c',
        'P 4ab 2ab -1ab':'P 4/n m m:1',
        '-P 4a 2a':'P 4/n m m:2',
        'P 4ab 2n -1ab':'P 4/n c c:1',
        '-P 4a 2ac':'P 4/n c c:2',
        '-P 4c 2':'P 42/m m c',
        '-P 4c 2c':'P 42/m c m',
        'P 4n 2c -1n':'P 42/n b c:1',
        '-P 4ac 2b':'P 42/n b c:2',
        'P 4n 2 -1n':'P 42/n n m:1',
        '-P 4ac 2bc':'P 42/n n m:2',
        '-P 4c 2ab':'P 42/m b c',
        '-P 4n 2n':'P 42/m n m',
        'P 4n 2n -1n':'P 42/n m c:1',
        '-P 4ac 2a':'P 42/n m c:2',
        'P 4n 2ab -1n':'P 42/n c m:1',
        '-P 4ac 2ac':'P 42/n c m:2',
        '-I 4 2':'I 4/m m m',
        '-I 4 2c':'I 4/m c m',
        'I 4bw 2bw -1bw':'I 41/a m d:1',
        '-I 4bd 2':'I 41/a m d:2',
        'I 4bw 2aw -1bw':'I 41/a c d:1',
        '-I 4bd 2c':'I 41/a c d:2',
        'P 3':'P 3',
        'P 31':'P 31',
        'P 32':'P 32',
        'R 3':'R 3:H',
        'P 3*':'R 3:R',
        '-P 3':'P -3',
        '-R 3':'R -3:H',
        '-P 3*':'R -3:R',
        'P 3 2':'P 3 1 2',
        'P 3 2"':'P 3 2 1',
        'P 31 2c (0 0 1)':'P 31 1 2',
        'P 31 2"':'P 31 2 1',
        'P 32 2c (0 0 -1)':'P 32 1 2',
        'P 32 2"':'P 32 2 1',
        'R 3 2"':'R 32:H',
        'P 3* 2':'R 32:R',
        'P 3 -2"':'P 3 m 1',
        'P 3 -2':'P 3 1 m',
        'P 3 -2"c':'P 3 c 1',
        'P 3 -2c':'P 3 1 c',
        'R 3 -2"':'R 3 m:H',
        'P 3* -2':'R 3 m:R',
        'R 3 -2"c':'R 3 c:H',
        'P 3* -2n':'R 3 c:R',
        '-P 3 2':'P -3 1 m',
        '-P 3 2c':'P -3 1 c',
        '-P 3 2"':'P -3 m 1',
        '-P 3 2"c':'P -3 c 1',
        '-R 3 2"':'R -3 m:H',
        '-P 3* 2':'R -3 m:R',
        '-R 3 2"c':'R -3 c:H',
        '-P 3* 2n':'R -3 c:R',
        'P 6':'P 6',
        'P 61':'P 61',
        'P 65':'P 65',
        'P 62':'P 62',
        'P 64':'P 64',
        'P 6c':'P 63',
        'P -6':'P -6',
        '-P 6':'P 6/m',
        '-P 6c':'P 63/m',
        'P 6 2':'P 6 2 2',
        'P 61 2 (0 0 -1)':'P 61 2 2',
        'P 65 2 (0 0 1)':'P 65 2 2',
        'P 62 2c (0 0 1)':'P 62 2 2',
        'P 64 2c (0 0 -1)':'P 64 2 2',
        'P 6c 2c':'P 63 2 2',
        'P 6 -2':'P 6 m m',
        'P 6 -2c':'P 6 c c',
        'P 6c -2':'P 63 c m',
        'P 6c -2c':'P 63 m c',
        'P -6 2':'P -6 m 2',
        'P -6c 2':'P -6 c 2',
        'P -6 -2':'P -6 2 m',
        'P -6c -2c':'P -6 2 c',
        '-P 6 2':'P 6/m m m',
        '-P 6 2c':'P 6/m c c',
        '-P 6c 2':'P 63/m c m',
        '-P 6c 2c':'P 63/m m c',
        'P 2 2 3':'P 2 3',
        'F 2 2 3':'F 2 3',
        'I 2 2 3':'I 2 3',
        'P 2ac 2ab 3':'P 21 3',
        'I 2b 2c 3':'I 21 3',
        '-P 2 2 3':'P m -3',
        'P 2 2 3 -1n':'P n -3:1',
        '-P 2ab 2bc 3':'P n -3:2',
        '-F 2 2 3':'F m -3',
        'F 2 2 3 -1d':'F d -3:1',
        '-F 2uv 2vw 3':'F d -3:2',
        '-I 2 2 3':'I m -3',
        '-P 2ac 2ab 3':'P a -3',
        '-I 2b 2c 3':'I a -3',
        'P 4 2 3':'P 4 3 2',
        'P 4n 2 3':'P 42 3 2',
        'F 4 2 3':'F 4 3 2',
        'F 4d 2 3':'F 41 3 2',
        'I 4 2 3':'I 4 3 2',
        'P 4acd 2ab 3':'P 43 3 2',
        'P 4bd 2ab 3':'P 41 3 2',
        'I 4bd 2c 3':'I 41 3 2',
        'P -4 2 3':'P -4 3 m',
        'F -4 2 3':'F -4 3 m',
        'I -4 2 3':'I -4 3 m',
        'P -4n 2 3':'P -4 3 n',
        'F -4c 2 3':'F -4 3 c',
        'I -4bd 2c 3':'I -4 3 d',
        '-P 4 2 3':'P m -3 m',
        'P 4 2 3 -1n':'P n -3 n:1',
        '-P 4a 2bc 3':'P n -3 n:2',
        '-P 4n 2 3':'P m -3 n',
        'P 4n 2 3 -1n':'P n -3 m:1',
        '-P 4bc 2bc 3':'P n -3 m:2',
        '-F 4 2 3':'F m -3 m',
        '-F 4c 2 3':'F m -3 c',
        'F 4d 2 3 -1d':'F d -3 m:1',
        '-F 4vw 2vw 3':'F d -3 m:2',
        'F 4d 2 3 -1cd':'F d -3 c:1',
        '-F 4cvw 2vw 3':'F d -3 c:2',
        '-I 4 2 3':'I m -3 m',
        '-I 4bd 2c 3':'I a -3 d'}
