# -*- coding: utf-8 -*-
#!/usr/bin/env python3

spacegroups={'1':['x,y,z'],
            '2':['x,y,z',
                '-x,-y,-z'],
            '3':['x,y,z',
                '-x,y,-z'],
            '4':['x,y,z',
                '-x,y+0.5,-z'],
            '5':['x,y,z',
                '-x,y,-z',
                'x+0.5,y+0.5,z',
                '-x+0.5,y+0.5,-z'],
            '6':['x,y,z',
                'x,-y,z'],
            '7':['x,y,z',
                'x,-y,z+0.5'],
            '8':['x,y,z',
                'x,-y,z',
                'x+0.5,y+0.5,z',
                'x+0.5,-y+0.5,z'],
            '9':['x,y,z',
                'x,-y,z',
                'x+0.5,y+0.5,z',
                'x+0.5,-y+0.5,z'],
            '10':['x,y,z',
                '-x,y,-z',
                '-x,-y,-z',
                'x,-y,z'],
            '11':['x,y,z',
                '-x,y+0.5,-z',
                '-x,-y,-z',
                'x,-y+0.5,z'],
            '12':['x,y,z',
                '-x,y,-z',
                '-x,-y,-z',
                'x,-y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,-y+0.5,z'],
            '13':['x,y,z',
                '-x,y,-z+0.5',
                '-x,-y,-z',
                'x,-y,z+0.5'],
            '14':['x,y,z',
                '-x,y+0.5,-z+0.5',
                '-x,-y,-z',
                'x,-y+0.5,z+0.5'],
            '15':['x,y,z',
                '-x,y,-z+0.5',
                '-x,-y,-z',
                'x,-y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,-y+0.5,z+0.5'],
            '16':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z'],
            '17':['x,y,z',
                '-x,-y,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z'],
            '18':['x,y,z',
                '-x,-y,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z'],
            '19':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z'],
            '20':['x,y,z',
                '-x,-y,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z'],
            '21':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z'],
            '22':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z'],
            '23':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5'],
            '24':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5'],
            '25':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z'],
            '26':['x,y,z',
                '-x,-y,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z'],
            '27':['x,y,z',
                '-x,-y,z',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            '28':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y,z',
                '-x+0.5,y,z'],
            '29':['x,y,z',
                '-x,-y,z+0.5',
                'x+0.5,-y,z',
                '-x+0.5,y,z+0.5'],
            '30':['x,y,z',
                '-x,-y,z',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            '31':['x,y,z',
                '-x+0.5,-y,z+0.5',
                'x+0.5,-y,z+0.5',
                '-x,y,z'],
            '32':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            '33':['x,y,z',
                '-x,-y,z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z+0.5'],
            '34':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            '35':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            '36':['x,y,z',
                '-x,-y,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z'],
            '37':['x,y,z',
                '-x,-y,z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            '38':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            '39':['x,y,z',
                '-x,-y,z',
                'x,-y+0.5,z',
                '-x,y+0.5,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            '40':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y,z',
                '-x+0.5,y,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            '41':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5'],
            '42':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            '43':['x,y,z',
                '-x,-y,z',
                'x+0.25,-y+0.25,z+0.25',
                '-x+0.25,y+0.25,z+0.25',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x+0.25,-y+0.75,z+0.75',
                '-x+0.25,y+0.75,z+0.75',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                'x+0.75,-y+0.25,z+0.75',
                '-x+0.75,y+0.25,z+0.75',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                'x+0.75,-y+0.75,z+0.25',
                '-x+0.75,y+0.75,z+0.25'],
            '44':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            '45':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            '46':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y,z',
                '-x+0.5,y,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            '47':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z'],
            '48':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5'],
            '49':['x,y,z',
                '-x,-y,z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            '50':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z',
                '-x,y+0.5,z'],
            '51':['x,y,z',
                '-x+0.5,-y,z',
                '-x,y,-z',
                'x+0.5,-y,-z',
                '-x,-y,-z',
                'x+0.5,y,-z',
                'x,-y,z',
                '-x+0.5,y,z'],
            '52':['x,y,z',
                '-x+0.5,-y,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            '53':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x,-y,-z',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x,y,z'],
            '54':['x,y,z',
                '-x+0.5,-y,z',
                '-x,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z',
                'x,-y,z+0.5',
                '-x+0.5,y,z+0.5'],
            '55':['x,y,z',
                '-x,-y,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            '56':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y,z+0.5'],
            '57':['x,y,z',
                '-x,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z',
                '-x,-y,-z',
                'x,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z'],
            '58':['x,y,z',
                '-x,-y,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            '59':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x,y+0.5,-z',
                'x+0.5,-y,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x,-y+0.5,z',
                '-x+0.5,y,z'],
            '60':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-x,y,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z+0.5',
                'x,-y,z+0.5',
                '-x+0.5,y+0.5,z'],
            '61':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z'],
            '62':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z',
                'x+0.5,-y+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z',
                '-x+0.5,y+0.5,z+0.5'],
            '63':['x,y,z',
                '-x,-y,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z+0.5',
                'x,-y,z+0.5',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z'],
            '64':['x,y,z',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y+0.5,z'],
            '65':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            '66':['x,y,z',
                '-x,-y,z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            '67':['x,y,z',
                '-x,-y+0.5,z',
                '-x,y+0.5,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y+0.5,-z',
                'x,-y+0.5,z',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y,z',
                '-x+0.5,y,-z',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y,-z',
                'x+0.5,-y,z',
                '-x+0.5,y+0.5,z'],
            '68':['x,y,z',
                '-x+0.5,-y,z',
                '-x,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z',
                'x,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x,-y+0.5,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z',
                'x,y+0.5,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            '69':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                '-x,-y+0.5,-z+0.5',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            '70':['x,y,z',
                '-x+0.75,-y+0.75,z',
                '-x+0.75,y,-z+0.75',
                'x,-y+0.75,-z+0.75',
                '-x,-y,-z',
                'x+0.25,y+0.25,-z',
                'x+0.25,-y,z+0.25',
                '-x,y+0.25,z+0.25',
                'x,y+0.5,z+0.5',
                '-x+0.75,-y+0.25,z+0.5',
                '-x+0.75,y+0.5,-z+0.25',
                'x,-y+0.25,-z+0.25',
                '-x,-y+0.5,-z+0.5',
                'x+0.25,y+0.75,-z+0.5',
                'x+0.25,-y+0.5,z+0.75',
                '-x,y+0.75,z+0.75',
                'x+0.5,y,z+0.5',
                '-x+0.25,-y+0.75,z+0.5',
                '-x+0.25,y,-z+0.25',
                'x+0.5,-y+0.75,-z+0.25',
                '-x+0.5,-y,-z+0.5',
                'x+0.75,y+0.25,-z+0.5',
                'x+0.75,-y,z+0.75',
                '-x+0.5,y+0.25,z+0.75',
                'x+0.5,y+0.5,z',
                '-x+0.25,-y+0.25,z',
                '-x+0.25,y+0.5,-z+0.75',
                'x+0.5,-y+0.25,-z+0.75',
                '-x+0.5,-y+0.5,-z',
                'x+0.75,y+0.75,-z',
                'x+0.75,-y+0.5,z+0.25',
                '-x+0.5,y+0.75,z+0.25'],
            '71':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            '72':['x,y,z',
                '-x,-y,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            '73':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'x+0.5,-y,z',
                '-x,y,z+0.5'],
            '74':['x,y,z',
                '-x,-y+0.5,z',
                '-x,y+0.5,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y+0.5,-z',
                'x,-y+0.5,z',
                '-x,y,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            '75':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z'],
            '76':['x,y,z',
                '-x,-y,z+0.5',
                '-y,x,z+0.25',
                'y,-x,z+0.75'],
            '77':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5'],
            '78':['x,y,z',
                '-x,-y,z+0.5',
                '-y,x,z+0.75',
                'y,-x,z+0.25'],
            '79':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5'],
            '80':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-y,x+0.5,z+0.25',
                'y+0.5,-x,z+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y,z',
                '-y+0.5,x,z+0.75',
                'y,-x+0.5,z+0.25'],
            '81':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z'],
            '82':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5'],
            '83':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z'],
            '84':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5'],
            '85':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z'],
            '86':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y,x+0.5,z+0.5',
                'y+0.5,-x,z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y,-x+0.5,-z+0.5',
                '-y+0.5,x,-z+0.5'],
            '87':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5'],
            '88':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-y+0.75,x+0.25,z+0.25',
                'y+0.75,-x+0.75,z+0.75',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'y+0.25,-x+0.75,-z+0.75',
                '-y+0.25,x+0.25,-z+0.25',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-y+0.25,x+0.75,z+0.75',
                'y+0.25,-x+0.25,z+0.25',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'y+0.75,-x+0.25,-z+0.25',
                '-y+0.75,x+0.75,-z+0.75'],
            '89':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z',
                '-y,-x,-z'],
            '90':['x,y,z',
                '-x,-y,z',
                '-y+0.5,x+0.5,z',
                'y+0.5,-x+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'y,x,-z',
                '-y,-x,-z'],
            '91':['x,y,z',
                '-x,-y,z+0.5',
                '-y,x,z+0.25',
                'y,-x,z+0.75',
                '-x,y,-z',
                'x,-y,-z+0.5',
                'y,x,-z+0.75',
                '-y,-x,-z+0.25'],
            '92':['x,y,z',
                '-x,-y,z+0.5',
                '-y+0.5,x+0.5,z+0.25',
                'y+0.5,-x+0.5,z+0.75',
                '-x+0.5,y+0.5,-z+0.25',
                'x+0.5,-y+0.5,-z+0.75',
                'y,x,-z',
                '-y,-x,-z+0.5'],
            '93':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5'],
            '94':['x,y,z',
                '-x,-y,z',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y,x,-z',
                '-y,-x,-z'],
            '95':['x,y,z',
                '-x,-y,z+0.5',
                '-y,x,z+0.75',
                'y,-x,z+0.25',
                '-x,y,-z',
                'x,-y,-z+0.5',
                'y,x,-z+0.25',
                '-y,-x,-z+0.75'],
            '96':['x,y,z',
                '-x,-y,z+0.5',
                '-y+0.5,x+0.5,z+0.75',
                'y+0.5,-x+0.5,z+0.25',
                '-x+0.5,y+0.5,-z+0.75',
                'x+0.5,-y+0.5,-z+0.25',
                'y,x,-z',
                '-y,-x,-z+0.5'],
            '97':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z',
                '-y,-x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5'],
            '98':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-y,x+0.5,z+0.25',
                'y+0.5,-x,z+0.75',
                '-x+0.5,y,-z+0.75',
                'x,-y+0.5,-z+0.25',
                'y+0.5,x+0.5,-z+0.5',
                '-y,-x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y,z',
                '-y+0.5,x,z+0.75',
                'y,-x+0.5,z+0.25',
                '-x,y+0.5,-z+0.25',
                'x+0.5,-y,-z+0.75',
                'y,x,-z',
                '-y+0.5,-x+0.5,-z+0.5'],
            '99':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z',
                'y,x,z'],
            '100':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            '101':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z',
                'y,x,z'],
            '102':['x,y,z',
                '-x,-y,z',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y,-x,z',
                'y,x,z'],
            '103':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            '104':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '105':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            '106':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '107':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z',
                'y,x,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '108':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            '109':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-y,x+0.5,z+0.25',
                'y+0.5,-x,z+0.75',
                'x,-y,z',
                '-x+0.5,y+0.5,z+0.5',
                '-y,-x+0.5,z+0.25',
                'y+0.5,x,z+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y,z',
                '-y+0.5,x,z+0.75',
                'y,-x+0.5,z+0.25',
                'x+0.5,-y+0.5,z+0.5',
                '-x,y,z',
                '-y+0.5,-x,z+0.75',
                'y,x+0.5,z+0.25'],
            '110':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-y,x+0.5,z+0.25',
                'y+0.5,-x,z+0.75',
                'x,-y,z+0.5',
                '-x+0.5,y+0.5,z',
                '-y,-x+0.5,z+0.75',
                'y+0.5,x,z+0.25',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y,z',
                '-y+0.5,x,z+0.75',
                'y,-x+0.5,z+0.25',
                'x+0.5,-y+0.5,z',
                '-x,y,z+0.5',
                '-y+0.5,-x,z+0.25',
                'y,x+0.5,z+0.75'],
            '111':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x,y,-z',
                'x,-y,-z',
                '-y,-x,z',
                'y,x,z'],
            '112':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            '113':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            '114':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '115':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z',
                '-x,y,z',
                'y,x,-z',
                '-y,-x,-z'],
            '116':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5'],
            '117':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z'],
            '118':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5'],
            '119':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z',
                '-x,y,z',
                'y,x,-z',
                '-y,-x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5'],
            '120':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z'],
            '121':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x,y,-z',
                'x,-y,-z',
                '-y,-x,z',
                'y,x,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '122':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x+0.5,y,-z+0.75',
                'x+0.5,-y,-z+0.75',
                '-y+0.5,-x,z+0.75',
                'y+0.5,x,z+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                '-x,y+0.5,-z+0.25',
                'x,-y+0.5,-z+0.25',
                '-y,-x+0.5,z+0.25',
                'y,x+0.5,z+0.25'],
            '123':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z',
                'y,x,z'],
            '124':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            '125':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x+0.5,y,-z',
                'x,-y+0.5,-z',
                'y,x,-z',
                '-y+0.5,-x+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z',
                'x+0.5,-y,z',
                '-x,y+0.5,z',
                '-y,-x,z',
                'y+0.5,x+0.5,z'],
            '126':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'y,x,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-y,-x,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '127':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            '128':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '129':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x,y+0.5,-z',
                'x+0.5,-y,-z',
                'y+0.5,x+0.5,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z',
                'x,-y+0.5,z',
                '-x+0.5,y,z',
                '-y+0.5,-x+0.5,z',
                'y,x,z'],
            '130':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y,x,z+0.5'],
            '131':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            '132':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                'y,x,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z',
                'y,x,z'],
            '133':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z+0.5',
                'y,-x+0.5,z+0.5',
                '-x+0.5,y,-z',
                'x,-y+0.5,-z',
                'y,x,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x+0.5,-y,z',
                '-x,y+0.5,z',
                '-y,-x,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '134':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z+0.5',
                'y,-x+0.5,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'y,x,-z',
                '-y+0.5,-x+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-y,-x,z',
                'y+0.5,x+0.5,z'],
            '135':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '136':['x,y,z',
                '-x,-y,z',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y,x,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y,-x,z',
                'y,x,z'],
            '137':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z+0.5',
                'y,-x+0.5,z+0.5',
                '-x,y+0.5,-z',
                'x+0.5,-y,-z',
                'y+0.5,x+0.5,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x,-y+0.5,z',
                '-x+0.5,y,z',
                '-y+0.5,-x+0.5,z+0.5',
                'y,x,z+0.5'],
            '138':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z+0.5',
                'y,-x+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'y+0.5,x+0.5,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y,z+0.5',
                '-y+0.5,-x+0.5,z',
                'y,x,z'],
            '139':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z',
                'y,x,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            '140':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            '141':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-y+0.25,x+0.75,z+0.25',
                'y+0.25,-x+0.25,z+0.75',
                '-x+0.5,y,-z+0.5',
                'x,-y,-z',
                'y+0.25,x+0.75,-z+0.25',
                '-y+0.25,-x+0.25,-z+0.75',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'y+0.75,-x+0.25,-z+0.75',
                '-y+0.75,x+0.75,-z+0.25',
                'x+0.5,-y,z+0.5',
                '-x,y,z',
                '-y+0.75,-x+0.25,z+0.75',
                'y+0.75,x+0.75,z+0.25',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-y+0.75,x+0.25,z+0.75',
                'y+0.75,-x+0.75,z+0.25',
                '-x,y+0.5,-z',
                'x+0.5,-y+0.5,-z+0.5',
                'y+0.75,x+0.25,-z+0.75',
                '-y+0.75,-x+0.75,-z+0.25',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'y+0.25,-x+0.75,-z+0.25',
                '-y+0.25,x+0.25,-z+0.75',
                'x,-y+0.5,z',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.25,-x+0.75,z+0.25',
                'y+0.25,x+0.25,z+0.75'],
            '142':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-y+0.25,x+0.75,z+0.25',
                'y+0.25,-x+0.25,z+0.75',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'y+0.75,-x+0.25,-z+0.75',
                '-y+0.75,x+0.75,-z+0.25',
                'x+0.5,-y,z',
                '-x,y,z+0.5',
                '-y+0.75,-x+0.25,z+0.25',
                'y+0.75,x+0.75,z+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-y+0.75,x+0.25,z+0.75',
                'y+0.75,-x+0.75,z+0.25',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'y+0.75,x+0.25,-z+0.25',
                '-y+0.75,-x+0.75,-z+0.75',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'y+0.25,-x+0.75,-z+0.25',
                '-y+0.25,x+0.25,-z+0.75',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                '-y+0.25,-x+0.75,z+0.75',
                'y+0.25,x+0.25,z+0.25'],
            '143':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z'],
            '144':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.'],
            '145':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.'],
            '146':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.'],
            '147':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z'],
            '148':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                '-x+2./3.,-y+1./3.,-z+1./3.',
                'y+2./3.,-x+y+1./3.,-z+1./3.',
                'x-y+2./3.,x+1./3.,-z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                '-x+1./3.,-y+2./3.,-z+2./3.',
                'y+1./3.,-x+y+2./3.,-z+2./3.',
                'x-y+1./3.,x+2./3.,-z+2./3.'],
            '149':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z'],
            '150':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z'],
            '151':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-y,-x,-z+2./3.',
                '-x+y,y,-z+1./3.',
                'x,x-y,-z'],
            '152':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                'y,x,-z',
                'x-y,-y,-z+2./3.',
                '-x,-x+y,-z+1./3.'],
            '153':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-y,-x,-z+1./3.',
                '-x+y,y,-z+2./3.',
                'x,x-y,-z'],
            '154':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                'y,x,-z',
                'x-y,-y,-z+1./3.',
                '-x,-x+y,-z+2./3.'],
            '155':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                'y+2./3.,x+1./3.,-z+1./3.',
                'x-y+2./3.,-y+1./3.,-z+1./3.',
                '-x+2./3.,-x+y+1./3.,-z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                'y+1./3.,x+2./3.,-z+2./3.',
                'x-y+1./3.,-y+2./3.,-z+2./3.',
                '-x+1./3.,-x+y+2./3.,-z+2./3.'],
            '156':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z'],
            '157':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            '158':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5'],
            '159':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            '160':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                '-y+2./3.,-x+1./3.,z+1./3.',
                '-x+y+2./3.,y+1./3.,z+1./3.',
                'x+2./3.,x-y+1./3.,z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                '-y+1./3.,-x+2./3.,z+2./3.',
                '-x+y+1./3.,y+2./3.,z+2./3.',
                'x+1./3.,x-y+2./3.,z+2./3.'],
            '161':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                '-y+2./3.,-x+1./3.,z+5./6.',
                '-x+y+2./3.,y+1./3.,z+5./6.',
                'x+2./3.,x-y+1./3.,z+5./6.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                '-y+1./3.,-x+2./3.,z+1./6.',
                '-x+y+1./3.,y+2./3.,z+1./6.',
                'x+1./3.,x-y+2./3.,z+1./6.'],
            '162':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            '163':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,-z+0.5',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            '164':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z'],
            '165':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z+0.5',
                'x-y,-y,-z+0.5',
                '-x,-x+y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5'],
            '166':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                'y+2./3.,x+1./3.,-z+1./3.',
                'x-y+2./3.,-y+1./3.,-z+1./3.',
                '-x+2./3.,-x+y+1./3.,-z+1./3.',
                '-x+2./3.,-y+1./3.,-z+1./3.',
                'y+2./3.,-x+y+1./3.,-z+1./3.',
                'x-y+2./3.,x+1./3.,-z+1./3.',
                '-y+2./3.,-x+1./3.,z+1./3.',
                '-x+y+2./3.,y+1./3.,z+1./3.',
                'x+2./3.,x-y+1./3.,z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                'y+1./3.,x+2./3.,-z+2./3.',
                'x-y+1./3.,-y+2./3.,-z+2./3.',
                '-x+1./3.,-x+y+2./3.,-z+2./3.',
                '-x+1./3.,-y+2./3.,-z+2./3.',
                'y+1./3.,-x+y+2./3.,-z+2./3.',
                'x-y+1./3.,x+2./3.,-z+2./3.',
                '-y+1./3.,-x+2./3.,z+2./3.',
                '-x+y+1./3.,y+2./3.,z+2./3.',
                'x+1./3.,x-y+2./3.,z+2./3.'],
            '167':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z+0.5',
                'x-y,-y,-z+0.5',
                '-x,-x+y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                'y+2./3.,x+1./3.,-z+5./6.',
                'x-y+2./3.,-y+1./3.,-z+5./6.',
                '-x+2./3.,-x+y+1./3.,-z+5./6.',
                '-x+2./3.,-y+1./3.,-z+1./3.',
                'y+2./3.,-x+y+1./3.,-z+1./3.',
                'x-y+2./3.,x+1./3.,-z+1./3.',
                '-y+2./3.,-x+1./3.,z+5./6.',
                '-x+y+2./3.,y+1./3.,z+5./6.',
                'x+2./3.,x-y+1./3.,z+5./6.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                'y+1./3.,x+2./3.,-z+1./6.',
                'x-y+1./3.,-y+2./3.,-z+1./6.',
                '-x+1./3.,-x+y+2./3.,-z+1./6.',
                '-x+1./3.,-y+2./3.,-z+2./3.',
                'y+1./3.,-x+y+2./3.,-z+2./3.',
                'x-y+1./3.,x+2./3.,-z+2./3.',
                '-y+1./3.,-x+2./3.,z+1./6.',
                '-x+y+1./3.,y+2./3.,z+1./6.',
                'x+1./3.,x-y+2./3.,z+1./6.'],
            '168':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z'],
            '169':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-x,-y,z+0.5',
                'y,-x+y,z+5./6.',
                'x-y,x,z+1./6.'],
            '170':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-x,-y,z+0.5',
                'y,-x+y,z+1./6.',
                'x-y,x,z+5./6.'],
            '171':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-x,-y,z',
                'y,-x+y,z+2./3.',
                'x-y,x,z+1./3.'],
            '172':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-x,-y,z',
                'y,-x+y,z+1./3.',
                'x-y,x,z+2./3.'],
            '173':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5'],
            '174':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z'],
            '175':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z'],
            '176':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5'],
            '177':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z'],
            '178':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-x,-y,z+0.5',
                'y,-x+y,z+5./6.',
                'x-y,x,z+1./6.',
                'y,x,-z+1./3.',
                'x-y,-y,-z',
                '-x,-x+y,-z+2./3.',
                '-y,-x,-z+5./6.',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+1./6.'],
            '179':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-x,-y,z+0.5',
                'y,-x+y,z+1./6.',
                'x-y,x,z+5./6.',
                'y,x,-z+2./3.',
                'x-y,-y,-z',
                '-x,-x+y,-z+1./3.',
                '-y,-x,-z+1./6.',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+5./6.'],
            '180':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-x,-y,z',
                'y,-x+y,z+2./3.',
                'x-y,x,z+1./3.',
                'y,x,-z+2./3.',
                'x-y,-y,-z',
                '-x,-x+y,-z+1./3.',
                '-y,-x,-z+2./3.',
                '-x+y,y,-z',
                'x,x-y,-z+1./3.'],
            '181':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-x,-y,z',
                'y,-x+y,z+1./3.',
                'x-y,x,z+2./3.',
                'y,x,-z+1./3.',
                'x-y,-y,-z',
                '-x,-x+y,-z+2./3.',
                '-y,-x,-z+1./3.',
                '-x+y,y,-z',
                'x,x-y,-z+2./3.'],
            '182':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-y,-x,-z+0.5',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+0.5'],
            '183':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            '184':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            '185':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            '186':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            '187':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z'],
            '188':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z'],
            '189':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            '190':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            '191':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            '192':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                'y,x,-z+0.5',
                'x-y,-y,-z+0.5',
                '-x,-x+y,-z+0.5',
                '-y,-x,-z+0.5',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            '193':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                'y,x,-z+0.5',
                'x-y,-y,-z+0.5',
                '-x,-x+y,-z+0.5',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            '194':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-y,-x,-z+0.5',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            '195':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x'],
            '196':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x'],
            '197':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5'],
            '198':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5'],
            '199':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x'],
            '200':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x'],
            '201':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x,y',
                'z,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x,-y+0.5',
                'y,z,x',
                '-y+0.5,z,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x,-y',
                '-z,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x,y+0.5',
                '-y,-z,-x',
                'y+0.5,-z,x+0.5',
                '-y,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x'],
            '202':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                '-x,-y+0.5,-z+0.5',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x+0.5,-y+0.5',
                '-z,x+0.5,y+0.5',
                'z,x+0.5,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z+0.5,-x+0.5',
                'y,-z+0.5,x+0.5',
                '-y,z+0.5,x+0.5',
                'y,z+0.5,-x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                '-z+0.5,-x,-y+0.5',
                '-z+0.5,x,y+0.5',
                'z+0.5,x,-y+0.5',
                'z+0.5,-x,y+0.5',
                '-y+0.5,-z,-x+0.5',
                'y+0.5,-z,x+0.5',
                '-y+0.5,z,x+0.5',
                'y+0.5,z,-x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-z+0.5,-x+0.5,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x+0.5,y',
                '-y+0.5,-z+0.5,-x',
                'y+0.5,-z+0.5,x',
                '-y+0.5,z+0.5,x',
                'y+0.5,z+0.5,-x'],
            '203':['x,y,z',
                '-x+0.75,-y+0.75,z',
                '-x+0.75,y,-z+0.75',
                'x,-y+0.75,-z+0.75',
                'z,x,y',
                'z,-x+0.75,-y+0.75',
                '-z+0.75,-x+0.75,y',
                '-z+0.75,x,-y+0.75',
                'y,z,x',
                '-y+0.75,z,-x+0.75',
                'y,-z+0.75,-x+0.75',
                '-y+0.75,-z+0.75,x',
                '-x,-y,-z',
                'x+0.25,y+0.25,-z',
                'x+0.25,-y,z+0.25',
                '-x,y+0.25,z+0.25',
                '-z,-x,-y',
                '-z,x+0.25,y+0.25',
                'z+0.25,x+0.25,-y',
                'z+0.25,-x,y+0.25',
                '-y,-z,-x',
                'y+0.25,-z,x+0.25',
                '-y,z+0.25,x+0.25',
                'y+0.25,z+0.25,-x',
                'x,y+0.5,z+0.5',
                '-x+0.75,-y+0.25,z+0.5',
                '-x+0.75,y+0.5,-z+0.25',
                'x,-y+0.25,-z+0.25',
                'z,x+0.5,y+0.5',
                'z,-x+0.25,-y+0.25',
                '-z+0.75,-x+0.25,y+0.5',
                '-z+0.75,x+0.5,-y+0.25',
                'y,z+0.5,x+0.5',
                '-y+0.75,z+0.5,-x+0.25',
                'y,-z+0.25,-x+0.25',
                '-y+0.75,-z+0.25,x+0.5',
                '-x,-y+0.5,-z+0.5',
                'x+0.25,y+0.75,-z+0.5',
                'x+0.25,-y+0.5,z+0.75',
                '-x,y+0.75,z+0.75',
                '-z,-x+0.5,-y+0.5',
                '-z,x+0.75,y+0.75',
                'z+0.25,x+0.75,-y+0.5',
                'z+0.25,-x+0.5,y+0.75',
                '-y,-z+0.5,-x+0.5',
                'y+0.25,-z+0.5,x+0.75',
                '-y,z+0.75,x+0.75',
                'y+0.25,z+0.75,-x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.25,-y+0.75,z+0.5',
                '-x+0.25,y,-z+0.25',
                'x+0.5,-y+0.75,-z+0.25',
                'z+0.5,x,y+0.5',
                'z+0.5,-x+0.75,-y+0.25',
                '-z+0.25,-x+0.75,y+0.5',
                '-z+0.25,x,-y+0.25',
                'y+0.5,z,x+0.5',
                '-y+0.25,z,-x+0.25',
                'y+0.5,-z+0.75,-x+0.25',
                '-y+0.25,-z+0.75,x+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.75,y+0.25,-z+0.5',
                'x+0.75,-y,z+0.75',
                '-x+0.5,y+0.25,z+0.75',
                '-z+0.5,-x,-y+0.5',
                '-z+0.5,x+0.25,y+0.75',
                'z+0.75,x+0.25,-y+0.5',
                'z+0.75,-x,y+0.75',
                '-y+0.5,-z,-x+0.5',
                'y+0.75,-z,x+0.75',
                '-y+0.5,z+0.25,x+0.75',
                'y+0.75,z+0.25,-x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.25,-y+0.25,z',
                '-x+0.25,y+0.5,-z+0.75',
                'x+0.5,-y+0.25,-z+0.75',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.25,-y+0.75',
                '-z+0.25,-x+0.25,y',
                '-z+0.25,x+0.5,-y+0.75',
                'y+0.5,z+0.5,x',
                '-y+0.25,z+0.5,-x+0.75',
                'y+0.5,-z+0.25,-x+0.75',
                '-y+0.25,-z+0.25,x',
                '-x+0.5,-y+0.5,-z',
                'x+0.75,y+0.75,-z',
                'x+0.75,-y+0.5,z+0.25',
                '-x+0.5,y+0.75,z+0.25',
                '-z+0.5,-x+0.5,-y',
                '-z+0.5,x+0.75,y+0.25',
                'z+0.75,x+0.75,-y',
                'z+0.75,-x+0.5,y+0.25',
                '-y+0.5,-z+0.5,-x',
                'y+0.75,-z+0.5,x+0.25',
                '-y+0.5,z+0.75,x+0.25',
                'y+0.75,z+0.75,-x'],
            '204':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y+0.5',
                'z+0.5,-x+0.5,y+0.5',
                '-y+0.5,-z+0.5,-x+0.5',
                'y+0.5,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x+0.5'],
            '205':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                '-z,-x,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z,-x',
                'y,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x',
                'y+0.5,z,-x+0.5'],
            '206':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                '-z,-x,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z,-x',
                'y,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x',
                'y+0.5,z,-x+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'x+0.5,-y,z',
                '-x,y,z+0.5',
                '-z+0.5,-x+0.5,-y+0.5',
                '-z,x,y+0.5',
                'z,x+0.5,-y',
                'z+0.5,-x,y',
                '-y+0.5,-z+0.5,-x+0.5',
                'y+0.5,-z,x',
                '-y,z,x+0.5',
                'y,z+0.5,-x'],
            '207':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x'],
            '208':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5'],
            '209':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y,x+0.5,-z+0.5',
                '-y,-x+0.5,-z+0.5',
                'y,-x+0.5,z+0.5',
                '-y,x+0.5,z+0.5',
                'x,z+0.5,-y+0.5',
                '-x,z+0.5,y+0.5',
                '-x,-z+0.5,-y+0.5',
                'x,-z+0.5,y+0.5',
                'z,y+0.5,-x+0.5',
                'z,-y+0.5,x+0.5',
                '-z,y+0.5,x+0.5',
                '-z,-y+0.5,-x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y+0.5,x,-z+0.5',
                '-y+0.5,-x,-z+0.5',
                'y+0.5,-x,z+0.5',
                '-y+0.5,x,z+0.5',
                'x+0.5,z,-y+0.5',
                '-x+0.5,z,y+0.5',
                '-x+0.5,-z,-y+0.5',
                'x+0.5,-z,y+0.5',
                'z+0.5,y,-x+0.5',
                'z+0.5,-y,x+0.5',
                '-z+0.5,y,x+0.5',
                '-z+0.5,-y,-x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z',
                'y+0.5,-x+0.5,z',
                '-y+0.5,x+0.5,z',
                'x+0.5,z+0.5,-y',
                '-x+0.5,z+0.5,y',
                '-x+0.5,-z+0.5,-y',
                'x+0.5,-z+0.5,y',
                'z+0.5,y+0.5,-x',
                'z+0.5,-y+0.5,x',
                '-z+0.5,y+0.5,x',
                '-z+0.5,-y+0.5,-x'],
            '210':['x,y,z',
                '-x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y,-z+0.5',
                'z,x,y',
                'z+0.5,-x,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y',
                'y,z,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y+0.75,x+0.25,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                'y+0.25,-x+0.75,z+0.75',
                '-y+0.75,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.75',
                '-x+0.75,z+0.75,y+0.25',
                '-x+0.25,-z+0.25,-y+0.25',
                'x+0.25,-z+0.75,y+0.75',
                'z+0.75,y+0.25,-x+0.75',
                'z+0.25,-y+0.75,x+0.75',
                '-z+0.75,y+0.75,x+0.25',
                '-z+0.25,-y+0.25,-x+0.25',
                'x,y+0.5,z+0.5',
                '-x,-y,z',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y',
                '-z,-x,y',
                '-z+0.5,x,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y,-z,x',
                'y+0.75,x+0.75,-z+0.25',
                '-y+0.25,-x+0.75,-z+0.75',
                'y+0.25,-x+0.25,z+0.25',
                '-y+0.75,x+0.25,z+0.75',
                'x+0.75,z+0.75,-y+0.25',
                '-x+0.75,z+0.25,y+0.75',
                '-x+0.25,-z+0.75,-y+0.75',
                'x+0.25,-z+0.25,y+0.25',
                'z+0.75,y+0.75,-x+0.25',
                'z+0.25,-y+0.25,x+0.25',
                '-z+0.75,y+0.25,x+0.75',
                '-z+0.25,-y+0.75,-x+0.75',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y+0.5,z',
                '-x,y+0.5,-z+0.5',
                'x,-y,-z',
                'z+0.5,x,y+0.5',
                'z,-x,-y',
                '-z+0.5,-x+0.5,y',
                '-z,x+0.5,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z,-x',
                '-y+0.5,-z+0.5,x',
                'y+0.25,x+0.25,-z+0.25',
                '-y+0.75,-x+0.25,-z+0.75',
                'y+0.75,-x+0.75,z+0.25',
                '-y+0.25,x+0.75,z+0.75',
                'x+0.25,z+0.25,-y+0.25',
                '-x+0.25,z+0.75,y+0.75',
                '-x+0.75,-z+0.25,-y+0.75',
                'x+0.75,-z+0.75,y+0.25',
                'z+0.25,y+0.25,-x+0.25',
                'z+0.75,-y+0.75,x+0.25',
                '-z+0.25,y+0.75,x+0.75',
                '-z+0.75,-y+0.25,-x+0.75',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y,z+0.5',
                '-x,y,-z',
                'x,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y',
                'z,-x+0.5,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z,x,-y',
                'y+0.5,z+0.5,x',
                '-y,z,-x',
                'y,-z+0.5,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.75,-x+0.75,-z+0.25',
                'y+0.75,-x+0.25,z+0.75',
                '-y+0.25,x+0.25,z+0.25',
                'x+0.25,z+0.75,-y+0.75',
                '-x+0.25,z+0.25,y+0.25',
                '-x+0.75,-z+0.75,-y+0.25',
                'x+0.75,-z+0.25,y+0.75',
                'z+0.25,y+0.75,-x+0.75',
                'z+0.75,-y+0.25,x+0.75',
                '-z+0.25,y+0.25,x+0.25',
                '-z+0.75,-y+0.75,-x+0.25'],
            '211':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5'],
            '212':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                'y+0.75,-x+0.75,z+0.25',
                '-y+0.75,x+0.25,z+0.75',
                'x+0.25,z+0.75,-y+0.75',
                '-x+0.75,z+0.25,y+0.75',
                '-x+0.25,-z+0.25,-y+0.25',
                'x+0.75,-z+0.75,y+0.25',
                'z+0.25,y+0.75,-x+0.75',
                'z+0.75,-y+0.75,x+0.25',
                '-z+0.75,y+0.25,x+0.75',
                '-z+0.25,-y+0.25,-x+0.25'],
            '213':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.75,x+0.25,-z+0.25',
                '-y+0.75,-x+0.75,-z+0.75',
                'y+0.25,-x+0.25,z+0.75',
                '-y+0.25,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.25',
                '-x+0.25,z+0.75,y+0.25',
                '-x+0.75,-z+0.75,-y+0.75',
                'x+0.25,-z+0.25,y+0.75',
                'z+0.75,y+0.25,-x+0.25',
                'z+0.25,-y+0.25,x+0.75',
                '-z+0.25,y+0.75,x+0.25',
                '-z+0.75,-y+0.75,-x+0.75'],
            '214':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.75,x+0.25,-z+0.25',
                '-y+0.75,-x+0.75,-z+0.75',
                'y+0.25,-x+0.25,z+0.75',
                '-y+0.25,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.25',
                '-x+0.25,z+0.75,y+0.25',
                '-x+0.75,-z+0.75,-y+0.75',
                'x+0.25,-z+0.25,y+0.75',
                'z+0.75,y+0.25,-x+0.25',
                'z+0.25,-y+0.25,x+0.75',
                '-z+0.25,y+0.75,x+0.25',
                '-z+0.75,-y+0.75,-x+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                'y+0.75,-x+0.75,z+0.25',
                '-y+0.75,x+0.25,z+0.75',
                'x+0.25,z+0.75,-y+0.75',
                '-x+0.75,z+0.25,y+0.75',
                '-x+0.25,-z+0.25,-y+0.25',
                'x+0.75,-z+0.75,y+0.25',
                'z+0.25,y+0.75,-x+0.75',
                'z+0.75,-y+0.75,x+0.25',
                '-z+0.75,y+0.25,x+0.75',
                '-z+0.25,-y+0.25,-x+0.25'],
            '215':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,z',
                '-y,-x,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,z,y',
                '-x,z,-y',
                '-x,-z,y',
                'x,-z,-y',
                'z,y,x',
                'z,-y,-x',
                '-z,y,-x',
                '-z,-y,x'],
            '216':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,z',
                '-y,-x,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,z,y',
                '-x,z,-y',
                '-x,-z,y',
                'x,-z,-y',
                'z,y,x',
                'z,-y,-x',
                '-z,y,-x',
                '-z,-y,x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y,x+0.5,z+0.5',
                '-y,-x+0.5,z+0.5',
                'y,-x+0.5,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x,z+0.5,y+0.5',
                '-x,z+0.5,-y+0.5',
                '-x,-z+0.5,y+0.5',
                'x,-z+0.5,-y+0.5',
                'z,y+0.5,x+0.5',
                'z,-y+0.5,-x+0.5',
                '-z,y+0.5,-x+0.5',
                '-z,-y+0.5,x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y+0.5,x,z+0.5',
                '-y+0.5,-x,z+0.5',
                'y+0.5,-x,-z+0.5',
                '-y+0.5,x,-z+0.5',
                'x+0.5,z,y+0.5',
                '-x+0.5,z,-y+0.5',
                '-x+0.5,-z,y+0.5',
                'x+0.5,-z,-y+0.5',
                'z+0.5,y,x+0.5',
                'z+0.5,-y,-x+0.5',
                '-z+0.5,y,-x+0.5',
                '-z+0.5,-y,x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y+0.5,x+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,-x+0.5,-z',
                '-y+0.5,x+0.5,-z',
                'x+0.5,z+0.5,y',
                '-x+0.5,z+0.5,-y',
                '-x+0.5,-z+0.5,y',
                'x+0.5,-z+0.5,-y',
                'z+0.5,y+0.5,x',
                'z+0.5,-y+0.5,-x',
                '-z+0.5,y+0.5,-x',
                '-z+0.5,-y+0.5,x'],
            '217':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,z',
                '-y,-x,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,z,y',
                '-x,z,-y',
                '-x,-z,y',
                'x,-z,-y',
                'z,y,x',
                'z,-y,-x',
                '-z,y,-x',
                '-z,-y,x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'z+0.5,y+0.5,x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                '-z+0.5,-y+0.5,x+0.5'],
            '218':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'z+0.5,y+0.5,x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                '-z+0.5,-y+0.5,x+0.5'],
            '219':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'z+0.5,y+0.5,x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                '-z+0.5,-y+0.5,x+0.5',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y+0.5,x,z',
                '-y+0.5,-x,z',
                'y+0.5,-x,-z',
                '-y+0.5,x,-z',
                'x+0.5,z,y',
                '-x+0.5,z,-y',
                '-x+0.5,-z,y',
                'x+0.5,-z,-y',
                'z+0.5,y,x',
                'z+0.5,-y,-x',
                '-z+0.5,y,-x',
                '-z+0.5,-y,x',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y,x+0.5,z',
                '-y,-x+0.5,z',
                'y,-x+0.5,-z',
                '-y,x+0.5,-z',
                'x,z+0.5,y',
                '-x,z+0.5,-y',
                '-x,-z+0.5,y',
                'x,-z+0.5,-y',
                'z,y+0.5,x',
                'z,-y+0.5,-x',
                '-z,y+0.5,-x',
                '-z,-y+0.5,x',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y,x,z+0.5',
                '-y,-x,z+0.5',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5',
                'x,z,y+0.5',
                '-x,z,-y+0.5',
                '-x,-z,y+0.5',
                'x,-z,-y+0.5',
                'z,y,x+0.5',
                'z,-y,-x+0.5',
                '-z,y,-x+0.5',
                '-z,-y,x+0.5'],
            '220':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.25,x+0.25,z+0.25',
                '-y+0.25,-x+0.75,z+0.75',
                'y+0.75,-x+0.25,-z+0.75',
                '-y+0.75,x+0.75,-z+0.25',
                'x+0.25,z+0.25,y+0.25',
                '-x+0.75,z+0.75,-y+0.25',
                '-x+0.25,-z+0.75,y+0.75',
                'x+0.75,-z+0.25,-y+0.75',
                'z+0.25,y+0.25,x+0.25',
                'z+0.75,-y+0.25,-x+0.75',
                '-z+0.75,y+0.75,-x+0.25',
                '-z+0.25,-y+0.75,x+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x',
                'y+0.75,x+0.75,z+0.75',
                '-y+0.75,-x+0.25,z+0.25',
                'y+0.25,-x+0.75,-z+0.25',
                '-y+0.25,x+0.25,-z+0.75',
                'x+0.75,z+0.75,y+0.75',
                '-x+0.25,z+0.25,-y+0.75',
                '-x+0.75,-z+0.25,y+0.25',
                'x+0.25,-z+0.75,-y+0.25',
                'z+0.75,y+0.75,x+0.75',
                'z+0.25,-y+0.75,-x+0.25',
                '-z+0.25,y+0.25,-x+0.75',
                '-z+0.75,-y+0.25,x+0.25'],
            '221':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y,-x,z',
                'y,x,z',
                '-y,x,-z',
                'y,-x,-z',
                '-x,-z,y',
                'x,-z,-y',
                'x,z,y',
                '-x,z,-y',
                '-z,-y,x',
                '-z,y,-x',
                'z,-y,-x',
                'z,y,x'],
            '222':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x,y',
                'z,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x,-y+0.5',
                'y,z,x',
                '-y+0.5,z,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x',
                'y,x,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y,-x+0.5,z',
                '-y+0.5,x,z',
                'x,z,-y+0.5',
                '-x+0.5,z,y',
                '-x+0.5,-z+0.5,-y+0.5',
                'x,-z+0.5,y',
                'z,y,-x+0.5',
                'z,-y+0.5,x',
                '-z+0.5,y,x',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x,-y',
                '-z,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x,y+0.5',
                '-y,-z,-x',
                'y+0.5,-z,x+0.5',
                '-y,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x',
                '-y,-x,z+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y,x+0.5,-z',
                'y+0.5,-x,-z',
                '-x,-z,y+0.5',
                'x+0.5,-z,-y',
                'x+0.5,z+0.5,y+0.5',
                '-x,z+0.5,-y',
                '-z,-y,x+0.5',
                '-z,y+0.5,-x',
                'z+0.5,-y,-x',
                'z+0.5,y+0.5,x+0.5'],
            '223':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                'z+0.5,y+0.5,x+0.5'],
            '224':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x,y',
                'z,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x,-y+0.5',
                'y,z,x',
                '-y+0.5,z,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x',
                'y+0.5,x+0.5,-z',
                '-y,-x,-z',
                'y+0.5,-x,z+0.5',
                '-y,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y',
                '-x,z+0.5,y+0.5',
                '-x,-z,-y',
                'x+0.5,-z,y+0.5',
                'z+0.5,y+0.5,-x',
                'z+0.5,-y,x+0.5',
                '-z,y+0.5,x+0.5',
                '-z,-y,-x',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x,-y',
                '-z,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x,y+0.5',
                '-y,-z,-x',
                'y+0.5,-z,x+0.5',
                '-y,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x',
                '-y+0.5,-x+0.5,z',
                'y,x,z',
                '-y+0.5,x,-z+0.5',
                'y,-x+0.5,-z+0.5',
                '-x+0.5,-z+0.5,y',
                'x,-z+0.5,-y+0.5',
                'x,z,y',
                '-x+0.5,z,-y+0.5',
                '-z+0.5,-y+0.5,x',
                '-z+0.5,y,-x+0.5',
                'z,-y+0.5,-x+0.5',
                'z,y,x'],
            '225':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y,-x,z',
                'y,x,z',
                '-y,x,-z',
                'y,-x,-z',
                '-x,-z,y',
                'x,-z,-y',
                'x,z,y',
                '-x,z,-y',
                '-z,-y,x',
                '-z,y,-x',
                'z,-y,-x',
                'z,y,x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y,x+0.5,-z+0.5',
                '-y,-x+0.5,-z+0.5',
                'y,-x+0.5,z+0.5',
                '-y,x+0.5,z+0.5',
                'x,z+0.5,-y+0.5',
                '-x,z+0.5,y+0.5',
                '-x,-z+0.5,-y+0.5',
                'x,-z+0.5,y+0.5',
                'z,y+0.5,-x+0.5',
                'z,-y+0.5,x+0.5',
                '-z,y+0.5,x+0.5',
                '-z,-y+0.5,-x+0.5',
                '-x,-y+0.5,-z+0.5',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x+0.5,-y+0.5',
                '-z,x+0.5,y+0.5',
                'z,x+0.5,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z+0.5,-x+0.5',
                'y,-z+0.5,x+0.5',
                '-y,z+0.5,x+0.5',
                'y,z+0.5,-x+0.5',
                '-y,-x+0.5,z+0.5',
                'y,x+0.5,z+0.5',
                '-y,x+0.5,-z+0.5',
                'y,-x+0.5,-z+0.5',
                '-x,-z+0.5,y+0.5',
                'x,-z+0.5,-y+0.5',
                'x,z+0.5,y+0.5',
                '-x,z+0.5,-y+0.5',
                '-z,-y+0.5,x+0.5',
                '-z,y+0.5,-x+0.5',
                'z,-y+0.5,-x+0.5',
                'z,y+0.5,x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y+0.5,x,-z+0.5',
                '-y+0.5,-x,-z+0.5',
                'y+0.5,-x,z+0.5',
                '-y+0.5,x,z+0.5',
                'x+0.5,z,-y+0.5',
                '-x+0.5,z,y+0.5',
                '-x+0.5,-z,-y+0.5',
                'x+0.5,-z,y+0.5',
                'z+0.5,y,-x+0.5',
                'z+0.5,-y,x+0.5',
                '-z+0.5,y,x+0.5',
                '-z+0.5,-y,-x+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                '-z+0.5,-x,-y+0.5',
                '-z+0.5,x,y+0.5',
                'z+0.5,x,-y+0.5',
                'z+0.5,-x,y+0.5',
                '-y+0.5,-z,-x+0.5',
                'y+0.5,-z,x+0.5',
                '-y+0.5,z,x+0.5',
                'y+0.5,z,-x+0.5',
                '-y+0.5,-x,z+0.5',
                'y+0.5,x,z+0.5',
                '-y+0.5,x,-z+0.5',
                'y+0.5,-x,-z+0.5',
                '-x+0.5,-z,y+0.5',
                'x+0.5,-z,-y+0.5',
                'x+0.5,z,y+0.5',
                '-x+0.5,z,-y+0.5',
                '-z+0.5,-y,x+0.5',
                '-z+0.5,y,-x+0.5',
                'z+0.5,-y,-x+0.5',
                'z+0.5,y,x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z',
                'y+0.5,-x+0.5,z',
                '-y+0.5,x+0.5,z',
                'x+0.5,z+0.5,-y',
                '-x+0.5,z+0.5,y',
                '-x+0.5,-z+0.5,-y',
                'x+0.5,-z+0.5,y',
                'z+0.5,y+0.5,-x',
                'z+0.5,-y+0.5,x',
                '-z+0.5,y+0.5,x',
                '-z+0.5,-y+0.5,-x',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-z+0.5,-x+0.5,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x+0.5,y',
                '-y+0.5,-z+0.5,-x',
                'y+0.5,-z+0.5,x',
                '-y+0.5,z+0.5,x',
                'y+0.5,z+0.5,-x',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z',
                '-y+0.5,x+0.5,-z',
                'y+0.5,-x+0.5,-z',
                '-x+0.5,-z+0.5,y',
                'x+0.5,-z+0.5,-y',
                'x+0.5,z+0.5,y',
                '-x+0.5,z+0.5,-y',
                '-z+0.5,-y+0.5,x',
                '-z+0.5,y+0.5,-x',
                'z+0.5,-y+0.5,-x',
                'z+0.5,y+0.5,x'],
            '226':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                'z+0.5,y+0.5,x+0.5',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y+0.5,x,-z',
                '-y+0.5,-x,-z',
                'y+0.5,-x,z',
                '-y+0.5,x,z',
                'x+0.5,z,-y',
                '-x+0.5,z,y',
                '-x+0.5,-z,-y',
                'x+0.5,-z,y',
                'z+0.5,y,-x',
                'z+0.5,-y,x',
                '-z+0.5,y,x',
                '-z+0.5,-y,-x',
                '-x,-y+0.5,-z+0.5',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x+0.5,-y+0.5',
                '-z,x+0.5,y+0.5',
                'z,x+0.5,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z+0.5,-x+0.5',
                'y,-z+0.5,x+0.5',
                '-y,z+0.5,x+0.5',
                'y,z+0.5,-x+0.5',
                '-y+0.5,-x,z',
                'y+0.5,x,z',
                '-y+0.5,x,-z',
                'y+0.5,-x,-z',
                '-x+0.5,-z,y',
                'x+0.5,-z,-y',
                'x+0.5,z,y',
                '-x+0.5,z,-y',
                '-z+0.5,-y,x',
                '-z+0.5,y,-x',
                'z+0.5,-y,-x',
                'z+0.5,y,x',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y,x+0.5,-z',
                '-y,-x+0.5,-z',
                'y,-x+0.5,z',
                '-y,x+0.5,z',
                'x,z+0.5,-y',
                '-x,z+0.5,y',
                '-x,-z+0.5,-y',
                'x,-z+0.5,y',
                'z,y+0.5,-x',
                'z,-y+0.5,x',
                '-z,y+0.5,x',
                '-z,-y+0.5,-x',
                '-x+0.5,-y,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                '-z+0.5,-x,-y+0.5',
                '-z+0.5,x,y+0.5',
                'z+0.5,x,-y+0.5',
                'z+0.5,-x,y+0.5',
                '-y+0.5,-z,-x+0.5',
                'y+0.5,-z,x+0.5',
                '-y+0.5,z,x+0.5',
                'y+0.5,z,-x+0.5',
                '-y,-x+0.5,z',
                'y,x+0.5,z',
                '-y,x+0.5,-z',
                'y,-x+0.5,-z',
                '-x,-z+0.5,y',
                'x,-z+0.5,-y',
                'x,z+0.5,y',
                '-x,z+0.5,-y',
                '-z,-y+0.5,x',
                '-z,y+0.5,-x',
                'z,-y+0.5,-x',
                'z,y+0.5,x',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                'y,-x,z+0.5',
                '-y,x,z+0.5',
                'x,z,-y+0.5',
                '-x,z,y+0.5',
                '-x,-z,-y+0.5',
                'x,-z,y+0.5',
                'z,y,-x+0.5',
                'z,-y,x+0.5',
                '-z,y,x+0.5',
                '-z,-y,-x+0.5',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-z+0.5,-x+0.5,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x+0.5,y',
                '-y+0.5,-z+0.5,-x',
                'y+0.5,-z+0.5,x',
                '-y+0.5,z+0.5,x',
                'y+0.5,z+0.5,-x',
                '-y,-x,z+0.5',
                'y,x,z+0.5',
                '-y,x,-z+0.5',
                'y,-x,-z+0.5',
                '-x,-z,y+0.5',
                'x,-z,-y+0.5',
                'x,z,y+0.5',
                '-x,z,-y+0.5',
                '-z,-y,x+0.5',
                '-z,y,-x+0.5',
                'z,-y,-x+0.5',
                'z,y,x+0.5'],
            '227':['x,y,z',
                '-x+0.75,-y+0.25,z+0.5',
                '-x+0.25,y+0.5,-z+0.75',
                'x+0.5,-y+0.75,-z+0.25',
                'z,x,y',
                'z+0.5,-x+0.75,-y+0.25',
                '-z+0.75,-x+0.25,y+0.5',
                '-z+0.25,x+0.5,-y+0.75',
                'y,z,x',
                '-y+0.25,z+0.5,-x+0.75',
                'y+0.5,-z+0.75,-x+0.25',
                '-y+0.75,-z+0.25,x+0.5',
                'y+0.75,x+0.25,-z+0.5',
                '-y,-x,-z',
                'y+0.25,-x+0.5,z+0.75',
                '-y+0.5,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.5',
                '-x+0.5,z+0.75,y+0.25',
                '-x,-z,-y',
                'x+0.25,-z+0.5,y+0.75',
                'z+0.75,y+0.25,-x+0.5',
                'z+0.25,-y+0.5,x+0.75',
                '-z+0.5,y+0.75,x+0.25',
                '-z,-y,-x',
                '-x,-y,-z',
                'x+0.25,y+0.75,-z+0.5',
                'x+0.75,-y+0.5,z+0.25',
                '-x+0.5,y+0.25,z+0.75',
                '-z,-x,-y',
                '-z+0.5,x+0.25,y+0.75',
                'z+0.25,x+0.75,-y+0.5',
                'z+0.75,-x+0.5,y+0.25',
                '-y,-z,-x',
                'y+0.75,-z+0.5,x+0.25',
                '-y+0.5,z+0.25,x+0.75',
                'y+0.25,z+0.75,-x+0.5',
                '-y+0.25,-x+0.75,z+0.5',
                'y,x,z',
                '-y+0.75,x+0.5,-z+0.25',
                'y+0.5,-x+0.25,-z+0.75',
                '-x+0.25,-z+0.75,y+0.5',
                'x+0.5,-z+0.25,-y+0.75',
                'x,z,y',
                '-x+0.75,z+0.5,-y+0.25',
                '-z+0.25,-y+0.75,x+0.5',
                '-z+0.75,y+0.5,-x+0.25',
                'z+0.5,-y+0.25,-x+0.75',
                'z,y,x',
                'x,y+0.5,z+0.5',
                '-x+0.75,-y+0.75,z',
                '-x+0.25,y,-z+0.25',
                'x+0.5,-y+0.25,-z+0.75',
                'z,x+0.5,y+0.5',
                'z+0.5,-x+0.25,-y+0.75',
                '-z+0.75,-x+0.75,y',
                '-z+0.25,x,-y+0.25',
                'y,z+0.5,x+0.5',
                '-y+0.25,z,-x+0.25',
                'y+0.5,-z+0.25,-x+0.75',
                '-y+0.75,-z+0.75,x',
                'y+0.75,x+0.75,-z',
                '-y,-x+0.5,-z+0.5',
                'y+0.25,-x,z+0.25',
                '-y+0.5,x+0.25,z+0.75',
                'x+0.75,z+0.75,-y',
                '-x+0.5,z+0.25,y+0.75',
                '-x,-z+0.5,-y+0.5',
                'x+0.25,-z,y+0.25',
                'z+0.75,y+0.75,-x',
                'z+0.25,-y,x+0.25',
                '-z+0.5,y+0.25,x+0.75',
                '-z,-y+0.5,-x+0.5',
                '-x,-y+0.5,-z+0.5',
                'x+0.25,y+0.25,-z',
                'x+0.75,-y,z+0.75',
                '-x+0.5,y+0.75,z+0.25',
                '-z,-x+0.5,-y+0.5',
                '-z+0.5,x+0.75,y+0.25',
                'z+0.25,x+0.25,-y',
                'z+0.75,-x,y+0.75',
                '-y,-z+0.5,-x+0.5',
                'y+0.75,-z,x+0.75',
                '-y+0.5,z+0.75,x+0.25',
                'y+0.25,z+0.25,-x',
                '-y+0.25,-x+0.25,z',
                'y,x+0.5,z+0.5',
                '-y+0.75,x,-z+0.75',
                'y+0.5,-x+0.75,-z+0.25',
                '-x+0.25,-z+0.25,y',
                'x+0.5,-z+0.75,-y+0.25',
                'x,z+0.5,y+0.5',
                '-x+0.75,z,-y+0.75',
                '-z+0.25,-y+0.25,x',
                '-z+0.75,y,-x+0.75',
                'z+0.5,-y+0.75,-x+0.25',
                'z,y+0.5,x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.25,-y+0.25,z',
                '-x+0.75,y+0.5,-z+0.25',
                'x,-y+0.75,-z+0.75',
                'z+0.5,x,y+0.5',
                'z,-x+0.75,-y+0.75',
                '-z+0.25,-x+0.25,y',
                '-z+0.75,x+0.5,-y+0.25',
                'y+0.5,z,x+0.5',
                '-y+0.75,z+0.5,-x+0.25',
                'y,-z+0.75,-x+0.75',
                '-y+0.25,-z+0.25,x',
                'y+0.25,x+0.25,-z',
                '-y+0.5,-x,-z+0.5',
                'y+0.75,-x+0.5,z+0.25',
                '-y,x+0.75,z+0.75',
                'x+0.25,z+0.25,-y',
                '-x,z+0.75,y+0.75',
                '-x+0.5,-z,-y+0.5',
                'x+0.75,-z+0.5,y+0.25',
                'z+0.25,y+0.25,-x',
                'z+0.75,-y+0.5,x+0.25',
                '-z,y+0.75,x+0.75',
                '-z+0.5,-y,-x+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.75,y+0.75,-z',
                'x+0.25,-y+0.5,z+0.75',
                '-x,y+0.25,z+0.25',
                '-z+0.5,-x,-y+0.5',
                '-z,x+0.25,y+0.25',
                'z+0.75,x+0.75,-y',
                'z+0.25,-x+0.5,y+0.75',
                '-y+0.5,-z,-x+0.5',
                'y+0.25,-z+0.5,x+0.75',
                '-y,z+0.25,x+0.25',
                'y+0.75,z+0.75,-x',
                '-y+0.75,-x+0.75,z',
                'y+0.5,x,z+0.5',
                '-y+0.25,x+0.5,-z+0.75',
                'y,-x+0.25,-z+0.25',
                '-x+0.75,-z+0.75,y',
                'x,-z+0.25,-y+0.25',
                'x+0.5,z,y+0.5',
                '-x+0.25,z+0.5,-y+0.75',
                '-z+0.75,-y+0.75,x',
                '-z+0.25,y+0.5,-x+0.75',
                'z,-y+0.25,-x+0.25',
                'z+0.5,y,x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.25,-y+0.75,z+0.5',
                '-x+0.75,y,-z+0.75',
                'x,-y+0.25,-z+0.25',
                'z+0.5,x+0.5,y',
                'z,-x+0.25,-y+0.25',
                '-z+0.25,-x+0.75,y+0.5',
                '-z+0.75,x,-y+0.75',
                'y+0.5,z+0.5,x',
                '-y+0.75,z,-x+0.75',
                'y,-z+0.25,-x+0.25',
                '-y+0.25,-z+0.75,x+0.5',
                'y+0.25,x+0.75,-z+0.5',
                '-y+0.5,-x+0.5,-z',
                'y+0.75,-x,z+0.75',
                '-y,x+0.25,z+0.25',
                'x+0.25,z+0.75,-y+0.5',
                '-x,z+0.25,y+0.25',
                '-x+0.5,-z+0.5,-y',
                'x+0.75,-z,y+0.75',
                'z+0.25,y+0.75,-x+0.5',
                'z+0.75,-y,x+0.75',
                '-z,y+0.25,x+0.25',
                '-z+0.5,-y+0.5,-x',
                '-x+0.5,-y+0.5,-z',
                'x+0.75,y+0.25,-z+0.5',
                'x+0.25,-y,z+0.25',
                '-x,y+0.75,z+0.75',
                '-z+0.5,-x+0.5,-y',
                '-z,x+0.75,y+0.75',
                'z+0.75,x+0.25,-y+0.5',
                'z+0.25,-x,y+0.25',
                '-y+0.5,-z+0.5,-x',
                'y+0.25,-z,x+0.25',
                '-y,z+0.75,x+0.75',
                'y+0.75,z+0.25,-x+0.5',
                '-y+0.75,-x+0.25,z+0.5',
                'y+0.5,x+0.5,z',
                '-y+0.25,x,-z+0.25',
                'y,-x+0.75,-z+0.75',
                '-x+0.75,-z+0.25,y+0.5',
                'x,-z+0.75,-y+0.75',
                'x+0.5,z+0.5,y',
                '-x+0.25,z,-y+0.25',
                '-z+0.75,-y+0.25,x+0.5',
                '-z+0.25,y,-x+0.25',
                'z,-y+0.75,-x+0.75',
                'z+0.5,y+0.5,x'],
            '228':['x,y,z',
                '-x+0.25,-y+0.75,z+0.5',
                '-x+0.75,y+0.5,-z+0.25',
                'x+0.5,-y+0.25,-z+0.75',
                'z,x,y',
                'z+0.5,-x+0.25,-y+0.75',
                '-z+0.25,-x+0.75,y+0.5',
                '-z+0.75,x+0.5,-y+0.25',
                'y,z,x',
                '-y+0.75,z+0.5,-x+0.25',
                'y+0.5,-z+0.25,-x+0.75',
                '-y+0.25,-z+0.75,x+0.5',
                'y+0.75,x+0.25,-z',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.25,-x,z+0.75',
                '-y,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y',
                '-x,z+0.75,y+0.25',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.25,-z,y+0.75',
                'z+0.75,y+0.25,-x',
                'z+0.25,-y,x+0.75',
                '-z,y+0.75,x+0.25',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x,-y,-z',
                'x+0.75,y+0.25,-z+0.5',
                'x+0.25,-y+0.5,z+0.75',
                '-x+0.5,y+0.75,z+0.25',
                '-z,-x,-y',
                '-z+0.5,x+0.75,y+0.25',
                'z+0.75,x+0.25,-y+0.5',
                'z+0.25,-x+0.5,y+0.75',
                '-y,-z,-x',
                'y+0.25,-z+0.5,x+0.75',
                '-y+0.5,z+0.75,x+0.25',
                'y+0.75,z+0.25,-x+0.5',
                '-y+0.25,-x+0.75,z',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.75,x,-z+0.25',
                'y,-x+0.25,-z+0.75',
                '-x+0.25,-z+0.75,y',
                'x,-z+0.25,-y+0.75',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.75,z,-y+0.25',
                '-z+0.25,-y+0.75,x',
                '-z+0.75,y,-x+0.25',
                'z,-y+0.25,-x+0.75',
                'z+0.5,y+0.5,x+0.5',
                'x,y+0.5,z+0.5',
                '-x+0.25,-y+0.25,z',
                '-x+0.75,y,-z+0.75',
                'x+0.5,-y+0.75,-z+0.25',
                'z,x+0.5,y+0.5',
                'z+0.5,-x+0.75,-y+0.25',
                '-z+0.25,-x+0.25,y',
                '-z+0.75,x,-y+0.75',
                'y,z+0.5,x+0.5',
                '-y+0.75,z,-x+0.75',
                'y+0.5,-z+0.75,-x+0.25',
                '-y+0.25,-z+0.25,x',
                'y+0.75,x+0.75,-z+0.5',
                '-y+0.5,-x,-z',
                'y+0.25,-x+0.5,z+0.25',
                '-y,x+0.25,z+0.75',
                'x+0.75,z+0.75,-y+0.5',
                '-x,z+0.25,y+0.75',
                '-x+0.5,-z,-y',
                'x+0.25,-z+0.5,y+0.25',
                'z+0.75,y+0.75,-x+0.5',
                'z+0.25,-y+0.5,x+0.25',
                '-z,y+0.25,x+0.75',
                '-z+0.5,-y,-x',
                '-x,-y+0.5,-z+0.5',
                'x+0.75,y+0.75,-z',
                'x+0.25,-y,z+0.25',
                '-x+0.5,y+0.25,z+0.75',
                '-z,-x+0.5,-y+0.5',
                '-z+0.5,x+0.25,y+0.75',
                'z+0.75,x+0.75,-y',
                'z+0.25,-x,y+0.25',
                '-y,-z+0.5,-x+0.5',
                'y+0.25,-z,x+0.25',
                '-y+0.5,z+0.25,x+0.75',
                'y+0.75,z+0.75,-x',
                '-y+0.25,-x+0.25,z+0.5',
                'y+0.5,x,z',
                '-y+0.75,x+0.5,-z+0.75',
                'y,-x+0.75,-z+0.25',
                '-x+0.25,-z+0.25,y+0.5',
                'x,-z+0.75,-y+0.25',
                'x+0.5,z,y',
                '-x+0.75,z+0.5,-y+0.75',
                '-z+0.25,-y+0.25,x+0.5',
                '-z+0.75,y+0.5,-x+0.75',
                'z,-y+0.75,-x+0.25',
                'z+0.5,y,x',
                'x+0.5,y,z+0.5',
                '-x+0.75,-y+0.75,z',
                '-x+0.25,y+0.5,-z+0.75',
                'x,-y+0.25,-z+0.25',
                'z+0.5,x,y+0.5',
                'z,-x+0.25,-y+0.25',
                '-z+0.75,-x+0.75,y',
                '-z+0.25,x+0.5,-y+0.75',
                'y+0.5,z,x+0.5',
                '-y+0.25,z+0.5,-x+0.75',
                'y,-z+0.25,-x+0.25',
                '-y+0.75,-z+0.75,x',
                'y+0.25,x+0.25,-z+0.5',
                '-y,-x+0.5,-z',
                'y+0.75,-x,z+0.25',
                '-y+0.5,x+0.75,z+0.75',
                'x+0.25,z+0.25,-y+0.5',
                '-x+0.5,z+0.75,y+0.75',
                '-x,-z+0.5,-y',
                'x+0.75,-z,y+0.25',
                'z+0.25,y+0.25,-x+0.5',
                'z+0.75,-y,x+0.25',
                '-z+0.5,y+0.75,x+0.75',
                '-z,-y+0.5,-x',
                '-x+0.5,-y,-z+0.5',
                'x+0.25,y+0.25,-z',
                'x+0.75,-y+0.5,z+0.25',
                '-x,y+0.75,z+0.75',
                '-z+0.5,-x,-y+0.5',
                '-z,x+0.75,y+0.75',
                'z+0.25,x+0.25,-y',
                'z+0.75,-x+0.5,y+0.25',
                '-y+0.5,-z,-x+0.5',
                'y+0.75,-z+0.5,x+0.25',
                '-y,z+0.75,x+0.75',
                'y+0.25,z+0.25,-x',
                '-y+0.75,-x+0.75,z+0.5',
                'y,x+0.5,z',
                '-y+0.25,x,-z+0.75',
                'y+0.5,-x+0.25,-z+0.25',
                '-x+0.75,-z+0.75,y+0.5',
                'x+0.5,-z+0.25,-y+0.25',
                'x,z+0.5,y',
                '-x+0.25,z,-y+0.75',
                '-z+0.75,-y+0.75,x+0.5',
                '-z+0.25,y,-x+0.75',
                'z+0.5,-y+0.25,-x+0.25',
                'z,y+0.5,x',
                'x+0.5,y+0.5,z',
                '-x+0.75,-y+0.25,z+0.5',
                '-x+0.25,y,-z+0.25',
                'x,-y+0.75,-z+0.75',
                'z+0.5,x+0.5,y',
                'z,-x+0.75,-y+0.75',
                '-z+0.75,-x+0.25,y+0.5',
                '-z+0.25,x,-y+0.25',
                'y+0.5,z+0.5,x',
                '-y+0.25,z,-x+0.25',
                'y,-z+0.75,-x+0.75',
                '-y+0.75,-z+0.25,x+0.5',
                'y+0.25,x+0.75,-z',
                '-y,-x,-z+0.5',
                'y+0.75,-x+0.5,z+0.75',
                '-y+0.5,x+0.25,z+0.25',
                'x+0.25,z+0.75,-y',
                '-x+0.5,z+0.25,y+0.25',
                '-x,-z,-y+0.5',
                'x+0.75,-z+0.5,y+0.75',
                'z+0.25,y+0.75,-x',
                'z+0.75,-y+0.5,x+0.75',
                '-z+0.5,y+0.25,x+0.25',
                '-z,-y,-x+0.5',
                '-x+0.5,-y+0.5,-z',
                'x+0.25,y+0.75,-z+0.5',
                'x+0.75,-y,z+0.75',
                '-x,y+0.25,z+0.25',
                '-z+0.5,-x+0.5,-y',
                '-z,x+0.25,y+0.25',
                'z+0.25,x+0.75,-y+0.5',
                'z+0.75,-x,y+0.75',
                '-y+0.5,-z+0.5,-x',
                'y+0.75,-z,x+0.75',
                '-y,z+0.25,x+0.25',
                'y+0.25,z+0.75,-x+0.5',
                '-y+0.75,-x+0.25,z',
                'y,x,z+0.5',
                '-y+0.25,x+0.5,-z+0.25',
                'y+0.5,-x+0.75,-z+0.75',
                '-x+0.75,-z+0.25,y',
                'x+0.5,-z+0.75,-y+0.75',
                'x,z,y+0.5',
                '-x+0.25,z+0.5,-y+0.25',
                '-z+0.75,-y+0.25,x',
                '-z+0.25,y+0.5,-x+0.25',
                'z+0.5,-y+0.75,-x+0.75',
                'z,y,x+0.5'],
            '229':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y,-x,z',
                'y,x,z',
                '-y,x,-z',
                'y,-x,-z',
                '-x,-z,y',
                'x,-z,-y',
                'x,z,y',
                '-x,z,-y',
                '-z,-y,x',
                '-z,y,-x',
                'z,-y,-x',
                'z,y,x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y+0.5',
                'z+0.5,-x+0.5,y+0.5',
                '-y+0.5,-z+0.5,-x+0.5',
                'y+0.5,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                'z+0.5,y+0.5,x+0.5'],
            '230':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.75,x+0.25,-z+0.25',
                '-y+0.75,-x+0.75,-z+0.75',
                'y+0.25,-x+0.25,z+0.75',
                '-y+0.25,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.25',
                '-x+0.25,z+0.75,y+0.25',
                '-x+0.75,-z+0.75,-y+0.75',
                'x+0.25,-z+0.25,y+0.75',
                'z+0.75,y+0.25,-x+0.25',
                'z+0.25,-y+0.25,x+0.75',
                '-z+0.25,y+0.75,x+0.25',
                '-z+0.75,-y+0.75,-x+0.75',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                '-z,-x,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z,-x',
                'y,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x',
                'y+0.5,z,-x+0.5',
                '-y+0.25,-x+0.75,z+0.75',
                'y+0.25,x+0.25,z+0.25',
                '-y+0.75,x+0.75,-z+0.25',
                'y+0.75,-x+0.25,-z+0.75',
                '-x+0.25,-z+0.75,y+0.75',
                'x+0.75,-z+0.25,-y+0.75',
                'x+0.25,z+0.25,y+0.25',
                '-x+0.75,z+0.75,-y+0.25',
                '-z+0.25,-y+0.75,x+0.75',
                '-z+0.75,y+0.75,-x+0.25',
                'z+0.75,-y+0.25,-x+0.75',
                'z+0.25,y+0.25,x+0.25',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                'y+0.75,-x+0.75,z+0.25',
                '-y+0.75,x+0.25,z+0.75',
                'x+0.25,z+0.75,-y+0.75',
                '-x+0.75,z+0.25,y+0.75',
                '-x+0.25,-z+0.25,-y+0.25',
                'x+0.75,-z+0.75,y+0.25',
                'z+0.25,y+0.75,-x+0.75',
                'z+0.75,-y+0.75,x+0.25',
                '-z+0.75,y+0.25,x+0.75',
                '-z+0.25,-y+0.25,-x+0.25',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'x+0.5,-y,z',
                '-x,y,z+0.5',
                '-z+0.5,-x+0.5,-y+0.5',
                '-z,x,y+0.5',
                'z,x+0.5,-y',
                'z+0.5,-x,y',
                '-y+0.5,-z+0.5,-x+0.5',
                'y+0.5,-z,x',
                '-y,z,x+0.5',
                'y,z+0.5,-x',
                '-y+0.75,-x+0.25,z+0.25',
                'y+0.75,x+0.75,z+0.75',
                '-y+0.25,x+0.25,-z+0.75',
                'y+0.25,-x+0.75,-z+0.25',
                '-x+0.75,-z+0.25,y+0.25',
                'x+0.25,-z+0.75,-y+0.25',
                'x+0.75,z+0.75,y+0.75',
                '-x+0.25,z+0.25,-y+0.75',
                '-z+0.75,-y+0.25,x+0.25',
                '-z+0.25,y+0.25,-x+0.75',
                'z+0.25,-y+0.75,-x+0.25',
                'z+0.75,y+0.75,x+0.75'],
            'P 1':['x,y,z'],
            'P -1':['x,y,z',
                '-x,-y,-z'],
            'P 2':['x,y,z',
                '-x,y,-z'],
            'P 21':['x,y,z',
                '-x,y+0.5,-z'],
            'C 2':['x,y,z',
                '-x,y,-z',
                'x+0.5,y+0.5,z',
                '-x+0.5,y+0.5,-z'],
            'P m':['x,y,z',
                'x,-y,z'],
            'P c':['x,y,z',
                'x,-y,z+0.5'],
            'C m':['x,y,z',
                'x,-y,z',
                'x+0.5,y+0.5,z',
                'x+0.5,-y+0.5,z'],
            'C c':['x,y,z',
                'x,-y,z',
                'x+0.5,y+0.5,z',
                'x+0.5,-y+0.5,z'],
            'P 2/m':['x,y,z',
                '-x,y,-z',
                '-x,-y,-z',
                'x,-y,z'],
            'P 21/m':['x,y,z',
                '-x,y+0.5,-z',
                '-x,-y,-z',
                'x,-y+0.5,z'],
            'C 2/m':['x,y,z',
                '-x,y,-z',
                '-x,-y,-z',
                'x,-y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,-y+0.5,z'],
            'P 2/c':['x,y,z',
                '-x,y,-z+0.5',
                '-x,-y,-z',
                'x,-y,z+0.5'],
            'P 21/c':['x,y,z',
                '-x,y+0.5,-z+0.5',
                '-x,-y,-z',
                'x,-y+0.5,z+0.5'],
            'C 2/c':['x,y,z',
                '-x,y,-z+0.5',
                '-x,-y,-z',
                'x,-y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,-y+0.5,z+0.5'],
            'P 2 2 2':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z'],
            'P 2 2 21':['x,y,z',
                '-x,-y,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z'],
            'P 21 21 2':['x,y,z',
                '-x,-y,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z'],
            'P 21 21 21':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z'],
            'C 2 2 21':['x,y,z',
                '-x,-y,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z'],
            'C 2 2 2':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z'],
            'F 2 2 2':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z'],
            'I 2 2 2':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5'],
            'I 21 21 21':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5'],
            'P m m 2':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z'],
            'P m c 21':['x,y,z',
                '-x,-y,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z'],
            'P c c 2':['x,y,z',
                '-x,-y,z',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            'P m a 2':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y,z',
                '-x+0.5,y,z'],
            'P c a 21':['x,y,z',
                '-x,-y,z+0.5',
                'x+0.5,-y,z',
                '-x+0.5,y,z+0.5'],
            'P n c 2':['x,y,z',
                '-x,-y,z',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            'P m n 21':['x,y,z',
                '-x+0.5,-y,z+0.5',
                'x+0.5,-y,z+0.5',
                '-x,y,z'],
            'P b a 2':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            'P n a 21':['x,y,z',
                '-x,-y,z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z+0.5'],
            'P n n 2':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            'C m m 2':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            'C m c 21':['x,y,z',
                '-x,-y,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z'],
            'C c c 2':['x,y,z',
                '-x,-y,z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            'A m m 2':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            'A e m 2':['x,y,z',
                '-x,-y,z',
                'x,-y+0.5,z',
                '-x,y+0.5,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            'A m a 2':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y,z',
                '-x+0.5,y,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            'A e a 2':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5'],
            'F m m 2':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            'F d d 2':['x,y,z',
                '-x,-y,z',
                'x+0.25,-y+0.25,z+0.25',
                '-x+0.25,y+0.25,z+0.25',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                'x+0.25,-y+0.75,z+0.75',
                '-x+0.25,y+0.75,z+0.75',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                'x+0.75,-y+0.25,z+0.75',
                '-x+0.75,y+0.25,z+0.75',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                'x+0.75,-y+0.75,z+0.25',
                '-x+0.75,y+0.75,z+0.25'],
            'I m m 2':['x,y,z',
                '-x,-y,z',
                'x,-y,z',
                '-x,y,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            'I b a 2':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            'I m a 2':['x,y,z',
                '-x,-y,z',
                'x+0.5,-y,z',
                '-x+0.5,y,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            'P m m m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z'],
            'P n n n':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5'],
            'P c c m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            'P b a n':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z',
                '-x,y+0.5,z'],
            'P m m a':['x,y,z',
                '-x+0.5,-y,z',
                '-x,y,-z',
                'x+0.5,-y,-z',
                '-x,-y,-z',
                'x+0.5,y,-z',
                'x,-y,z',
                '-x+0.5,y,z'],
            'P n n a':['x,y,z',
                '-x+0.5,-y,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            'P m n a':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x,-y,-z',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x,y,z'],
            'P c c a':['x,y,z',
                '-x+0.5,-y,z',
                '-x,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z',
                'x,-y,z+0.5',
                '-x+0.5,y,z+0.5'],
            'P b a m':['x,y,z',
                '-x,-y,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            'P c c n':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y,z+0.5'],
            'P b c m':['x,y,z',
                '-x,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z',
                '-x,-y,-z',
                'x,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z'],
            'P n n m':['x,y,z',
                '-x,-y,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            'P m m n':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x,y+0.5,-z',
                'x+0.5,-y,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x,-y+0.5,z',
                '-x+0.5,y,z'],
            'P b c n':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-x,y,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z+0.5',
                'x,-y,z+0.5',
                '-x+0.5,y+0.5,z'],
            'P b c a':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z'],
            'P n m a':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z',
                'x+0.5,-y+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z',
                '-x+0.5,y+0.5,z+0.5'],
            'C m c m':['x,y,z',
                '-x,-y,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z+0.5',
                'x,-y,z+0.5',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z'],
            'C m c e':['x,y,z',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y+0.5,z'],
            'C m m m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            'C c c m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            'C m m e':['x,y,z',
                '-x,-y+0.5,z',
                '-x,y+0.5,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y+0.5,-z',
                'x,-y+0.5,z',
                '-x,y,z',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y,z',
                '-x+0.5,y,-z',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y,-z',
                'x+0.5,-y,z',
                '-x+0.5,y+0.5,z'],
            'C c c e':['x,y,z',
                '-x+0.5,-y,z',
                '-x,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z',
                'x,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x,-y+0.5,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z',
                'x,y+0.5,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5'],
            'F m m m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                '-x,-y+0.5,-z+0.5',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z'],
            'F d d d':['x,y,z',
                '-x+0.75,-y+0.75,z',
                '-x+0.75,y,-z+0.75',
                'x,-y+0.75,-z+0.75',
                '-x,-y,-z',
                'x+0.25,y+0.25,-z',
                'x+0.25,-y,z+0.25',
                '-x,y+0.25,z+0.25',
                'x,y+0.5,z+0.5',
                '-x+0.75,-y+0.25,z+0.5',
                '-x+0.75,y+0.5,-z+0.25',
                'x,-y+0.25,-z+0.25',
                '-x,-y+0.5,-z+0.5',
                'x+0.25,y+0.75,-z+0.5',
                'x+0.25,-y+0.5,z+0.75',
                '-x,y+0.75,z+0.75',
                'x+0.5,y,z+0.5',
                '-x+0.25,-y+0.75,z+0.5',
                '-x+0.25,y,-z+0.25',
                'x+0.5,-y+0.75,-z+0.25',
                '-x+0.5,-y,-z+0.5',
                'x+0.75,y+0.25,-z+0.5',
                'x+0.75,-y,z+0.75',
                '-x+0.5,y+0.25,z+0.75',
                'x+0.5,y+0.5,z',
                '-x+0.25,-y+0.25,z',
                '-x+0.25,y+0.5,-z+0.75',
                'x+0.5,-y+0.25,-z+0.75',
                '-x+0.5,-y+0.5,-z',
                'x+0.75,y+0.75,-z',
                'x+0.75,-y+0.5,z+0.25',
                '-x+0.5,y+0.75,z+0.25'],
            'I m m m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            'I b a m':['x,y,z',
                '-x,-y,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x,y,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5'],
            'I b c a':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'x+0.5,-y,z',
                '-x,y,z+0.5'],
            'I m m a':['x,y,z',
                '-x,-y+0.5,z',
                '-x,y+0.5,-z',
                'x,-y,-z',
                '-x,-y,-z',
                'x,y+0.5,-z',
                'x,-y+0.5,z',
                '-x,y,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y+0.5,z+0.5'],
            'P 4':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z'],
            'P 41':['x,y,z',
                '-x,-y,z+0.5',
                '-y,x,z+0.25',
                'y,-x,z+0.75'],
            'P 42':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5'],
            'P 43':['x,y,z',
                '-x,-y,z+0.5',
                '-y,x,z+0.75',
                'y,-x,z+0.25'],
            'I 4':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5'],
            'I 41':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-y,x+0.5,z+0.25',
                'y+0.5,-x,z+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y,z',
                '-y+0.5,x,z+0.75',
                'y,-x+0.5,z+0.25'],
            'P -4':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z'],
            'I -4':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5'],
            'P 4/m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z'],
            'P 42/m':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5'],
            'P 4/n':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z'],
            'P 42/n':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y,x+0.5,z+0.5',
                'y+0.5,-x,z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y,-x+0.5,-z+0.5',
                '-y+0.5,x,-z+0.5'],
            'I 4/m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5'],
            'I 41/a':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-y+0.75,x+0.25,z+0.25',
                'y+0.75,-x+0.75,z+0.75',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'y+0.25,-x+0.75,-z+0.75',
                '-y+0.25,x+0.25,-z+0.25',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-y+0.25,x+0.75,z+0.75',
                'y+0.25,-x+0.25,z+0.25',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'y+0.75,-x+0.25,-z+0.25',
                '-y+0.75,x+0.75,-z+0.75'],
            'P 4 2 2':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z',
                '-y,-x,-z'],
            'P 4 21 2':['x,y,z',
                '-x,-y,z',
                '-y+0.5,x+0.5,z',
                'y+0.5,-x+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'y,x,-z',
                '-y,-x,-z'],
            'P 41 2 2':['x,y,z',
                '-x,-y,z+0.5',
                '-y,x,z+0.25',
                'y,-x,z+0.75',
                '-x,y,-z',
                'x,-y,-z+0.5',
                'y,x,-z+0.75',
                '-y,-x,-z+0.25'],
            'P 41 21 2':['x,y,z',
                '-x,-y,z+0.5',
                '-y+0.5,x+0.5,z+0.25',
                'y+0.5,-x+0.5,z+0.75',
                '-x+0.5,y+0.5,-z+0.25',
                'x+0.5,-y+0.5,-z+0.75',
                'y,x,-z',
                '-y,-x,-z+0.5'],
            'P 42 2 2':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5'],
            'P 42 21 2':['x,y,z',
                '-x,-y,z',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y,x,-z',
                '-y,-x,-z'],
            'P 43 2 2':['x,y,z',
                '-x,-y,z+0.5',
                '-y,x,z+0.75',
                'y,-x,z+0.25',
                '-x,y,-z',
                'x,-y,-z+0.5',
                'y,x,-z+0.25',
                '-y,-x,-z+0.75'],
            'P 43 21 2':['x,y,z',
                '-x,-y,z+0.5',
                '-y+0.5,x+0.5,z+0.75',
                'y+0.5,-x+0.5,z+0.25',
                '-x+0.5,y+0.5,-z+0.75',
                'x+0.5,-y+0.5,-z+0.25',
                'y,x,-z',
                '-y,-x,-z+0.5'],
            'I 4 2 2':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z',
                '-y,-x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5'],
            'I 41 2 2':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-y,x+0.5,z+0.25',
                'y+0.5,-x,z+0.75',
                '-x+0.5,y,-z+0.75',
                'x,-y+0.5,-z+0.25',
                'y+0.5,x+0.5,-z+0.5',
                '-y,-x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y,z',
                '-y+0.5,x,z+0.75',
                'y,-x+0.5,z+0.25',
                '-x,y+0.5,-z+0.25',
                'x+0.5,-y,-z+0.75',
                'y,x,-z',
                '-y+0.5,-x+0.5,-z+0.5'],
            'P 4 m m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z',
                'y,x,z'],
            'P 4 b m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            'P 42 c m':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z',
                'y,x,z'],
            'P 42 n m':['x,y,z',
                '-x,-y,z',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y,-x,z',
                'y,x,z'],
            'P 4 c c':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            'P 4 n c':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'P 42 m c':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            'P 42 b c':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'I 4 m m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z',
                'y,x,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'I 4 c m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            'I 41 m d':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-y,x+0.5,z+0.25',
                'y+0.5,-x,z+0.75',
                'x,-y,z',
                '-x+0.5,y+0.5,z+0.5',
                '-y,-x+0.5,z+0.25',
                'y+0.5,x,z+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y,z',
                '-y+0.5,x,z+0.75',
                'y,-x+0.5,z+0.25',
                'x+0.5,-y+0.5,z+0.5',
                '-x,y,z',
                '-y+0.5,-x,z+0.75',
                'y,x+0.5,z+0.25'],
            'I 41 c d':['x,y,z',
                '-x+0.5,-y+0.5,z+0.5',
                '-y,x+0.5,z+0.25',
                'y+0.5,-x,z+0.75',
                'x,-y,z+0.5',
                '-x+0.5,y+0.5,z',
                '-y,-x+0.5,z+0.75',
                'y+0.5,x,z+0.25',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y,z',
                '-y+0.5,x,z+0.75',
                'y,-x+0.5,z+0.25',
                'x+0.5,-y+0.5,z',
                '-x,y,z+0.5',
                '-y+0.5,-x,z+0.25',
                'y,x+0.5,z+0.75'],
            'P -4 2 m':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x,y,-z',
                'x,-y,-z',
                '-y,-x,z',
                'y,x,z'],
            'P -4 2 c':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            'P -4 21 m':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            'P -4 21 c':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'P -4 m 2':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z',
                '-x,y,z',
                'y,x,-z',
                '-y,-x,-z'],
            'P -4 c 2':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5'],
            'P -4 b 2':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z'],
            'P -4 n 2':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5'],
            'I -4 m 2':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z',
                '-x,y,z',
                'y,x,-z',
                '-y,-x,-z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5'],
            'I -4 c 2':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z'],
            'I -4 2 m':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x,y,-z',
                'x,-y,-z',
                '-y,-x,z',
                'y,x,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'I -4 2 d':['x,y,z',
                '-x,-y,z',
                'y,-x,-z',
                '-y,x,-z',
                '-x+0.5,y,-z+0.75',
                'x+0.5,-y,-z+0.75',
                '-y+0.5,-x,z+0.75',
                'y+0.5,x,z+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                '-x,y+0.5,-z+0.25',
                'x,-y+0.5,-z+0.25',
                '-y,-x+0.5,z+0.25',
                'y,x+0.5,z+0.25'],
            'P 4/m m m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z',
                'y,x,z'],
            'P 4/m c c':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            'P 4/n b m':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x+0.5,y,-z',
                'x,-y+0.5,-z',
                'y,x,-z',
                '-y+0.5,-x+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z',
                'x+0.5,-y,z',
                '-x,y+0.5,z',
                '-y,-x,z',
                'y+0.5,x+0.5,z'],
            'P 4/n n c':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'y,x,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-y,-x,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'P 4/m b m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            'P 4/m n c':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'P 4/n m m':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x,y+0.5,-z',
                'x+0.5,-y,-z',
                'y+0.5,x+0.5,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z',
                'x,-y+0.5,z',
                '-x+0.5,y,z',
                '-y+0.5,-x+0.5,z',
                'y,x,z'],
            'P 4/n c c':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z',
                'y,-x+0.5,z',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z',
                '-y,x+0.5,-z',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y,x,z+0.5'],
            'P 42/m m c':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z+0.5',
                'y,x,z+0.5'],
            'P 42/m c m':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                'y,x,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z',
                'y,x,z'],
            'P 42/n b c':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z+0.5',
                'y,-x+0.5,z+0.5',
                '-x+0.5,y,-z',
                'x,-y+0.5,-z',
                'y,x,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x+0.5,-y,z',
                '-x,y+0.5,z',
                '-y,-x,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'P 42/n n m':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z+0.5',
                'y,-x+0.5,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'y,x,-z',
                '-y+0.5,-x+0.5,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-y,-x,z',
                'y+0.5,x+0.5,z'],
            'P 42/m b c':['x,y,z',
                '-x,-y,z',
                '-y,x,z+0.5',
                'y,-x,z+0.5',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'P 42/m n m':['x,y,z',
                '-x,-y,z',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y,x,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y,-x,z',
                'y,x,z'],
            'P 42/n m c':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z+0.5',
                'y,-x+0.5,z+0.5',
                '-x,y+0.5,-z',
                'x+0.5,-y,-z',
                'y+0.5,x+0.5,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x,-y+0.5,z',
                '-x+0.5,y,z',
                '-y+0.5,-x+0.5,z+0.5',
                'y,x,z+0.5'],
            'P 42/n c m':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-y+0.5,x,z+0.5',
                'y,-x+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'y+0.5,x+0.5,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'y+0.5,-x,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y,z+0.5',
                '-y+0.5,-x+0.5,z',
                'y,x,z'],
            'I 4/m m m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z',
                'x,-y,-z',
                'y,x,-z',
                '-y,-x,-z',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z',
                '-x,y,z',
                '-y,-x,z',
                'y,x,z',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5'],
            'I 4/m c m':['x,y,z',
                '-x,-y,z',
                '-y,x,z',
                'y,-x,z',
                '-x,y,-z+0.5',
                'x,-y,-z+0.5',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'y,-x,-z',
                '-y,x,-z',
                'x,-y,z+0.5',
                '-x,y,z+0.5',
                '-y,-x,z+0.5',
                'y,x,z+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z'],
            'I 41/a m d':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-y+0.25,x+0.75,z+0.25',
                'y+0.25,-x+0.25,z+0.75',
                '-x+0.5,y,-z+0.5',
                'x,-y,-z',
                'y+0.25,x+0.75,-z+0.25',
                '-y+0.25,-x+0.25,-z+0.75',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'y+0.75,-x+0.25,-z+0.75',
                '-y+0.75,x+0.75,-z+0.25',
                'x+0.5,-y,z+0.5',
                '-x,y,z',
                '-y+0.75,-x+0.25,z+0.75',
                'y+0.75,x+0.75,z+0.25',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-y+0.75,x+0.25,z+0.75',
                'y+0.75,-x+0.75,z+0.25',
                '-x,y+0.5,-z',
                'x+0.5,-y+0.5,-z+0.5',
                'y+0.75,x+0.25,-z+0.75',
                '-y+0.75,-x+0.75,-z+0.25',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'y+0.25,-x+0.75,-z+0.25',
                '-y+0.25,x+0.25,-z+0.75',
                'x,-y+0.5,z',
                '-x+0.5,y+0.5,z+0.5',
                '-y+0.25,-x+0.75,z+0.25',
                'y+0.25,x+0.25,z+0.75'],
            'I 41/a c d':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-y+0.25,x+0.75,z+0.25',
                'y+0.25,-x+0.25,z+0.75',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'y+0.75,-x+0.25,-z+0.75',
                '-y+0.75,x+0.75,-z+0.25',
                'x+0.5,-y,z',
                '-x,y,z+0.5',
                '-y+0.75,-x+0.25,z+0.25',
                'y+0.75,x+0.75,z+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-y+0.75,x+0.25,z+0.75',
                'y+0.75,-x+0.75,z+0.25',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'y+0.75,x+0.25,-z+0.25',
                '-y+0.75,-x+0.75,-z+0.75',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'y+0.25,-x+0.75,-z+0.25',
                '-y+0.25,x+0.25,-z+0.75',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                '-y+0.25,-x+0.75,z+0.75',
                'y+0.25,x+0.25,z+0.25'],
            'P 3':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z'],
            'P 31':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.'],
            'P 32':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.'],
            'R 3':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.'],
            'P -3':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z'],
            'R -3':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                '-x+2./3.,-y+1./3.,-z+1./3.',
                'y+2./3.,-x+y+1./3.,-z+1./3.',
                'x-y+2./3.,x+1./3.,-z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                '-x+1./3.,-y+2./3.,-z+2./3.',
                'y+1./3.,-x+y+2./3.,-z+2./3.',
                'x-y+1./3.,x+2./3.,-z+2./3.'],
            'P 3 1 2':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z'],
            'P 3 2 1':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z'],
            'P 31 1 2':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-y,-x,-z+2./3.',
                '-x+y,y,-z+1./3.',
                'x,x-y,-z'],
            'P 31 2 1':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                'y,x,-z',
                'x-y,-y,-z+2./3.',
                '-x,-x+y,-z+1./3.'],
            'P 32 1 2':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-y,-x,-z+1./3.',
                '-x+y,y,-z+2./3.',
                'x,x-y,-z'],
            'P 32 2 1':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                'y,x,-z',
                'x-y,-y,-z+1./3.',
                '-x,-x+y,-z+2./3.'],
            'R 3 2':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                'y+2./3.,x+1./3.,-z+1./3.',
                'x-y+2./3.,-y+1./3.,-z+1./3.',
                '-x+2./3.,-x+y+1./3.,-z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                'y+1./3.,x+2./3.,-z+2./3.',
                'x-y+1./3.,-y+2./3.,-z+2./3.',
                '-x+1./3.,-x+y+2./3.,-z+2./3.'],
            'P 3 m 1':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z'],
            'P 3 1 m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            'P 3 c 1':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5'],
            'P 3 1 c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            'R 3 m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                '-y+2./3.,-x+1./3.,z+1./3.',
                '-x+y+2./3.,y+1./3.,z+1./3.',
                'x+2./3.,x-y+1./3.,z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                '-y+1./3.,-x+2./3.,z+2./3.',
                '-x+y+1./3.,y+2./3.,z+2./3.',
                'x+1./3.,x-y+2./3.,z+2./3.'],
            'R 3 c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                '-y+2./3.,-x+1./3.,z+5./6.',
                '-x+y+2./3.,y+1./3.,z+5./6.',
                'x+2./3.,x-y+1./3.,z+5./6.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                '-y+1./3.,-x+2./3.,z+1./6.',
                '-x+y+1./3.,y+2./3.,z+1./6.',
                'x+1./3.,x-y+2./3.,z+1./6.'],
            'P -3 1 m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            'P -3 1 c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-y,-x,-z+0.5',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            'P -3 m 1':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z'],
            'P -3 c 1':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z+0.5',
                'x-y,-y,-z+0.5',
                '-x,-x+y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5'],
            'R -3 m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                'y+2./3.,x+1./3.,-z+1./3.',
                'x-y+2./3.,-y+1./3.,-z+1./3.',
                '-x+2./3.,-x+y+1./3.,-z+1./3.',
                '-x+2./3.,-y+1./3.,-z+1./3.',
                'y+2./3.,-x+y+1./3.,-z+1./3.',
                'x-y+2./3.,x+1./3.,-z+1./3.',
                '-y+2./3.,-x+1./3.,z+1./3.',
                '-x+y+2./3.,y+1./3.,z+1./3.',
                'x+2./3.,x-y+1./3.,z+1./3.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                'y+1./3.,x+2./3.,-z+2./3.',
                'x-y+1./3.,-y+2./3.,-z+2./3.',
                '-x+1./3.,-x+y+2./3.,-z+2./3.',
                '-x+1./3.,-y+2./3.,-z+2./3.',
                'y+1./3.,-x+y+2./3.,-z+2./3.',
                'x-y+1./3.,x+2./3.,-z+2./3.',
                '-y+1./3.,-x+2./3.,z+2./3.',
                '-x+y+1./3.,y+2./3.,z+2./3.',
                'x+1./3.,x-y+2./3.,z+2./3.'],
            'R -3 c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'y,x,-z+0.5',
                'x-y,-y,-z+0.5',
                '-x,-x+y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'x+2./3.,y+1./3.,z+1./3.',
                '-y+2./3.,x-y+1./3.,z+1./3.',
                '-x+y+2./3.,-x+1./3.,z+1./3.',
                'y+2./3.,x+1./3.,-z+5./6.',
                'x-y+2./3.,-y+1./3.,-z+5./6.',
                '-x+2./3.,-x+y+1./3.,-z+5./6.',
                '-x+2./3.,-y+1./3.,-z+1./3.',
                'y+2./3.,-x+y+1./3.,-z+1./3.',
                'x-y+2./3.,x+1./3.,-z+1./3.',
                '-y+2./3.,-x+1./3.,z+5./6.',
                '-x+y+2./3.,y+1./3.,z+5./6.',
                'x+2./3.,x-y+1./3.,z+5./6.',
                'x+1./3.,y+2./3.,z+2./3.',
                '-y+1./3.,x-y+2./3.,z+2./3.',
                '-x+y+1./3.,-x+2./3.,z+2./3.',
                'y+1./3.,x+2./3.,-z+1./6.',
                'x-y+1./3.,-y+2./3.,-z+1./6.',
                '-x+1./3.,-x+y+2./3.,-z+1./6.',
                '-x+1./3.,-y+2./3.,-z+2./3.',
                'y+1./3.,-x+y+2./3.,-z+2./3.',
                'x-y+1./3.,x+2./3.,-z+2./3.',
                '-y+1./3.,-x+2./3.,z+1./6.',
                '-x+y+1./3.,y+2./3.,z+1./6.',
                'x+1./3.,x-y+2./3.,z+1./6.'],
            'P 6':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z'],
            'P 61':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-x,-y,z+0.5',
                'y,-x+y,z+5./6.',
                'x-y,x,z+1./6.'],
            'P 65':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-x,-y,z+0.5',
                'y,-x+y,z+1./6.',
                'x-y,x,z+5./6.'],
            'P 62':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-x,-y,z',
                'y,-x+y,z+2./3.',
                'x-y,x,z+1./3.'],
            'P 64':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-x,-y,z',
                'y,-x+y,z+1./3.',
                'x-y,x,z+2./3.'],
            'P 63':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5'],
            'P -6':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z'],
            'P 6/m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z'],
            'P 63/m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5'],
            'P 6 2 2':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z'],
            'P 61 2 2':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-x,-y,z+0.5',
                'y,-x+y,z+5./6.',
                'x-y,x,z+1./6.',
                'y,x,-z+1./3.',
                'x-y,-y,-z',
                '-x,-x+y,-z+2./3.',
                '-y,-x,-z+5./6.',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+1./6.'],
            'P 65 2 2':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-x,-y,z+0.5',
                'y,-x+y,z+1./6.',
                'x-y,x,z+5./6.',
                'y,x,-z+2./3.',
                'x-y,-y,-z',
                '-x,-x+y,-z+1./3.',
                '-y,-x,-z+1./6.',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+5./6.'],
            'P 62 2 2':['x,y,z',
                '-y,x-y,z+2./3.',
                '-x+y,-x,z+1./3.',
                '-x,-y,z',
                'y,-x+y,z+2./3.',
                'x-y,x,z+1./3.',
                'y,x,-z+2./3.',
                'x-y,-y,-z',
                '-x,-x+y,-z+1./3.',
                '-y,-x,-z+2./3.',
                '-x+y,y,-z',
                'x,x-y,-z+1./3.'],
            'P 64 2 2':['x,y,z',
                '-y,x-y,z+1./3.',
                '-x+y,-x,z+2./3.',
                '-x,-y,z',
                'y,-x+y,z+1./3.',
                'x-y,x,z+2./3.',
                'y,x,-z+1./3.',
                'x-y,-y,-z',
                '-x,-x+y,-z+2./3.',
                '-y,-x,-z+1./3.',
                '-x+y,y,-z',
                'x,x-y,-z+2./3.'],
            'P 63 2 2':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-y,-x,-z+0.5',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+0.5'],
            'P 6 m m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            'P 6 c c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            'P 63 c m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            'P 63 m c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            'P -6 m 2':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z'],
            'P -6 c 2':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z'],
            'P -6 2 m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            'P -6 2 c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            'P 6/m m m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            'P 6/m c c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z',
                'y,-x+y,z',
                'x-y,x,z',
                'y,x,-z+0.5',
                'x-y,-y,-z+0.5',
                '-x,-x+y,-z+0.5',
                '-y,-x,-z+0.5',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z',
                '-y,x-y,-z',
                '-x+y,-x,-z',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            'P 63/m c m':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                'y,x,-z+0.5',
                'x-y,-y,-z+0.5',
                '-x,-x+y,-z+0.5',
                '-y,-x,-z',
                '-x+y,y,-z',
                'x,x-y,-z',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5',
                '-y,-x,z+0.5',
                '-x+y,y,z+0.5',
                'x,x-y,z+0.5',
                'y,x,z',
                'x-y,-y,z',
                '-x,-x+y,z'],
            'P 63/m m c':['x,y,z',
                '-y,x-y,z',
                '-x+y,-x,z',
                '-x,-y,z+0.5',
                'y,-x+y,z+0.5',
                'x-y,x,z+0.5',
                'y,x,-z',
                'x-y,-y,-z',
                '-x,-x+y,-z',
                '-y,-x,-z+0.5',
                '-x+y,y,-z+0.5',
                'x,x-y,-z+0.5',
                '-x,-y,-z',
                'y,-x+y,-z',
                'x-y,x,-z',
                'x,y,-z+0.5',
                '-y,x-y,-z+0.5',
                '-x+y,-x,-z+0.5',
                '-y,-x,z',
                '-x+y,y,z',
                'x,x-y,z',
                'y,x,z+0.5',
                'x-y,-y,z+0.5',
                '-x,-x+y,z+0.5'],
            'P 2 3':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x'],
            'F 2 3':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x'],
            'I 2 3':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5'],
            'P 21 3':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5'],
            'I 21 3':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x'],
            'P m -3':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x'],
            'P n -3':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x,y',
                'z,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x,-y+0.5',
                'y,z,x',
                '-y+0.5,z,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x,-y',
                '-z,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x,y+0.5',
                '-y,-z,-x',
                'y+0.5,-z,x+0.5',
                '-y,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x'],
            'F m -3':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                '-x,-y+0.5,-z+0.5',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x+0.5,-y+0.5',
                '-z,x+0.5,y+0.5',
                'z,x+0.5,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z+0.5,-x+0.5',
                'y,-z+0.5,x+0.5',
                '-y,z+0.5,x+0.5',
                'y,z+0.5,-x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                '-z+0.5,-x,-y+0.5',
                '-z+0.5,x,y+0.5',
                'z+0.5,x,-y+0.5',
                'z+0.5,-x,y+0.5',
                '-y+0.5,-z,-x+0.5',
                'y+0.5,-z,x+0.5',
                '-y+0.5,z,x+0.5',
                'y+0.5,z,-x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-z+0.5,-x+0.5,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x+0.5,y',
                '-y+0.5,-z+0.5,-x',
                'y+0.5,-z+0.5,x',
                '-y+0.5,z+0.5,x',
                'y+0.5,z+0.5,-x'],
            'F d -3':['x,y,z',
                '-x+0.75,-y+0.75,z',
                '-x+0.75,y,-z+0.75',
                'x,-y+0.75,-z+0.75',
                'z,x,y',
                'z,-x+0.75,-y+0.75',
                '-z+0.75,-x+0.75,y',
                '-z+0.75,x,-y+0.75',
                'y,z,x',
                '-y+0.75,z,-x+0.75',
                'y,-z+0.75,-x+0.75',
                '-y+0.75,-z+0.75,x',
                '-x,-y,-z',
                'x+0.25,y+0.25,-z',
                'x+0.25,-y,z+0.25',
                '-x,y+0.25,z+0.25',
                '-z,-x,-y',
                '-z,x+0.25,y+0.25',
                'z+0.25,x+0.25,-y',
                'z+0.25,-x,y+0.25',
                '-y,-z,-x',
                'y+0.25,-z,x+0.25',
                '-y,z+0.25,x+0.25',
                'y+0.25,z+0.25,-x',
                'x,y+0.5,z+0.5',
                '-x+0.75,-y+0.25,z+0.5',
                '-x+0.75,y+0.5,-z+0.25',
                'x,-y+0.25,-z+0.25',
                'z,x+0.5,y+0.5',
                'z,-x+0.25,-y+0.25',
                '-z+0.75,-x+0.25,y+0.5',
                '-z+0.75,x+0.5,-y+0.25',
                'y,z+0.5,x+0.5',
                '-y+0.75,z+0.5,-x+0.25',
                'y,-z+0.25,-x+0.25',
                '-y+0.75,-z+0.25,x+0.5',
                '-x,-y+0.5,-z+0.5',
                'x+0.25,y+0.75,-z+0.5',
                'x+0.25,-y+0.5,z+0.75',
                '-x,y+0.75,z+0.75',
                '-z,-x+0.5,-y+0.5',
                '-z,x+0.75,y+0.75',
                'z+0.25,x+0.75,-y+0.5',
                'z+0.25,-x+0.5,y+0.75',
                '-y,-z+0.5,-x+0.5',
                'y+0.25,-z+0.5,x+0.75',
                '-y,z+0.75,x+0.75',
                'y+0.25,z+0.75,-x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.25,-y+0.75,z+0.5',
                '-x+0.25,y,-z+0.25',
                'x+0.5,-y+0.75,-z+0.25',
                'z+0.5,x,y+0.5',
                'z+0.5,-x+0.75,-y+0.25',
                '-z+0.25,-x+0.75,y+0.5',
                '-z+0.25,x,-y+0.25',
                'y+0.5,z,x+0.5',
                '-y+0.25,z,-x+0.25',
                'y+0.5,-z+0.75,-x+0.25',
                '-y+0.25,-z+0.75,x+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.75,y+0.25,-z+0.5',
                'x+0.75,-y,z+0.75',
                '-x+0.5,y+0.25,z+0.75',
                '-z+0.5,-x,-y+0.5',
                '-z+0.5,x+0.25,y+0.75',
                'z+0.75,x+0.25,-y+0.5',
                'z+0.75,-x,y+0.75',
                '-y+0.5,-z,-x+0.5',
                'y+0.75,-z,x+0.75',
                '-y+0.5,z+0.25,x+0.75',
                'y+0.75,z+0.25,-x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.25,-y+0.25,z',
                '-x+0.25,y+0.5,-z+0.75',
                'x+0.5,-y+0.25,-z+0.75',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.25,-y+0.75',
                '-z+0.25,-x+0.25,y',
                '-z+0.25,x+0.5,-y+0.75',
                'y+0.5,z+0.5,x',
                '-y+0.25,z+0.5,-x+0.75',
                'y+0.5,-z+0.25,-x+0.75',
                '-y+0.25,-z+0.25,x',
                '-x+0.5,-y+0.5,-z',
                'x+0.75,y+0.75,-z',
                'x+0.75,-y+0.5,z+0.25',
                '-x+0.5,y+0.75,z+0.25',
                '-z+0.5,-x+0.5,-y',
                '-z+0.5,x+0.75,y+0.25',
                'z+0.75,x+0.75,-y',
                'z+0.75,-x+0.5,y+0.25',
                '-y+0.5,-z+0.5,-x',
                'y+0.75,-z+0.5,x+0.25',
                '-y+0.5,z+0.75,x+0.25',
                'y+0.75,z+0.75,-x'],
            'I m -3':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y+0.5',
                'z+0.5,-x+0.5,y+0.5',
                '-y+0.5,-z+0.5,-x+0.5',
                'y+0.5,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x+0.5'],
            'P a -3':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                '-z,-x,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z,-x',
                'y,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x',
                'y+0.5,z,-x+0.5'],
            'I a -3':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                '-z,-x,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z,-x',
                'y,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x',
                'y+0.5,z,-x+0.5',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'x+0.5,-y,z',
                '-x,y,z+0.5',
                '-z+0.5,-x+0.5,-y+0.5',
                '-z,x,y+0.5',
                'z,x+0.5,-y',
                'z+0.5,-x,y',
                '-y+0.5,-z+0.5,-x+0.5',
                'y+0.5,-z,x',
                '-y,z,x+0.5',
                'y,z+0.5,-x'],
            'P 4 3 2':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x'],
            'P 42 3 2':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5'],
            'F 4 3 2':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y,x+0.5,-z+0.5',
                '-y,-x+0.5,-z+0.5',
                'y,-x+0.5,z+0.5',
                '-y,x+0.5,z+0.5',
                'x,z+0.5,-y+0.5',
                '-x,z+0.5,y+0.5',
                '-x,-z+0.5,-y+0.5',
                'x,-z+0.5,y+0.5',
                'z,y+0.5,-x+0.5',
                'z,-y+0.5,x+0.5',
                '-z,y+0.5,x+0.5',
                '-z,-y+0.5,-x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y+0.5,x,-z+0.5',
                '-y+0.5,-x,-z+0.5',
                'y+0.5,-x,z+0.5',
                '-y+0.5,x,z+0.5',
                'x+0.5,z,-y+0.5',
                '-x+0.5,z,y+0.5',
                '-x+0.5,-z,-y+0.5',
                'x+0.5,-z,y+0.5',
                'z+0.5,y,-x+0.5',
                'z+0.5,-y,x+0.5',
                '-z+0.5,y,x+0.5',
                '-z+0.5,-y,-x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z',
                'y+0.5,-x+0.5,z',
                '-y+0.5,x+0.5,z',
                'x+0.5,z+0.5,-y',
                '-x+0.5,z+0.5,y',
                '-x+0.5,-z+0.5,-y',
                'x+0.5,-z+0.5,y',
                'z+0.5,y+0.5,-x',
                'z+0.5,-y+0.5,x',
                '-z+0.5,y+0.5,x',
                '-z+0.5,-y+0.5,-x'],
            'F 41 3 2':['x,y,z',
                '-x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y,-z+0.5',
                'z,x,y',
                'z+0.5,-x,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y',
                'y,z,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y+0.75,x+0.25,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                'y+0.25,-x+0.75,z+0.75',
                '-y+0.75,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.75',
                '-x+0.75,z+0.75,y+0.25',
                '-x+0.25,-z+0.25,-y+0.25',
                'x+0.25,-z+0.75,y+0.75',
                'z+0.75,y+0.25,-x+0.75',
                'z+0.25,-y+0.75,x+0.75',
                '-z+0.75,y+0.75,x+0.25',
                '-z+0.25,-y+0.25,-x+0.25',
                'x,y+0.5,z+0.5',
                '-x,-y,z',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y',
                '-z,-x,y',
                '-z+0.5,x,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y,-z,x',
                'y+0.75,x+0.75,-z+0.25',
                '-y+0.25,-x+0.75,-z+0.75',
                'y+0.25,-x+0.25,z+0.25',
                '-y+0.75,x+0.25,z+0.75',
                'x+0.75,z+0.75,-y+0.25',
                '-x+0.75,z+0.25,y+0.75',
                '-x+0.25,-z+0.75,-y+0.75',
                'x+0.25,-z+0.25,y+0.25',
                'z+0.75,y+0.75,-x+0.25',
                'z+0.25,-y+0.25,x+0.25',
                '-z+0.75,y+0.25,x+0.75',
                '-z+0.25,-y+0.75,-x+0.75',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y+0.5,z',
                '-x,y+0.5,-z+0.5',
                'x,-y,-z',
                'z+0.5,x,y+0.5',
                'z,-x,-y',
                '-z+0.5,-x+0.5,y',
                '-z,x+0.5,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z,-x',
                '-y+0.5,-z+0.5,x',
                'y+0.25,x+0.25,-z+0.25',
                '-y+0.75,-x+0.25,-z+0.75',
                'y+0.75,-x+0.75,z+0.25',
                '-y+0.25,x+0.75,z+0.75',
                'x+0.25,z+0.25,-y+0.25',
                '-x+0.25,z+0.75,y+0.75',
                '-x+0.75,-z+0.25,-y+0.75',
                'x+0.75,-z+0.75,y+0.25',
                'z+0.25,y+0.25,-x+0.25',
                'z+0.75,-y+0.75,x+0.25',
                '-z+0.25,y+0.75,x+0.75',
                '-z+0.75,-y+0.25,-x+0.75',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y,z+0.5',
                '-x,y,-z',
                'x,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y',
                'z,-x+0.5,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z,x,-y',
                'y+0.5,z+0.5,x',
                '-y,z,-x',
                'y,-z+0.5,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.75,-x+0.75,-z+0.25',
                'y+0.75,-x+0.25,z+0.75',
                '-y+0.25,x+0.25,z+0.25',
                'x+0.25,z+0.75,-y+0.75',
                '-x+0.25,z+0.25,y+0.25',
                '-x+0.75,-z+0.75,-y+0.25',
                'x+0.75,-z+0.25,y+0.75',
                'z+0.25,y+0.75,-x+0.75',
                'z+0.75,-y+0.25,x+0.75',
                '-z+0.25,y+0.25,x+0.25',
                '-z+0.75,-y+0.75,-x+0.25'],
            'I 4 3 2':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5'],
            'P 43 3 2':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                'y+0.75,-x+0.75,z+0.25',
                '-y+0.75,x+0.25,z+0.75',
                'x+0.25,z+0.75,-y+0.75',
                '-x+0.75,z+0.25,y+0.75',
                '-x+0.25,-z+0.25,-y+0.25',
                'x+0.75,-z+0.75,y+0.25',
                'z+0.25,y+0.75,-x+0.75',
                'z+0.75,-y+0.75,x+0.25',
                '-z+0.75,y+0.25,x+0.75',
                '-z+0.25,-y+0.25,-x+0.25'],
            'P 41 3 2':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.75,x+0.25,-z+0.25',
                '-y+0.75,-x+0.75,-z+0.75',
                'y+0.25,-x+0.25,z+0.75',
                '-y+0.25,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.25',
                '-x+0.25,z+0.75,y+0.25',
                '-x+0.75,-z+0.75,-y+0.75',
                'x+0.25,-z+0.25,y+0.75',
                'z+0.75,y+0.25,-x+0.25',
                'z+0.25,-y+0.25,x+0.75',
                '-z+0.25,y+0.75,x+0.25',
                '-z+0.75,-y+0.75,-x+0.75'],
            'I 41 3 2':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.75,x+0.25,-z+0.25',
                '-y+0.75,-x+0.75,-z+0.75',
                'y+0.25,-x+0.25,z+0.75',
                '-y+0.25,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.25',
                '-x+0.25,z+0.75,y+0.25',
                '-x+0.75,-z+0.75,-y+0.75',
                'x+0.25,-z+0.25,y+0.75',
                'z+0.75,y+0.25,-x+0.25',
                'z+0.25,-y+0.25,x+0.75',
                '-z+0.25,y+0.75,x+0.25',
                '-z+0.75,-y+0.75,-x+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                'y+0.75,-x+0.75,z+0.25',
                '-y+0.75,x+0.25,z+0.75',
                'x+0.25,z+0.75,-y+0.75',
                '-x+0.75,z+0.25,y+0.75',
                '-x+0.25,-z+0.25,-y+0.25',
                'x+0.75,-z+0.75,y+0.25',
                'z+0.25,y+0.75,-x+0.75',
                'z+0.75,-y+0.75,x+0.25',
                '-z+0.75,y+0.25,x+0.75',
                '-z+0.25,-y+0.25,-x+0.25'],
            'P -4 3 m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,z',
                '-y,-x,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,z,y',
                '-x,z,-y',
                '-x,-z,y',
                'x,-z,-y',
                'z,y,x',
                'z,-y,-x',
                '-z,y,-x',
                '-z,-y,x'],
            'F -4 3 m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,z',
                '-y,-x,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,z,y',
                '-x,z,-y',
                '-x,-z,y',
                'x,-z,-y',
                'z,y,x',
                'z,-y,-x',
                '-z,y,-x',
                '-z,-y,x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y,x+0.5,z+0.5',
                '-y,-x+0.5,z+0.5',
                'y,-x+0.5,-z+0.5',
                '-y,x+0.5,-z+0.5',
                'x,z+0.5,y+0.5',
                '-x,z+0.5,-y+0.5',
                '-x,-z+0.5,y+0.5',
                'x,-z+0.5,-y+0.5',
                'z,y+0.5,x+0.5',
                'z,-y+0.5,-x+0.5',
                '-z,y+0.5,-x+0.5',
                '-z,-y+0.5,x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y+0.5,x,z+0.5',
                '-y+0.5,-x,z+0.5',
                'y+0.5,-x,-z+0.5',
                '-y+0.5,x,-z+0.5',
                'x+0.5,z,y+0.5',
                '-x+0.5,z,-y+0.5',
                '-x+0.5,-z,y+0.5',
                'x+0.5,-z,-y+0.5',
                'z+0.5,y,x+0.5',
                'z+0.5,-y,-x+0.5',
                '-z+0.5,y,-x+0.5',
                '-z+0.5,-y,x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y+0.5,x+0.5,z',
                '-y+0.5,-x+0.5,z',
                'y+0.5,-x+0.5,-z',
                '-y+0.5,x+0.5,-z',
                'x+0.5,z+0.5,y',
                '-x+0.5,z+0.5,-y',
                '-x+0.5,-z+0.5,y',
                'x+0.5,-z+0.5,-y',
                'z+0.5,y+0.5,x',
                'z+0.5,-y+0.5,-x',
                '-z+0.5,y+0.5,-x',
                '-z+0.5,-y+0.5,x'],
            'I -4 3 m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,z',
                '-y,-x,z',
                'y,-x,-z',
                '-y,x,-z',
                'x,z,y',
                '-x,z,-y',
                '-x,-z,y',
                'x,-z,-y',
                'z,y,x',
                'z,-y,-x',
                '-z,y,-x',
                '-z,-y,x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'z+0.5,y+0.5,x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                '-z+0.5,-y+0.5,x+0.5'],
            'P -4 3 n':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'z+0.5,y+0.5,x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                '-z+0.5,-y+0.5,x+0.5'],
            'F -4 3 c':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'z+0.5,y+0.5,x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                '-z+0.5,-y+0.5,x+0.5',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y+0.5,x,z',
                '-y+0.5,-x,z',
                'y+0.5,-x,-z',
                '-y+0.5,x,-z',
                'x+0.5,z,y',
                '-x+0.5,z,-y',
                '-x+0.5,-z,y',
                'x+0.5,-z,-y',
                'z+0.5,y,x',
                'z+0.5,-y,-x',
                '-z+0.5,y,-x',
                '-z+0.5,-y,x',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y,x+0.5,z',
                '-y,-x+0.5,z',
                'y,-x+0.5,-z',
                '-y,x+0.5,-z',
                'x,z+0.5,y',
                '-x,z+0.5,-y',
                '-x,-z+0.5,y',
                'x,-z+0.5,-y',
                'z,y+0.5,x',
                'z,-y+0.5,-x',
                '-z,y+0.5,-x',
                '-z,-y+0.5,x',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y,x,z+0.5',
                '-y,-x,z+0.5',
                'y,-x,-z+0.5',
                '-y,x,-z+0.5',
                'x,z,y+0.5',
                '-x,z,-y+0.5',
                '-x,-z,y+0.5',
                'x,-z,-y+0.5',
                'z,y,x+0.5',
                'z,-y,-x+0.5',
                '-z,y,-x+0.5',
                '-z,-y,x+0.5'],
            'I -4 3 d':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.25,x+0.25,z+0.25',
                '-y+0.25,-x+0.75,z+0.75',
                'y+0.75,-x+0.25,-z+0.75',
                '-y+0.75,x+0.75,-z+0.25',
                'x+0.25,z+0.25,y+0.25',
                '-x+0.75,z+0.75,-y+0.25',
                '-x+0.25,-z+0.75,y+0.75',
                'x+0.75,-z+0.25,-y+0.75',
                'z+0.25,y+0.25,x+0.25',
                'z+0.75,-y+0.25,-x+0.75',
                '-z+0.75,y+0.75,-x+0.25',
                '-z+0.25,-y+0.75,x+0.75',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x',
                'y+0.75,x+0.75,z+0.75',
                '-y+0.75,-x+0.25,z+0.25',
                'y+0.25,-x+0.75,-z+0.25',
                '-y+0.25,x+0.25,-z+0.75',
                'x+0.75,z+0.75,y+0.75',
                '-x+0.25,z+0.25,-y+0.75',
                '-x+0.75,-z+0.25,y+0.25',
                'x+0.25,-z+0.75,-y+0.25',
                'z+0.75,y+0.75,x+0.75',
                'z+0.25,-y+0.75,-x+0.25',
                '-z+0.25,y+0.25,-x+0.75',
                '-z+0.75,-y+0.25,x+0.25'],
            'P m -3 m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y,-x,z',
                'y,x,z',
                '-y,x,-z',
                'y,-x,-z',
                '-x,-z,y',
                'x,-z,-y',
                'x,z,y',
                '-x,z,-y',
                '-z,-y,x',
                '-z,y,-x',
                'z,-y,-x',
                'z,y,x'],
            'P n -3 n':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x,y',
                'z,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x,-y+0.5',
                'y,z,x',
                '-y+0.5,z,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x',
                'y,x,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y,-x+0.5,z',
                '-y+0.5,x,z',
                'x,z,-y+0.5',
                '-x+0.5,z,y',
                '-x+0.5,-z+0.5,-y+0.5',
                'x,-z+0.5,y',
                'z,y,-x+0.5',
                'z,-y+0.5,x',
                '-z+0.5,y,x',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x,-y',
                '-z,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x,y+0.5',
                '-y,-z,-x',
                'y+0.5,-z,x+0.5',
                '-y,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x',
                '-y,-x,z+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y,x+0.5,-z',
                'y+0.5,-x,-z',
                '-x,-z,y+0.5',
                'x+0.5,-z,-y',
                'x+0.5,z+0.5,y+0.5',
                '-x,z+0.5,-y',
                '-z,-y,x+0.5',
                '-z,y+0.5,-x',
                'z+0.5,-y,-x',
                'z+0.5,y+0.5,x+0.5'],
            'P m -3 n':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                'z+0.5,y+0.5,x+0.5'],
            'P n -3 m':['x,y,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x,y',
                'z,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x,-y+0.5',
                'y,z,x',
                '-y+0.5,z,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x',
                'y+0.5,x+0.5,-z',
                '-y,-x,-z',
                'y+0.5,-x,z+0.5',
                '-y,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y',
                '-x,z+0.5,y+0.5',
                '-x,-z,-y',
                'x+0.5,-z,y+0.5',
                'z+0.5,y+0.5,-x',
                'z+0.5,-y,x+0.5',
                '-z,y+0.5,x+0.5',
                '-z,-y,-x',
                '-x,-y,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x,-y',
                '-z,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x,y+0.5',
                '-y,-z,-x',
                'y+0.5,-z,x+0.5',
                '-y,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x',
                '-y+0.5,-x+0.5,z',
                'y,x,z',
                '-y+0.5,x,-z+0.5',
                'y,-x+0.5,-z+0.5',
                '-x+0.5,-z+0.5,y',
                'x,-z+0.5,-y+0.5',
                'x,z,y',
                '-x+0.5,z,-y+0.5',
                '-z+0.5,-y+0.5,x',
                '-z+0.5,y,-x+0.5',
                'z,-y+0.5,-x+0.5',
                'z,y,x'],
            'F m -3 m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y,-x,z',
                'y,x,z',
                '-y,x,-z',
                'y,-x,-z',
                '-x,-z,y',
                'x,-z,-y',
                'x,z,y',
                '-x,z,-y',
                '-z,-y,x',
                '-z,y,-x',
                'z,-y,-x',
                'z,y,x',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y,x+0.5,-z+0.5',
                '-y,-x+0.5,-z+0.5',
                'y,-x+0.5,z+0.5',
                '-y,x+0.5,z+0.5',
                'x,z+0.5,-y+0.5',
                '-x,z+0.5,y+0.5',
                '-x,-z+0.5,-y+0.5',
                'x,-z+0.5,y+0.5',
                'z,y+0.5,-x+0.5',
                'z,-y+0.5,x+0.5',
                '-z,y+0.5,x+0.5',
                '-z,-y+0.5,-x+0.5',
                '-x,-y+0.5,-z+0.5',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x+0.5,-y+0.5',
                '-z,x+0.5,y+0.5',
                'z,x+0.5,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z+0.5,-x+0.5',
                'y,-z+0.5,x+0.5',
                '-y,z+0.5,x+0.5',
                'y,z+0.5,-x+0.5',
                '-y,-x+0.5,z+0.5',
                'y,x+0.5,z+0.5',
                '-y,x+0.5,-z+0.5',
                'y,-x+0.5,-z+0.5',
                '-x,-z+0.5,y+0.5',
                'x,-z+0.5,-y+0.5',
                'x,z+0.5,y+0.5',
                '-x,z+0.5,-y+0.5',
                '-z,-y+0.5,x+0.5',
                '-z,y+0.5,-x+0.5',
                'z,-y+0.5,-x+0.5',
                'z,y+0.5,x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y+0.5,x,-z+0.5',
                '-y+0.5,-x,-z+0.5',
                'y+0.5,-x,z+0.5',
                '-y+0.5,x,z+0.5',
                'x+0.5,z,-y+0.5',
                '-x+0.5,z,y+0.5',
                '-x+0.5,-z,-y+0.5',
                'x+0.5,-z,y+0.5',
                'z+0.5,y,-x+0.5',
                'z+0.5,-y,x+0.5',
                '-z+0.5,y,x+0.5',
                '-z+0.5,-y,-x+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                '-z+0.5,-x,-y+0.5',
                '-z+0.5,x,y+0.5',
                'z+0.5,x,-y+0.5',
                'z+0.5,-x,y+0.5',
                '-y+0.5,-z,-x+0.5',
                'y+0.5,-z,x+0.5',
                '-y+0.5,z,x+0.5',
                'y+0.5,z,-x+0.5',
                '-y+0.5,-x,z+0.5',
                'y+0.5,x,z+0.5',
                '-y+0.5,x,-z+0.5',
                'y+0.5,-x,-z+0.5',
                '-x+0.5,-z,y+0.5',
                'x+0.5,-z,-y+0.5',
                'x+0.5,z,y+0.5',
                '-x+0.5,z,-y+0.5',
                '-z+0.5,-y,x+0.5',
                '-z+0.5,y,-x+0.5',
                'z+0.5,-y,-x+0.5',
                'z+0.5,y,x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y+0.5,x+0.5,-z',
                '-y+0.5,-x+0.5,-z',
                'y+0.5,-x+0.5,z',
                '-y+0.5,x+0.5,z',
                'x+0.5,z+0.5,-y',
                '-x+0.5,z+0.5,y',
                '-x+0.5,-z+0.5,-y',
                'x+0.5,-z+0.5,y',
                'z+0.5,y+0.5,-x',
                'z+0.5,-y+0.5,x',
                '-z+0.5,y+0.5,x',
                '-z+0.5,-y+0.5,-x',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-z+0.5,-x+0.5,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x+0.5,y',
                '-y+0.5,-z+0.5,-x',
                'y+0.5,-z+0.5,x',
                '-y+0.5,z+0.5,x',
                'y+0.5,z+0.5,-x',
                '-y+0.5,-x+0.5,z',
                'y+0.5,x+0.5,z',
                '-y+0.5,x+0.5,-z',
                'y+0.5,-x+0.5,-z',
                '-x+0.5,-z+0.5,y',
                'x+0.5,-z+0.5,-y',
                'x+0.5,z+0.5,y',
                '-x+0.5,z+0.5,-y',
                '-z+0.5,-y+0.5,x',
                '-z+0.5,y+0.5,-x',
                'z+0.5,-y+0.5,-x',
                'z+0.5,y+0.5,x'],
            'F m -3 c':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                'z+0.5,y+0.5,x+0.5',
                'x,y+0.5,z+0.5',
                '-x,-y+0.5,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x,-y+0.5,-z+0.5',
                'z,x+0.5,y+0.5',
                'z,-x+0.5,-y+0.5',
                '-z,-x+0.5,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z+0.5,x+0.5',
                '-y,z+0.5,-x+0.5',
                'y,-z+0.5,-x+0.5',
                '-y,-z+0.5,x+0.5',
                'y+0.5,x,-z',
                '-y+0.5,-x,-z',
                'y+0.5,-x,z',
                '-y+0.5,x,z',
                'x+0.5,z,-y',
                '-x+0.5,z,y',
                '-x+0.5,-z,-y',
                'x+0.5,-z,y',
                'z+0.5,y,-x',
                'z+0.5,-y,x',
                '-z+0.5,y,x',
                '-z+0.5,-y,-x',
                '-x,-y+0.5,-z+0.5',
                'x,y+0.5,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x,y+0.5,z+0.5',
                '-z,-x+0.5,-y+0.5',
                '-z,x+0.5,y+0.5',
                'z,x+0.5,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z+0.5,-x+0.5',
                'y,-z+0.5,x+0.5',
                '-y,z+0.5,x+0.5',
                'y,z+0.5,-x+0.5',
                '-y+0.5,-x,z',
                'y+0.5,x,z',
                '-y+0.5,x,-z',
                'y+0.5,-x,-z',
                '-x+0.5,-z,y',
                'x+0.5,-z,-y',
                'x+0.5,z,y',
                '-x+0.5,z,-y',
                '-z+0.5,-y,x',
                '-z+0.5,y,-x',
                'z+0.5,-y,-x',
                'z+0.5,y,x',
                'x+0.5,y,z+0.5',
                '-x+0.5,-y,z+0.5',
                '-x+0.5,y,-z+0.5',
                'x+0.5,-y,-z+0.5',
                'z+0.5,x,y+0.5',
                'z+0.5,-x,-y+0.5',
                '-z+0.5,-x,y+0.5',
                '-z+0.5,x,-y+0.5',
                'y+0.5,z,x+0.5',
                '-y+0.5,z,-x+0.5',
                'y+0.5,-z,-x+0.5',
                '-y+0.5,-z,x+0.5',
                'y,x+0.5,-z',
                '-y,-x+0.5,-z',
                'y,-x+0.5,z',
                '-y,x+0.5,z',
                'x,z+0.5,-y',
                '-x,z+0.5,y',
                '-x,-z+0.5,-y',
                'x,-z+0.5,y',
                'z,y+0.5,-x',
                'z,-y+0.5,x',
                '-z,y+0.5,x',
                '-z,-y+0.5,-x',
                '-x+0.5,-y,-z+0.5',
                'x+0.5,y,-z+0.5',
                'x+0.5,-y,z+0.5',
                '-x+0.5,y,z+0.5',
                '-z+0.5,-x,-y+0.5',
                '-z+0.5,x,y+0.5',
                'z+0.5,x,-y+0.5',
                'z+0.5,-x,y+0.5',
                '-y+0.5,-z,-x+0.5',
                'y+0.5,-z,x+0.5',
                '-y+0.5,z,x+0.5',
                'y+0.5,z,-x+0.5',
                '-y,-x+0.5,z',
                'y,x+0.5,z',
                '-y,x+0.5,-z',
                'y,-x+0.5,-z',
                '-x,-z+0.5,y',
                'x,-z+0.5,-y',
                'x,z+0.5,y',
                '-x,z+0.5,-y',
                '-z,-y+0.5,x',
                '-z,y+0.5,-x',
                'z,-y+0.5,-x',
                'z,y+0.5,x',
                'x+0.5,y+0.5,z',
                '-x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,-z',
                'z+0.5,x+0.5,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x+0.5,y',
                '-z+0.5,x+0.5,-y',
                'y+0.5,z+0.5,x',
                '-y+0.5,z+0.5,-x',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z+0.5,x',
                'y,x,-z+0.5',
                '-y,-x,-z+0.5',
                'y,-x,z+0.5',
                '-y,x,z+0.5',
                'x,z,-y+0.5',
                '-x,z,y+0.5',
                '-x,-z,-y+0.5',
                'x,-z,y+0.5',
                'z,y,-x+0.5',
                'z,-y,x+0.5',
                '-z,y,x+0.5',
                '-z,-y,-x+0.5',
                '-x+0.5,-y+0.5,-z',
                'x+0.5,y+0.5,-z',
                'x+0.5,-y+0.5,z',
                '-x+0.5,y+0.5,z',
                '-z+0.5,-x+0.5,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x+0.5,-y',
                'z+0.5,-x+0.5,y',
                '-y+0.5,-z+0.5,-x',
                'y+0.5,-z+0.5,x',
                '-y+0.5,z+0.5,x',
                'y+0.5,z+0.5,-x',
                '-y,-x,z+0.5',
                'y,x,z+0.5',
                '-y,x,-z+0.5',
                'y,-x,-z+0.5',
                '-x,-z,y+0.5',
                'x,-z,-y+0.5',
                'x,z,y+0.5',
                '-x,z,-y+0.5',
                '-z,-y,x+0.5',
                '-z,y,-x+0.5',
                'z,-y,-x+0.5',
                'z,y,x+0.5'],
            'F d -3 m':['x,y,z',
                '-x+0.75,-y+0.25,z+0.5',
                '-x+0.25,y+0.5,-z+0.75',
                'x+0.5,-y+0.75,-z+0.25',
                'z,x,y',
                'z+0.5,-x+0.75,-y+0.25',
                '-z+0.75,-x+0.25,y+0.5',
                '-z+0.25,x+0.5,-y+0.75',
                'y,z,x',
                '-y+0.25,z+0.5,-x+0.75',
                'y+0.5,-z+0.75,-x+0.25',
                '-y+0.75,-z+0.25,x+0.5',
                'y+0.75,x+0.25,-z+0.5',
                '-y,-x,-z',
                'y+0.25,-x+0.5,z+0.75',
                '-y+0.5,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.5',
                '-x+0.5,z+0.75,y+0.25',
                '-x,-z,-y',
                'x+0.25,-z+0.5,y+0.75',
                'z+0.75,y+0.25,-x+0.5',
                'z+0.25,-y+0.5,x+0.75',
                '-z+0.5,y+0.75,x+0.25',
                '-z,-y,-x',
                '-x,-y,-z',
                'x+0.25,y+0.75,-z+0.5',
                'x+0.75,-y+0.5,z+0.25',
                '-x+0.5,y+0.25,z+0.75',
                '-z,-x,-y',
                '-z+0.5,x+0.25,y+0.75',
                'z+0.25,x+0.75,-y+0.5',
                'z+0.75,-x+0.5,y+0.25',
                '-y,-z,-x',
                'y+0.75,-z+0.5,x+0.25',
                '-y+0.5,z+0.25,x+0.75',
                'y+0.25,z+0.75,-x+0.5',
                '-y+0.25,-x+0.75,z+0.5',
                'y,x,z',
                '-y+0.75,x+0.5,-z+0.25',
                'y+0.5,-x+0.25,-z+0.75',
                '-x+0.25,-z+0.75,y+0.5',
                'x+0.5,-z+0.25,-y+0.75',
                'x,z,y',
                '-x+0.75,z+0.5,-y+0.25',
                '-z+0.25,-y+0.75,x+0.5',
                '-z+0.75,y+0.5,-x+0.25',
                'z+0.5,-y+0.25,-x+0.75',
                'z,y,x',
                'x,y+0.5,z+0.5',
                '-x+0.75,-y+0.75,z',
                '-x+0.25,y,-z+0.25',
                'x+0.5,-y+0.25,-z+0.75',
                'z,x+0.5,y+0.5',
                'z+0.5,-x+0.25,-y+0.75',
                '-z+0.75,-x+0.75,y',
                '-z+0.25,x,-y+0.25',
                'y,z+0.5,x+0.5',
                '-y+0.25,z,-x+0.25',
                'y+0.5,-z+0.25,-x+0.75',
                '-y+0.75,-z+0.75,x',
                'y+0.75,x+0.75,-z',
                '-y,-x+0.5,-z+0.5',
                'y+0.25,-x,z+0.25',
                '-y+0.5,x+0.25,z+0.75',
                'x+0.75,z+0.75,-y',
                '-x+0.5,z+0.25,y+0.75',
                '-x,-z+0.5,-y+0.5',
                'x+0.25,-z,y+0.25',
                'z+0.75,y+0.75,-x',
                'z+0.25,-y,x+0.25',
                '-z+0.5,y+0.25,x+0.75',
                '-z,-y+0.5,-x+0.5',
                '-x,-y+0.5,-z+0.5',
                'x+0.25,y+0.25,-z',
                'x+0.75,-y,z+0.75',
                '-x+0.5,y+0.75,z+0.25',
                '-z,-x+0.5,-y+0.5',
                '-z+0.5,x+0.75,y+0.25',
                'z+0.25,x+0.25,-y',
                'z+0.75,-x,y+0.75',
                '-y,-z+0.5,-x+0.5',
                'y+0.75,-z,x+0.75',
                '-y+0.5,z+0.75,x+0.25',
                'y+0.25,z+0.25,-x',
                '-y+0.25,-x+0.25,z',
                'y,x+0.5,z+0.5',
                '-y+0.75,x,-z+0.75',
                'y+0.5,-x+0.75,-z+0.25',
                '-x+0.25,-z+0.25,y',
                'x+0.5,-z+0.75,-y+0.25',
                'x,z+0.5,y+0.5',
                '-x+0.75,z,-y+0.75',
                '-z+0.25,-y+0.25,x',
                '-z+0.75,y,-x+0.75',
                'z+0.5,-y+0.75,-x+0.25',
                'z,y+0.5,x+0.5',
                'x+0.5,y,z+0.5',
                '-x+0.25,-y+0.25,z',
                '-x+0.75,y+0.5,-z+0.25',
                'x,-y+0.75,-z+0.75',
                'z+0.5,x,y+0.5',
                'z,-x+0.75,-y+0.75',
                '-z+0.25,-x+0.25,y',
                '-z+0.75,x+0.5,-y+0.25',
                'y+0.5,z,x+0.5',
                '-y+0.75,z+0.5,-x+0.25',
                'y,-z+0.75,-x+0.75',
                '-y+0.25,-z+0.25,x',
                'y+0.25,x+0.25,-z',
                '-y+0.5,-x,-z+0.5',
                'y+0.75,-x+0.5,z+0.25',
                '-y,x+0.75,z+0.75',
                'x+0.25,z+0.25,-y',
                '-x,z+0.75,y+0.75',
                '-x+0.5,-z,-y+0.5',
                'x+0.75,-z+0.5,y+0.25',
                'z+0.25,y+0.25,-x',
                'z+0.75,-y+0.5,x+0.25',
                '-z,y+0.75,x+0.75',
                '-z+0.5,-y,-x+0.5',
                '-x+0.5,-y,-z+0.5',
                'x+0.75,y+0.75,-z',
                'x+0.25,-y+0.5,z+0.75',
                '-x,y+0.25,z+0.25',
                '-z+0.5,-x,-y+0.5',
                '-z,x+0.25,y+0.25',
                'z+0.75,x+0.75,-y',
                'z+0.25,-x+0.5,y+0.75',
                '-y+0.5,-z,-x+0.5',
                'y+0.25,-z+0.5,x+0.75',
                '-y,z+0.25,x+0.25',
                'y+0.75,z+0.75,-x',
                '-y+0.75,-x+0.75,z',
                'y+0.5,x,z+0.5',
                '-y+0.25,x+0.5,-z+0.75',
                'y,-x+0.25,-z+0.25',
                '-x+0.75,-z+0.75,y',
                'x,-z+0.25,-y+0.25',
                'x+0.5,z,y+0.5',
                '-x+0.25,z+0.5,-y+0.75',
                '-z+0.75,-y+0.75,x',
                '-z+0.25,y+0.5,-x+0.75',
                'z,-y+0.25,-x+0.25',
                'z+0.5,y,x+0.5',
                'x+0.5,y+0.5,z',
                '-x+0.25,-y+0.75,z+0.5',
                '-x+0.75,y,-z+0.75',
                'x,-y+0.25,-z+0.25',
                'z+0.5,x+0.5,y',
                'z,-x+0.25,-y+0.25',
                '-z+0.25,-x+0.75,y+0.5',
                '-z+0.75,x,-y+0.75',
                'y+0.5,z+0.5,x',
                '-y+0.75,z,-x+0.75',
                'y,-z+0.25,-x+0.25',
                '-y+0.25,-z+0.75,x+0.5',
                'y+0.25,x+0.75,-z+0.5',
                '-y+0.5,-x+0.5,-z',
                'y+0.75,-x,z+0.75',
                '-y,x+0.25,z+0.25',
                'x+0.25,z+0.75,-y+0.5',
                '-x,z+0.25,y+0.25',
                '-x+0.5,-z+0.5,-y',
                'x+0.75,-z,y+0.75',
                'z+0.25,y+0.75,-x+0.5',
                'z+0.75,-y,x+0.75',
                '-z,y+0.25,x+0.25',
                '-z+0.5,-y+0.5,-x',
                '-x+0.5,-y+0.5,-z',
                'x+0.75,y+0.25,-z+0.5',
                'x+0.25,-y,z+0.25',
                '-x,y+0.75,z+0.75',
                '-z+0.5,-x+0.5,-y',
                '-z,x+0.75,y+0.75',
                'z+0.75,x+0.25,-y+0.5',
                'z+0.25,-x,y+0.25',
                '-y+0.5,-z+0.5,-x',
                'y+0.25,-z,x+0.25',
                '-y,z+0.75,x+0.75',
                'y+0.75,z+0.25,-x+0.5',
                '-y+0.75,-x+0.25,z+0.5',
                'y+0.5,x+0.5,z',
                '-y+0.25,x,-z+0.25',
                'y,-x+0.75,-z+0.75',
                '-x+0.75,-z+0.25,y+0.5',
                'x,-z+0.75,-y+0.75',
                'x+0.5,z+0.5,y',
                '-x+0.25,z,-y+0.25',
                '-z+0.75,-y+0.25,x+0.5',
                '-z+0.25,y,-x+0.25',
                'z,-y+0.75,-x+0.75',
                'z+0.5,y+0.5,x'],
            'F d -3 c':['x,y,z',
                '-x+0.25,-y+0.75,z+0.5',
                '-x+0.75,y+0.5,-z+0.25',
                'x+0.5,-y+0.25,-z+0.75',
                'z,x,y',
                'z+0.5,-x+0.25,-y+0.75',
                '-z+0.25,-x+0.75,y+0.5',
                '-z+0.75,x+0.5,-y+0.25',
                'y,z,x',
                '-y+0.75,z+0.5,-x+0.25',
                'y+0.5,-z+0.25,-x+0.75',
                '-y+0.25,-z+0.75,x+0.5',
                'y+0.75,x+0.25,-z',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.25,-x,z+0.75',
                '-y,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y',
                '-x,z+0.75,y+0.25',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.25,-z,y+0.75',
                'z+0.75,y+0.25,-x',
                'z+0.25,-y,x+0.75',
                '-z,y+0.75,x+0.25',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x,-y,-z',
                'x+0.75,y+0.25,-z+0.5',
                'x+0.25,-y+0.5,z+0.75',
                '-x+0.5,y+0.75,z+0.25',
                '-z,-x,-y',
                '-z+0.5,x+0.75,y+0.25',
                'z+0.75,x+0.25,-y+0.5',
                'z+0.25,-x+0.5,y+0.75',
                '-y,-z,-x',
                'y+0.25,-z+0.5,x+0.75',
                '-y+0.5,z+0.75,x+0.25',
                'y+0.75,z+0.25,-x+0.5',
                '-y+0.25,-x+0.75,z',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.75,x,-z+0.25',
                'y,-x+0.25,-z+0.75',
                '-x+0.25,-z+0.75,y',
                'x,-z+0.25,-y+0.75',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.75,z,-y+0.25',
                '-z+0.25,-y+0.75,x',
                '-z+0.75,y,-x+0.25',
                'z,-y+0.25,-x+0.75',
                'z+0.5,y+0.5,x+0.5',
                'x,y+0.5,z+0.5',
                '-x+0.25,-y+0.25,z',
                '-x+0.75,y,-z+0.75',
                'x+0.5,-y+0.75,-z+0.25',
                'z,x+0.5,y+0.5',
                'z+0.5,-x+0.75,-y+0.25',
                '-z+0.25,-x+0.25,y',
                '-z+0.75,x,-y+0.75',
                'y,z+0.5,x+0.5',
                '-y+0.75,z,-x+0.75',
                'y+0.5,-z+0.75,-x+0.25',
                '-y+0.25,-z+0.25,x',
                'y+0.75,x+0.75,-z+0.5',
                '-y+0.5,-x,-z',
                'y+0.25,-x+0.5,z+0.25',
                '-y,x+0.25,z+0.75',
                'x+0.75,z+0.75,-y+0.5',
                '-x,z+0.25,y+0.75',
                '-x+0.5,-z,-y',
                'x+0.25,-z+0.5,y+0.25',
                'z+0.75,y+0.75,-x+0.5',
                'z+0.25,-y+0.5,x+0.25',
                '-z,y+0.25,x+0.75',
                '-z+0.5,-y,-x',
                '-x,-y+0.5,-z+0.5',
                'x+0.75,y+0.75,-z',
                'x+0.25,-y,z+0.25',
                '-x+0.5,y+0.25,z+0.75',
                '-z,-x+0.5,-y+0.5',
                '-z+0.5,x+0.25,y+0.75',
                'z+0.75,x+0.75,-y',
                'z+0.25,-x,y+0.25',
                '-y,-z+0.5,-x+0.5',
                'y+0.25,-z,x+0.25',
                '-y+0.5,z+0.25,x+0.75',
                'y+0.75,z+0.75,-x',
                '-y+0.25,-x+0.25,z+0.5',
                'y+0.5,x,z',
                '-y+0.75,x+0.5,-z+0.75',
                'y,-x+0.75,-z+0.25',
                '-x+0.25,-z+0.25,y+0.5',
                'x,-z+0.75,-y+0.25',
                'x+0.5,z,y',
                '-x+0.75,z+0.5,-y+0.75',
                '-z+0.25,-y+0.25,x+0.5',
                '-z+0.75,y+0.5,-x+0.75',
                'z,-y+0.75,-x+0.25',
                'z+0.5,y,x',
                'x+0.5,y,z+0.5',
                '-x+0.75,-y+0.75,z',
                '-x+0.25,y+0.5,-z+0.75',
                'x,-y+0.25,-z+0.25',
                'z+0.5,x,y+0.5',
                'z,-x+0.25,-y+0.25',
                '-z+0.75,-x+0.75,y',
                '-z+0.25,x+0.5,-y+0.75',
                'y+0.5,z,x+0.5',
                '-y+0.25,z+0.5,-x+0.75',
                'y,-z+0.25,-x+0.25',
                '-y+0.75,-z+0.75,x',
                'y+0.25,x+0.25,-z+0.5',
                '-y,-x+0.5,-z',
                'y+0.75,-x,z+0.25',
                '-y+0.5,x+0.75,z+0.75',
                'x+0.25,z+0.25,-y+0.5',
                '-x+0.5,z+0.75,y+0.75',
                '-x,-z+0.5,-y',
                'x+0.75,-z,y+0.25',
                'z+0.25,y+0.25,-x+0.5',
                'z+0.75,-y,x+0.25',
                '-z+0.5,y+0.75,x+0.75',
                '-z,-y+0.5,-x',
                '-x+0.5,-y,-z+0.5',
                'x+0.25,y+0.25,-z',
                'x+0.75,-y+0.5,z+0.25',
                '-x,y+0.75,z+0.75',
                '-z+0.5,-x,-y+0.5',
                '-z,x+0.75,y+0.75',
                'z+0.25,x+0.25,-y',
                'z+0.75,-x+0.5,y+0.25',
                '-y+0.5,-z,-x+0.5',
                'y+0.75,-z+0.5,x+0.25',
                '-y,z+0.75,x+0.75',
                'y+0.25,z+0.25,-x',
                '-y+0.75,-x+0.75,z+0.5',
                'y,x+0.5,z',
                '-y+0.25,x,-z+0.75',
                'y+0.5,-x+0.25,-z+0.25',
                '-x+0.75,-z+0.75,y+0.5',
                'x+0.5,-z+0.25,-y+0.25',
                'x,z+0.5,y',
                '-x+0.25,z,-y+0.75',
                '-z+0.75,-y+0.75,x+0.5',
                '-z+0.25,y,-x+0.75',
                'z+0.5,-y+0.25,-x+0.25',
                'z,y+0.5,x',
                'x+0.5,y+0.5,z',
                '-x+0.75,-y+0.25,z+0.5',
                '-x+0.25,y,-z+0.25',
                'x,-y+0.75,-z+0.75',
                'z+0.5,x+0.5,y',
                'z,-x+0.75,-y+0.75',
                '-z+0.75,-x+0.25,y+0.5',
                '-z+0.25,x,-y+0.25',
                'y+0.5,z+0.5,x',
                '-y+0.25,z,-x+0.25',
                'y,-z+0.75,-x+0.75',
                '-y+0.75,-z+0.25,x+0.5',
                'y+0.25,x+0.75,-z',
                '-y,-x,-z+0.5',
                'y+0.75,-x+0.5,z+0.75',
                '-y+0.5,x+0.25,z+0.25',
                'x+0.25,z+0.75,-y',
                '-x+0.5,z+0.25,y+0.25',
                '-x,-z,-y+0.5',
                'x+0.75,-z+0.5,y+0.75',
                'z+0.25,y+0.75,-x',
                'z+0.75,-y+0.5,x+0.75',
                '-z+0.5,y+0.25,x+0.25',
                '-z,-y,-x+0.5',
                '-x+0.5,-y+0.5,-z',
                'x+0.25,y+0.75,-z+0.5',
                'x+0.75,-y,z+0.75',
                '-x,y+0.25,z+0.25',
                '-z+0.5,-x+0.5,-y',
                '-z,x+0.25,y+0.25',
                'z+0.25,x+0.75,-y+0.5',
                'z+0.75,-x,y+0.75',
                '-y+0.5,-z+0.5,-x',
                'y+0.75,-z,x+0.75',
                '-y,z+0.25,x+0.25',
                'y+0.25,z+0.75,-x+0.5',
                '-y+0.75,-x+0.25,z',
                'y,x,z+0.5',
                '-y+0.25,x+0.5,-z+0.25',
                'y+0.5,-x+0.75,-z+0.75',
                '-x+0.75,-z+0.25,y',
                'x+0.5,-z+0.75,-y+0.75',
                'x,z,y+0.5',
                '-x+0.25,z+0.5,-y+0.25',
                '-z+0.75,-y+0.25,x',
                '-z+0.25,y+0.5,-x+0.25',
                'z+0.5,-y+0.75,-x+0.75',
                'z,y,x+0.5'],
            'I m -3 m':['x,y,z',
                '-x,-y,z',
                '-x,y,-z',
                'x,-y,-z',
                'z,x,y',
                'z,-x,-y',
                '-z,-x,y',
                '-z,x,-y',
                'y,z,x',
                '-y,z,-x',
                'y,-z,-x',
                '-y,-z,x',
                'y,x,-z',
                '-y,-x,-z',
                'y,-x,z',
                '-y,x,z',
                'x,z,-y',
                '-x,z,y',
                '-x,-z,-y',
                'x,-z,y',
                'z,y,-x',
                'z,-y,x',
                '-z,y,x',
                '-z,-y,-x',
                '-x,-y,-z',
                'x,y,-z',
                'x,-y,z',
                '-x,y,z',
                '-z,-x,-y',
                '-z,x,y',
                'z,x,-y',
                'z,-x,y',
                '-y,-z,-x',
                'y,-z,x',
                '-y,z,x',
                'y,z,-x',
                '-y,-x,z',
                'y,x,z',
                '-y,x,-z',
                'y,-x,-z',
                '-x,-z,y',
                'x,-z,-y',
                'x,z,y',
                '-x,z,-y',
                '-z,-y,x',
                '-z,y,-x',
                'z,-y,-x',
                'z,y,x',
                'x+0.5,y+0.5,z+0.5',
                '-x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,-x+0.5,y+0.5',
                '-z+0.5,x+0.5,-y+0.5',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x+0.5',
                '-y+0.5,-z+0.5,x+0.5',
                'y+0.5,x+0.5,-z+0.5',
                '-y+0.5,-x+0.5,-z+0.5',
                'y+0.5,-x+0.5,z+0.5',
                '-y+0.5,x+0.5,z+0.5',
                'x+0.5,z+0.5,-y+0.5',
                '-x+0.5,z+0.5,y+0.5',
                '-x+0.5,-z+0.5,-y+0.5',
                'x+0.5,-z+0.5,y+0.5',
                'z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,x+0.5',
                '-z+0.5,-y+0.5,-x+0.5',
                '-x+0.5,-y+0.5,-z+0.5',
                'x+0.5,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z+0.5',
                '-z+0.5,-x+0.5,-y+0.5',
                '-z+0.5,x+0.5,y+0.5',
                'z+0.5,x+0.5,-y+0.5',
                'z+0.5,-x+0.5,y+0.5',
                '-y+0.5,-z+0.5,-x+0.5',
                'y+0.5,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x+0.5',
                'y+0.5,z+0.5,-x+0.5',
                '-y+0.5,-x+0.5,z+0.5',
                'y+0.5,x+0.5,z+0.5',
                '-y+0.5,x+0.5,-z+0.5',
                'y+0.5,-x+0.5,-z+0.5',
                '-x+0.5,-z+0.5,y+0.5',
                'x+0.5,-z+0.5,-y+0.5',
                'x+0.5,z+0.5,y+0.5',
                '-x+0.5,z+0.5,-y+0.5',
                '-z+0.5,-y+0.5,x+0.5',
                '-z+0.5,y+0.5,-x+0.5',
                'z+0.5,-y+0.5,-x+0.5',
                'z+0.5,y+0.5,x+0.5'],
            'I a -3 d':['x,y,z',
                '-x+0.5,-y,z+0.5',
                '-x,y+0.5,-z+0.5',
                'x+0.5,-y+0.5,-z',
                'z,x,y',
                'z+0.5,-x+0.5,-y',
                '-z+0.5,-x,y+0.5',
                '-z,x+0.5,-y+0.5',
                'y,z,x',
                '-y,z+0.5,-x+0.5',
                'y+0.5,-z+0.5,-x',
                '-y+0.5,-z,x+0.5',
                'y+0.75,x+0.25,-z+0.25',
                '-y+0.75,-x+0.75,-z+0.75',
                'y+0.25,-x+0.25,z+0.75',
                '-y+0.25,x+0.75,z+0.25',
                'x+0.75,z+0.25,-y+0.25',
                '-x+0.25,z+0.75,y+0.25',
                '-x+0.75,-z+0.75,-y+0.75',
                'x+0.25,-z+0.25,y+0.75',
                'z+0.75,y+0.25,-x+0.25',
                'z+0.25,-y+0.25,x+0.75',
                '-z+0.25,y+0.75,x+0.25',
                '-z+0.75,-y+0.75,-x+0.75',
                '-x,-y,-z',
                'x+0.5,y,-z+0.5',
                'x,-y+0.5,z+0.5',
                '-x+0.5,y+0.5,z',
                '-z,-x,-y',
                '-z+0.5,x+0.5,y',
                'z+0.5,x,-y+0.5',
                'z,-x+0.5,y+0.5',
                '-y,-z,-x',
                'y,-z+0.5,x+0.5',
                '-y+0.5,z+0.5,x',
                'y+0.5,z,-x+0.5',
                '-y+0.25,-x+0.75,z+0.75',
                'y+0.25,x+0.25,z+0.25',
                '-y+0.75,x+0.75,-z+0.25',
                'y+0.75,-x+0.25,-z+0.75',
                '-x+0.25,-z+0.75,y+0.75',
                'x+0.75,-z+0.25,-y+0.75',
                'x+0.25,z+0.25,y+0.25',
                '-x+0.75,z+0.75,-y+0.25',
                '-z+0.25,-y+0.75,x+0.75',
                '-z+0.75,y+0.75,-x+0.25',
                'z+0.75,-y+0.25,-x+0.75',
                'z+0.25,y+0.25,x+0.25',
                'x+0.5,y+0.5,z+0.5',
                '-x,-y+0.5,z',
                '-x+0.5,y,-z',
                'x,-y,-z+0.5',
                'z+0.5,x+0.5,y+0.5',
                'z,-x,-y+0.5',
                '-z,-x+0.5,y',
                '-z+0.5,x,-y',
                'y+0.5,z+0.5,x+0.5',
                '-y+0.5,z,-x',
                'y,-z,-x+0.5',
                '-y,-z+0.5,x',
                'y+0.25,x+0.75,-z+0.75',
                '-y+0.25,-x+0.25,-z+0.25',
                'y+0.75,-x+0.75,z+0.25',
                '-y+0.75,x+0.25,z+0.75',
                'x+0.25,z+0.75,-y+0.75',
                '-x+0.75,z+0.25,y+0.75',
                '-x+0.25,-z+0.25,-y+0.25',
                'x+0.75,-z+0.75,y+0.25',
                'z+0.25,y+0.75,-x+0.75',
                'z+0.75,-y+0.75,x+0.25',
                '-z+0.75,y+0.25,x+0.75',
                '-z+0.25,-y+0.25,-x+0.25',
                '-x+0.5,-y+0.5,-z+0.5',
                'x,y+0.5,-z',
                'x+0.5,-y,z',
                '-x,y,z+0.5',
                '-z+0.5,-x+0.5,-y+0.5',
                '-z,x,y+0.5',
                'z,x+0.5,-y',
                'z+0.5,-x,y',
                '-y+0.5,-z+0.5,-x+0.5',
                'y+0.5,-z,x',
                '-y,z,x+0.5',
                'y,z+0.5,-x',
                '-y+0.75,-x+0.25,z+0.25',
                'y+0.75,x+0.75,z+0.75',
                '-y+0.25,x+0.25,-z+0.75',
                'y+0.25,-x+0.75,-z+0.25',
                '-x+0.75,-z+0.25,y+0.25',
                'x+0.25,-z+0.75,-y+0.25',
                'x+0.75,z+0.75,y+0.75',
                '-x+0.25,z+0.25,-y+0.75',
                '-z+0.75,-y+0.25,x+0.25',
                '-z+0.25,y+0.25,-x+0.75',
                'z+0.25,-y+0.75,-x+0.25',
                'z+0.75,y+0.75,x+0.75'],
			'F 1':['x, y, z',
                'x, y+.5, z+.5',
                'x+.5, y, z+.5',
                'x+.5, y+.5, z'],
			'C 1':['x, y, z',
                'x+.5, y+.5, z'],
			'I 1':['x, y, z',
                'x+.5, y+.5, z+.5'],
			'A -1':['-x, -y, -z',
                'x, y, z',
                '-x, -y+.5, -z+.5',
                'x, y+.5, z+.5'],
			'C -1':['-x, -y, -z',
                'x, y, z',
                '-x+.5, -y+.5, -z',
                'x+.5, y+.5, z'],
			'F -1':['-x, -y, -z',
                'x, y, z',
                '-x, -y+.5, -z+.5',
                '-x+.5, -y, -z+.5',
                '-x+.5, -y+.5, -z',
                'x, y+.5, z+.5',
                'x+.5, y, z+.5',
                'x+.5, y+.5, z'],
			'I -1':['-x, -y, -z',
                'x, y, z',
                '-x+.5, -y+.5, -z+.5',
                'x+.5, y+.5, z+.5'],
			'P 1 1 2':['-x, -y, z',
                'x, y, z'],
			'P 1 2 1':['-x, y, -z',
                'x, y, z'],
			'B 1 21 1':['-x, y+.5, -z',
                'x, y, z',
                '-x+.5, y+.5, -z+.5',
 	            'x+.5, y, z+.5'],
			'C 1 1 21':['-x, -y, z+.5',
                'x, y, z',
  	            '-x+.5, -y+.5, z+.5',
  	            'x+.5, y+.5, z'],
			'P 1 1 21':['-x, -y, z+.5',
			    'x, y, z'],
			'P 1 21 1':['-x, y+.5, -z',
			    'x, y, z'],
			'A 1 1 2':['-x, -y, z',
			    'x, y, z',
			    '-x, -y+.5, z+.5',
			    'x, y+.5, z+.5'],
			'A 1 2 1':['-x, y, -z',
			    'x, y, z',
			    '-x, y+.5, -z+.5',
			    'x, y+.5, z+.5'],
			'B 1 1 2':['-x, -y, z',
			    'x, y, z',
			    '-x+.5, -y, z+.5',
			    'x+.5, y, z+.5'],
			'B 2':['x,y,z',
                'x,-y,-z',
                'x+1/2,y,z+1/2',
                'x+1/2,-y,-z+1/2'],
			'C 1 2 1':['-x, y, -z',
			    'x, y, z',
		        '-x+.5, y+.5, -z',
			    'x+.5, y+.5, z'],
			'F 1 1 2':['-x, -y, z',
			    'x, y, z',
		        '-x, -y+.5, z+.5',
			    '-x+.5, -y, z+.5',
			    '-x+.5, -y+.5, z',
			    'x, y+.5, z+.5',
			    'x+.5, y, z+.5',
			    'x+.5, y+.5, z'],
			'F 1 2 1':['-x, y, -z',
                'x, y, z',
                '-x, y+.5, -z+.5',
                '-x+.5, y, -z+.5',
                '-x+.5, y+.5, -z',
                'x, y+.5, z+.5',
                'x+.5, y, z+.5',
                'x+.5, y+.5, z'],
			'I 1 1 2':['-x, -y, z',
                'x, y, z',
                '-x+.5, -y+.5, z+.5',
                'x+.5, y+.5, z+.5'],
			'I 1 2 1':['-x, y, -z',
         	    'x, y, z',
                '-x+.5, y+.5, -z+.5',
                'x+.5, y+.5, z+.5'],
			'I 2':['x,y,z',
                'x,-y,-z',
                'x+1/2,y+1/2,z+1/2',
                'x+1/2,-y+1/2,-z+1/2'],
			'P 1 m 1':['x, -y, z',
			    'x, y, z'],
			'P 1 1 m':['x, y, -z',
			    'x, y, z'],
			'B 1 a 1':['x+.5, -y+.5, z',
                'x, y, z',
                'x, -y+.5, z+.5',
                'x+.5, y, z+.5'],
			'P 1 a 1':['x+.5, -y, z',
                'x, y, z'],
			'P 1 c 1':['x, -y, z+.5',
                'x, y, z'],
			'P 1 n 1':['x+.5, -y, z+.5',
                'x, y, z'],
			'P 1 1 a':['x+.5, y, -z',
                'x, y, z'],
			'P 1 1 b':['x, y+.5, -z',
                'x, y, z'],
			'P 1 1 n':['x+.5, y+.5, -z',
                'x, y, z'],
			'P b':['x,y,z',
		        '-x,y+1/2,z'],
			'P n 1 1':['-x, y+.5, z+.5',
                'x, y, z'],
			'A 1 m 1':['x, -y, z',
                'x, y, z',
                'x, -y+.5, z+.5',
                'x, y+.5, z+.5'],
			'A 1 1 m':['x, y, -z',
                'x, y, z',
                'x, y+.5, -z+.5',
                'x, y+.5, z+.5'],
			'B 1 1 m':['x, y, -z',
                'x, y, z',
                'x+.5, y, -z+.5',
                'x+.5, y, z+.5'],
			'B m 1 1':['-x, y, z',
                'x, y, z',
                '-x+.5, y, z+.5',
                'x+.5, y, z+.5'],
			'C 1 m 1':['x, -y, z',
                'x, y, z',
                'x+.5, -y+.5, z',
                'x+.5, y+.5, z'],
			'F m 1 1':['-x, y, z',
                'x, y, z',
                '-x, y+.5, z+.5',
                '-x+.5, y, z+.5',
                '-x+.5, y+.5, z',
                'x, y+.5, z+.5',
                'x+.5, y, z+.5',
                'x+.5, y+.5, z'],
			'I 1 m 1':['x, -y, z',
                'x, y, z',
                'x+.5, -y+.5, z+.5',
                'x+.5, y+.5, z+.5'],
			'I 1 1 m':['x, y, -z',
                'x, y, z',
                'x+.5, y+.5, -z+.5',
                'x+.5, y+.5, z+.5'],
			'I m':['x,y,z',
			    '-x,y,z',
				'x+1/2,y+1/2,z+1/2',
				'-x+1/2,y+1/2,z+1/2'],
			'A 1 a 1':['x+.5, -y, z',
                'x, y, z',
                'x+.5, -y+.5, z+.5',
                'x, y+.5, z+.5'],
			'A 1 n 1':['x+.5, -y, z+.5',
                'x, y, z',
                'x+.5, -y+.5, z',
                'x, y+.5, z+.5'],
			'A 1 1 a':['x+.5, y, -z',
                'x, y, z',
                'x+.5, y+.5, -z+.5',
                'x, y+.5, z+.5'],
			'A 1 1 n':['x,y,z',
			    'x+1/2,y+1/2,-z',
				'x,y+1/2,z+1/2',
				'x+1/2,y,-z+1/2'],
			'B 1 1 b':['x, y+.5, -z',
                'x, y, z',
                'x+.5, y+.5, -z+.5',
                'x+.5, y, z+.5'],
			'B 1 1 n':['x,y,z',
			    'x+1/2,y+1/2,-z',
				'x+1/2,y,z+1/2',
				'x,y+1/2,-z+1/2'],
			'B b 1 1':['x,y,z',
			    '-x,y+1/2,z',
				'x+1/2,y,z+1/2',
				'-x+1/2,y+1/2,z+1/2'],
			'B n 1 1':['x,y,z',
			    '-x,y+1/2,z+1/2',
				'x+1/2,y,z+1/2',
				'-x+1/2,y+1/2,z'],
			'C 1 c 1':['x, -y, z+.5',
                'x, y, z',
                'x+.5, -y+.5, z+.5',
                'x+.5, y+.5, z'],
			'C 1 n 1':['x,y,z',
			    'x+1/2,-y,z+1/2',
				'x+1/2,y+1/2,z',
				'x,-y+1/2,z+1/2'],
			'C n 1 1':['x,y,z',
			    '-x,y+1/2,z+1/2',
				'x+1/2,y+1/2,z',
				'-x+1/2,y,z+1/2'],
			'F 1 d 1':['x+.25, -y+.25, z+.25',
                'x, y, z',
                'x+.25, -y+.75, z+.75',
                'x+.75, -y+.25, z+.75',
                'x+.75, -y+.75, z+.25',
                'x, y+.5, z+.5',
                'x+.5, y, z+.5',
                'x+.5, y+.5, z'],
			'I 1 a 1':['x+.5, -y, z',
                'x, y, z',
                'x, -y+.5, z+.5',
                'x+.5, y+.5, z+.5'],
			'I 1 c 1':['x, -y, z+.5',
                'x, y, z',
                'x+.5, -y+.5, z',
                'x+.5, y+.5, z+.5'],
			'I 1 1 a':['x,y,z',
			    'x+1/2,y,-z',
				'x+1/2,y+1/2,z+1/2',
				'x,y+1/2,-z+1/2'],
			'I 1 1 b':['x, y+.5, -z',
                'x, y, z',
                'x+.5, y, -z+.5',
                'x+.5, y+.5, z+.5'],
			'I b 1 1':['x,y,z',
			    '-x,y+1/2,z',
				'x+1/2,y+1/2,z+1/2',
				'-x+1/2,y,z+1/2'],
			'I c 1 1':['x,y,z',
			    '-x,y,z+1/2',
				'x+1/2,y+1/2,z+1/2',
				'-x+1/2,y+1/2,z'],
			'C 1 1 2/m':['x, y, -z',
                '-x, -y, -z',
                '-x, -y, z',
                'x, y, z',
                'x+.5, y+.5, -z',
                '-x+.5, -y+.5, -z',
                '-x+.5, -y+.5, z',
                'x+.5, y+.5, z'],
			'P 1 2/m 1':['-x, y, -z',
                '-x, -y, -z',
                'x, -y, z',
                'x, y, z'],
			'P 1 1 2/m':['-x, -y, z',
                '-x, -y, -z',
                'x, y, -z',
                'x, y, z'],
			'B 1 21/m 1':['x, -y+.5, z',
                '-x, y+.5, -z',
                '-x, -y, -z',
                'x, y, z',
                'x+.5, -y+.5, z+.5',
                '-x+.5, y+.5, -z+.5',
                '-x+.5, -y, -z+.5',
                'x+.5, y, z+.5'],
			'C 1 1 21/m':['-x, -y, z+.5',
                'x, y, -z+.5',
                '-x, -y, -z',
                'x, y, z',
                '-x+.5, -y+.5, z+.5',
                'x+.5, y+.5, -z+.5',
                '-x+.5, -y+.5, -z',
                'x+.5, y+.5, z'],
			'P 1 21/m 1':['x, -y+.5, z',
                '-x, -y, -z',
                '-x, y+.5, -z',
                'x, y, z'],
			'P 1 1 21/m':['x, y, -z+.5',
                '-x, -y, -z',
                '-x, -y, z+.5',
                'x, y, z'],
			'A 1 2/m 1':['x, -y, z',
                '-x, -y, -z',
                '-x, y, -z',
                'x, y, z',
                'x, -y+.5, z+.5',
                '-x, -y+.5, -z+.5',
                '-x, y+.5, -z+.5',
                'x, y+.5, z+.5'],
			'A 1 1 2/m':['x, y, -z',
                '-x, -y, -z',
                '-x, -y, z',
                'x, y, z',
                'x, y+.5, -z+.5',
                '-x, -y+.5, -z+.5',
                '-x, -y+.5, z+.5',
                'x, y+.5, z+.5'],
			'B 2/m 1 1':['x,y,z',
			    'x,-y,-z',
				'-x,-y,-z',
				'-x,y,z',
				'x+1/2,y,z+1/2',
				'x+1/2,-y,-z+1/2',
				'-x+1/2,-y,-z+1/2',
				'-x+1/2,y,z+1/2'],
			'B 1 1 2/m':['-x, -y, z',
                '-x, -y, -z',
                'x, y, -z',
       	        'x, y, z',
                '-x+.5, -y, z+.5',
                '-x+.5, -y, -z+.5',
                'x+.5, y, -z+.5',
                'x+.5, y, z+.5'],
			'C 1 2/m 1':['-x, y, -z',
                '-x, -y, -z',
                'x, -y, z',
                'x, y, z',
                '-x+.5, y+.5, -z',
                '-x+.5, -y+.5, -z',
                'x+.5, -y+.5, z',
                'x+.5, y+.5, z'],
			'I 1 2/m 1':['x, -y, z',
                '-x, -y, -z',
                '-x, y, -z',
                'x, y, z',
                'x+.5, -y+.5, z+.5',
                '-x+.5, -y+.5, -z+.5',
                '-x+.5, y+.5, -z+.5',
                'x+.5, y+.5, z+.5'],
			'F 1 2/m 1':['-x, -y, -z',
                'x, -y, z',
                '-x, y, -z',
                'x, y, z',
                '-x, -y+.5, -z+.5',
                '-x+.5, -y, -z+.5',
                '-x+.5, -y+.5, -z',
                'x, -y+.5, z+.5',
                'x+.5, -y, z+.5',
                'x+.5, -y+.5, z',
                '-x, y+.5, -z+.5',
                '-x+.5, y, -z+.5',
                '-x+.5, y+.5, -z',
                'x, y+.5, z+.5',
                'x+.5, y, z+.5',
                'x+.5, y+.5, z'],
		    'I 2/m 1 1':['x,y,z',
			    'x,-y,-z',
				'-x,-y,-z',
				'-x,y,z',
				'x+1/2,y+1/2,z+1/2',
				'x+1/2,-y+1/2,-z+1/2',
				'-x+1/2,-y+1/2,-z+1/2',
				'-x+1/2,y+1/2,z+1/2'],
			'I 1 2/m 1':['x, -y, z',
                '-x, -y, -z',
                '-x, y, -z',
                'x, y, z',
                'x+.5, -y+.5, z+.5',
                '-x+.5, -y+.5, -z+.5',
                '-x+.5, y+.5, -z+.5',
                'x+.5, y+.5, z+.5'],
			'B 1 2/c 1':['x, -y, z+.5',
                '-x, y, -z+.5',
                '-x, -y, -z',
                'x, y, z',
                'x+.5, -y, z',
                '-x+.5, y, -z',
                '-x+.5, -y, -z+.5',
                'x+.5, y, z+.5'],
			'C 1 1 2/a':['-x+.5, -y, z',
                'x+.5, y, -z',
                '-x, -y, -z',
                'x, y, z',
                '-x, -y+.5, z',
            	'x, y+.5, -z',
				'-x+.5, -y+.5, -z',
				'x+.5, y+.5, z'],
			'P 2/b 1 1':['x,y,z',
				'x,-y+1/2,-z',
				'-x,-y,-z',
				'-x,y+1/2,z'],
			'P 2/n 1 1':['x,y,z',
				'x,-y+1/2,-z+1/2',
				'-x,-y,-z',
				'-x,y+1/2,z+1/2'],
			'P 1 2/a 1':['x+.5, -y, z',
				'-x, -y, -z',
				'-x+.5, y, -z',
				'x, y, z'],
			'P 1 2/c 1':['x, -y, z+.5',
				'-x, -y, -z',
				'-x, y, -z+.5',
				'x, y, z'],
			'P 1 2/n 1':['x+.5, -y, z+.5',
				'-x+.5, y, -z+.5',
				'-x, -y, -z',
				'x, y, z'],
			'P 1 1 2/b':['x, y+.5, -z',
				'-x, -y, -z',
				'-x, -y+.5, z',
				'x, y, z'],
			'B 1 21/a 1':['-x, y+.5, -z+.5',
				'x, -y+.5, z+.5',
				'-x, -y, -z',
				'x, y, z',
				'-x+.5, y+.5, -z',
				'x+.5, -y+.5, z',
				'-x+.5, -y, -z+.5',
				'x+.5, y, z+.5'],
			'B 1 21/c 1':['x, -y+.5, z+.5',
				'-x, y+.5, -z+.5',
				'-x, -y, -z',
				'x, y, z',
				'x+.5, -y+.5, z',
				'-x+.5, y+.5, -z',
				'-x+.5, -y, -z+.5',
				'x+.5, y, z+.5'],
			'P 21/b 1 1':['-x+.5, y+.5, z',
				'x+.5, -y+.5, -z',
				'-x, -y, -z',
				'x, y, z'],
			'P 21/n 1 1':['x+.5, -y+.5, -z+.5',
				'-x+.5, y+.5, z+.5',
				'-x, -y, -z',
				'x, y, z'],
			'P 1 21/a 1':['x+.5, -y+.5, z',
				'-x, -y, -z',
				'-x+.5, y+.5, -z',
				'x, y, z'],
			'P 1 21/c 1':['x, -y+.5, z+.5',
				'-x, -y, -z',
				'-x, y+.5, -z+.5',
				'x, y, z'],
			'P 1 21/n 1':['-x+.5, y+.5, -z+.5',
				'-x, -y, -z',
				'x+.5, -y+.5, z+.5',
				'x, y, z'],
			'P 1 1 21/a':['x+.5, y, -z+.5',
				'-x, -y, -z',
				'-x+.5, -y, z+.5',
				'x, y, z'],
			'P 1 1 21/b':['x, y+.5, -z+.5',
				'-x, -y, -z',
				'-x, -y+.5, z+.5',
				'x, y, z'],
			'P 1 1 21/n':['x+.5, y+.5, -z+.5',
				'-x, -y, -z',
				'-x+.5, -y+.5, z+.5',
				'x, y, z'],
			'A 1 2/a 1':['-x+.5, y, -z',
				'-x, -y, -z',
				'x+.5, -y, z',
				'x, y, z',
				'-x+.5, y+.5, -z+.5',
				'-x, -y+.5, -z+.5',
				'x+.5, -y+.5, z+.5',
				'x, y+.5, z+.5'],
			'A 1 2/n 1':['x+.5, -y, z+.5',
				'-x, -y, -z',
				'-x+.5, y, -z+.5',
				'x, y, z',
				'x+.5, -y+.5, z',
				'-x, -y+.5, -z+.5',
				'-x+.5, y+.5, -z',
				'x, y+.5, z+.5'],
			'A 1 1 2/a':['-x+.5, -y, z',
				'-x, -y, -z',
				'x+.5, y, -z',
				'x, y, z',
				'-x+.5, -y+.5, z+.5',
				'-x, -y+.5, -z+.5',
				'x+.5, y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'A 1 1 2/n':['x,y,z',
				'-x+1/2,-y+1/2,z',
				'-x,-y,-z',
				'x+1/2,y+1/2,-z',
				'x,y+1/2,z+1/2',
				'-x+1/2,-y,z+1/2',
				'-x,-y+1/2,-z+1/2',
				'x+1/2,y,-z+1/2'],
			'B 2/b 1 1':['x,y,z',
				'x,-y+1/2,-z',
				'-x,-y,-z',
				'-x,y+1/2,z',
				'x+1/2,y,z+1/2',
				'x+1/2,-y+1/2,-z+1/2',
				'-x+1/2,-y,-z+1/2',
				'-x+1/2,y+1/2,z+1/2'],
			'B 2/n 1 1':['x,y,z',
				'x,-y+1/2,-z+1/2',
				'-x,-y,-z',
				'-x,y+1/2,z+1/2',
				'x+1/2,y,z+1/2',
				'x+1/2,-y+1/2,-z',
				'-x+1/2,-y,-z+1/2',
				'-x+1/2,y+1/2,z'],
			'B 1 1 2/b':['x, y+.5, -z',
				'-x, -y, -z',
				'-x, -y+.5, z',
				'x, y, z',
				'x+.5, y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, -y+.5, z+.5',
				'x+.5, y, z+.5'],
			'B 1 1 2/n':['x,y,z',
				'-x+1/2,-y+1/2,z',
				'-x,-y,-z',
				'x+1/2,y+1/2,-z',
				'x+1/2,y,z+1/2',
				'-x,-y+1/2,z+1/2',
				'-x+1/2,-y,-z+1/2',
				'x,y+1/2,-z+1/2'],
			'C 2/n 1 1':['x,y,z',
				'x,-y+1/2,-z+1/2',
				'-x,-y,-z',
				'-x,y+1/2,z+1/2',
				'x+1/2,y+1/2,z',
				'x+1/2,-y,-z+1/2',
				'-x+1/2,-y+1/2,-z',
				'-x+1/2,y,z+1/2'],
			'C 1 2/c 1':['x, -y, z+.5',
				'-x, -y, -z',
				'-x, y, -z+.5',
				'x, y, z',
				'x+.5, -y+.5, z+.5',
				'-x+.5, -y+.5, -z',
				'-x+.5, y+.5, -z+.5',
				'x+.5, y+.5, z'],
			'C 1 2/n 1':['x,y,z',
				'-x+1/2,y,-z+1/2',
				'-x,-y,-z',
				'x+1/2,-y,z+1/2',
				'x+1/2,y+1/2,z',
				'-x,y+1/2,-z+1/2',
				'-x+1/2,-y+1/2,-z',
				'x,-y+1/2,z+1/2'],
			'I 2/b 1 1':['x,y,z',
				'x,-y+1/2,-z',
				'-x,-y,-z',
				'-x,y+1/2,z',
				'x+1/2,y+1/2,z+1/2',
				'x+1/2,-y,-z+1/2',
				'-x+1/2,-y+1/2,-z+1/2',
				'-x+1/2,y,z+1/2'],
			'I 2/c 1 1':['x,y,z',
				'x,-y,-z+1/2',
				'-x,-y,-z',
				'-x,y,z+1/2',
				'x+1/2,y+1/2,z+1/2',
				'x+1/2,-y+1/2,-z',
				'-x+1/2,-y+1/2,-z+1/2',
				'-x+1/2,y+1/2,z'],
			'I 1 2/a 1':['x+.5, -y, z',
				'-x, -y, -z',
				'-x+.5, y, -z',
				'x, y, z',
				'x, -y+.5, z+.5',
				'-x+.5, -y+.5, -z+.5',
				'-x, y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I 1 2/c 1':['-x, y, -z+.5',
				'-x, -y, -z',
				'x, -y, z+.5',
				'x, y, z',
				'-x+.5, y+.5, -z',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, -y+.5, z',
				'x+.5, y+.5, z+.5'],
			'I 1 1 2/a':['-x+.5, -y, z',
				'x+.5, y, -z',
				'-x, -y, -z',
				'x, y, z',
				'-x, -y+.5, z+.5',
				'x, y+.5, -z+.5',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I 1 1 2/b':['-x, -y+.5, z',
				'x, y+.5, -z',
				'-x, -y, -z',
				'x, y, z',
				'-x+.5, -y, z+.5',
				'x+.5, y, -z+.5',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'P 21 2 2':['x,y,z',
				'x+1/2,-y,-z',
				'-x+1/2,-y,z',
				'-x,y,-z'],
			'P 2 21 2':['x,y,z',
				'-x,y+1/2,-z',
				'-x,-y+1/2,z',
				'x,-y,-z'],
			'P 21 2 21':['-x+.5, -y, z+.5',
				'x+.5, -y, -z+.5',
				'-x, y, -z',
				'x, y, z'],
			'P 2 21 21':['-x, y+.5, -z+.5',
				'-x, -y+.5, z+.5',
				'x, -y, -z',
				'x, y, z'],
			'A 21 2 2':['-x, y, -z',
				'x+.5, -y, -z',
				'-x+.5, -y, z',
				'x, y, z',
				'-x, y+.5, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'-x+.5, -y+.5, z+.5',
				'x, y+.5, z+.5'],
			'B 2 21 2':['-x, -y+.5, z',
				'-x, y+.5, -z',
				'x, -y, -z',
				'x, y, z',
				'-x+.5, -y+.5, z+.5',
				'-x+.5, y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, y, z+.5'],
			'A 2 2 2':['-x, y, -z',
				'-x, -y, z',
				'x, -y, -z',
				'x, y, z',
				'-x, y+.5, -z+.5',
				'-x, -y+.5, z+.5',
				'x, -y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'B 2 2 2':['x,y,z',
				'-x,y,-z',
				'-x,-y,z',
				'x,-y,-z',
				'x+1/2,y,z+1/2',
				'-x+1/2,y,-z+1/2',
				'-x+1/2,-y,z+1/2',
				'x+1/2,-y,-z+1/2'],
			'P 2 m m':['x, y, -z',
				'x, -y, z',
				'x, -y, -z',
				'x, y, z'],
			'P m 2 m':['-x, y, z',
				'x, y, -z',
				'-x, y, -z',
				'x, y, z'],
			'P 21 a m':['x+.5, -y, z',
				'x+.5, -y, -z',
				'x, y, -z',
				'x, y, z'],
			'P 21 m a':['x+.5, y, -z',
				'x+.5, -y, -z',
				'x, -y, z',
				'x, y, z'],
			'P b 21 m':['-x, y+.5, z',
				'-x, y+.5, -z',
				'x, y, -z',
				'x, y, z'],
			'P c m 21':['-x, y, z+.5',
				'-x, -y, z+.5',
				'x, -y, z',
				'x, y, z'],
			'P m 21 b':['x, y+.5, -z',
				'-x, y+.5, -z',
				'-x, y, z',
				'x, y, z'],
			'P 2 a a':['x,y,z',
			    'x,-y,-z',
			    'x+1/2,y,-z',
			    'x+1/2,-y,z'],
			'P b 2 b':['x,y,z',
				'-x,y,-z',
				'x,y+1/2,-z',
				'-x,y+1/2,z'],
			'P 2 c m':['x, -y, z+.5',
				'x, y, -z+.5',
				'x, -y, -z',
				'x, y, z'],
			'P 2 m b':['x,y,z',
				'x,-y,-z',
				'x,y+1/2,-z',
				'x,-y+1/2,z'],
			'P b m 2':['-x, y+.5, z',
  	            'x, -y+.5, z',
				'-x, -y, z',
				'x, y, z'],
			'P c 2 m':['x,y,z',
				'-x,y,-z',
				'-x,y,z+1/2',
				'x,y,-z+1/2'],
			'P m 2 a':['x+.5, y, -z',
				'-x+.5, y, z',
				'-x, y, -z',
				'x, y, z'],
			'P 21 a b':['x, y+.5, -z',
				'x+.5, -y+.5, z',
				'x+.5, -y, -z',
				'x, y, z'],
			'P 21 c a':['x, -y, z+.5',
				'x+.5, y, -z+.5',
				'x+.5, -y, -z',
				'x, y, z'],
			'P b 21 a':['x+.5, y, -z',
				'-x+.5, y+.5, z',
				'-x, y+.5, -z',
				'x, y, z'],
			'P b c 21':['-x, y+.5, z',
				'x, -y+.5, z+.5',
				'-x, -y, z+.5',
				'x, y, z'],
			'P c 21 b':['-x, y, z+.5',
				'x, y+.5, -z+.5',
				'-x, y+.5, -z',
				'x, y, z'],
			'P 2 a n':['x+.5, -y+.5, z',
				'x+.5, y+.5, -z',
				'x, -y, -z',
				'x, y, z'],
			'P 2 n a':['x,y,z',
				'x,-y,-z',
				'x+1/2,y,-z+1/2',
				'x+1/2,-y,z+1/2'],
			'P b 2 n':['-x+.5, y+.5, z',
				'x+.5, y+.5, -z+.5',
				'-x, y, -z+.5',
				'x, y, z'],
			'P c n 2':['-x+.5, y, z+.5',
				'x+.5, -y, z+.5',
				'-x, -y, z',
				'x, y, z'],
			'P n 2 b':['x,y,z',
				'-x,y,-z',
				'x,y+1/2,-z+1/2',
				'-x,y+1/2,z+1/2'],
			'P 21 m n':['x+.5, y+.5, -z',
				'x+.5, -y+.5, -z',
				'x, -y, z',
				'x, y, z'],
			'P 21 n m':['x+.5, -y, z+.5',
				'x+.5, -y, -z+.5',
				'x, y, -z',
				'x, y, z'],
			'P m 21 n':['x+.5, y+.5, -z',
				'-x+.5, y+.5, -z',
				'-x, y, z',
				'x, y, z'],
			'P n 21 m':['-x, y+.5, z+.5',
				'-x, y+.5, -z+.5',
				'x, y, -z',
				'x, y, z'],
			'P n m 21':['-x, y+.5, z+.5',
				'-x, -y+.5, z+.5',
				'x, -y, z',
				'x, y, z'],
			'P 2 c b':['x,y,z',
				'x,-y,-z',
				'x,y+1/2,-z+1/2',
				'x,-y+1/2,z+1/2'],
			'P c 2 a':['x,y,z',
				'-x,y,-z',
				'x+1/2,y,-z+1/2',
				'-x+1/2,y,z+1/2'],
			'P 21 c n':['x, -y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y, -z',
				'x, y, z'],
			
			'P 21 n b':['x, y+.5, -z+.5',
				'x+.5, -y+.5, z+.5',
				'x+.5, -y, -z',
				'x, y, z'],
			'P b n 21':['-x+.5, y+.5, z',
				'x+.5, -y+.5, z+.5',
				'-x, -y, z+.5',
				'x, y, z'],
			'P c 21 n':['-x+.5, y, z+.5',
				'x+.5, y+.5, -z+.5',
				'-x, y+.5, -z',
				'x, y, z'],
			'P n 21 a':['x+.5, y, -z+.5',
				'-x+.5, y+.5, z+.5',
				'-x, y+.5, -z',
				'x, y, z'],
			'P 2 n n':['x+.5, -y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'x, -y, -z',
				'x, y, z'],
			'P n 2 n':['x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, z+.5',
				'-x, y, -z',
				'x, y, z'],
			'A 2 m m':['x, y, -z',
				'x, -y, z',
				'x, -y, -z',
				'x, y, z',
				'x, y+.5, -z+.5',
				'x, -y+.5, z+.5',
				'x, -y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'B m 2 m':['x,y,z',
				'-x,y,-z',
				'x,y,-z',
				'-x,y,z',
				'x+1/2,y,z+1/2',
				'-x+1/2,y,-z+1/2',
				'x+1/2,y,-z+1/2',
				'-x+1/2,y,z+1/2'],
			'A 21 a m':['x+.5, -y, z',
				'x+.5, -y, -z',
				'x, y, -z',
				'x, y, z',
			    'x+.5, -y+.5, z+.5',
				'x+.5, -y+.5, -z+.5',
				'x, y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'A 21 m a':['x+.5, y, -z',
				'x+.5, -y, -z',
				'x, -y, z',
				'x, y, z',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'x, -y+.5, z+.5',
				'x, y+.5, z+.5'],
			'B b 21 m':['-x, y+.5, z',
				'-x, y+.5, -z',
				'x, y, -z',
				'x, y, z',
				'-x+.5, y+.5, z+.5',
				'-x+.5, y+.5, -z+.5',
				'x+.5, y, -z+.5',
				'x+.5, y, z+.5'],
			'B m 21 b':['x,y,z',
				'-x,y+1/2,-z',
				'x,y+1/2,-z',
				'-x,y,z',
				'x+1/2,y,z+1/2',
				'-x+1/2,y+1/2,-z+1/2',
				'x+1/2,y+1/2,-z+1/2',
				'-x+1/2,y,z+1/2'],
			'C c m 21':['-x, y, z+.5',
				'-x, -y, z+.5',
				'x, -y, z',
				'x, y, z',
				'-x+.5, y+.5, z+.5',
				'-x+.5, -y+.5, z+.5',
				'x+.5, -y+.5, z',
				'x+.5, y+.5, z'],
			'A 2 a a':['x+.5, -y, z',
				'x+.5, y, -z',
				'x, -y, -z',
				'x, y, z',
				'x+.5, -y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'x, -y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'B b 2 b':['x, y+.5, -z',
				'-x, y+.5, z',
				'-x, y, -z',
				'x, y, z',
				'x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, z+.5',
				'-x+.5, y, -z+.5',
				'x+.5, y, z+.5'],
			'A m 2 m':['x, y, -z',
				'-x, y, z',
				'-x, y, -z',
				'x, y, z',
				'x, y+.5, -z+.5',
				'-x, y+.5, z+.5',
				'-x, y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'B 2 m m':['x, y, -z',
				'x, -y, z',
				'x, -y, -z',
				'x, y, z',
				'x+.5, y, -z+.5',
				'x+.5, -y, z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, y, z+.5'],
			'B m m 2':['-x, y, z',
				'x, -y, z',
				'-x, -y, z',
				'x, y, z',
				'-x+.5, y, z+.5',
				'x+.5, -y, z+.5',
				'-x+.5, -y, z+.5',
				'x+.5, y, z+.5'],
			'C 2 m m':['x, -y, z',
				'x, y, -z',
				'x, -y, -z',
				'x, y, z',
				'x+.5, -y+.5, z',
				'x+.5, y+.5, -z',
				'x+.5, -y+.5, -z',
				'x+.5, y+.5, z'],
			'C m 2 m':['-x, y, z',
				'x, y, -z',
				'-x, y, -z',
				'x, y, z',
				'-x+.5, y+.5, z',
				'x+.5, y+.5, -z',
				'-x+.5, y+.5, -z',
				'x+.5, y+.5, z'],
			'A b m 2':['x, -y+.5, z',
				'-x, y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'x, -y, z+.5',
				'-x, y, z+.5',
				'-x, -y+.5, z+.5',
				'x, y+.5, z+.5'],
			'A c 2 m':['x,y,z',
				'-x,y,-z',
				'x,y,-z+1/2',
				'-x,y,z+1/2',
				'x,y+1/2,z+1/2',
				'-x,y+1/2,-z+1/2',
				'x,y+1/2,-z',
				'-x,y+1/2,z'],
			'B 2 c m':['x,y,z',
				'x,-y,-z',
				'x,y,-z+1/2',
				'x,-y,z+1/2',
				'x+1/2,y,z+1/2',
				'x+1/2,-y,-z+1/2',
				'x+1/2,y,-z',
				'x+1/2,-y,z'],
			'B m a 2':['x,y,z',
				'-x,-y,z',
				'-x+1/2,y,z',
				'x+1/2,-y,z',
				'x+1/2,y,z+1/2',
				'-x+1/2,-y,z+1/2',
				'-x,y,z+1/2',
				'x,-y,z+1/2'],
			'C 2 m b':['x, -y+.5, z',
				'x, y+.5, -z',
				'x, -y, -z',
				'x, y, z',
				'x+.5, -y, z',
				'x+.5, y, -z',
				'x+.5, -y+.5, -z',
				'x+.5, y+.5, z'],
			'C m 2 a':['-x+.5, y, z',
				'x+.5, y, -z',
				'-x, y, -z',
				'x, y, z',
				'-x, y+.5, z',
				'x, y+.5, -z',
				'-x+.5, y+.5, -z',
				'x+.5, y+.5, z'],
			'A m 2 a':['x,y,z',
				'-x,y,-z',
				'x+1/2,y,-z',
				'-x+1/2,y,z',
				'x,y+1/2,z+1/2',
				'-x,y+1/2,-z+1/2',
				'x+1/2,y+1/2,-z+1/2',
				'-x+1/2,y+1/2,z+1/2'],
			'B 2 m b':['x, y+.5, -z',
				'x, -y+.5, z',
				'x, -y, -z',
				'x, y, z',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y+.5, z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, y, z+.5'],
			'B b m 2':['-x, y+.5, z',
				'x, -y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'-x+.5, y+.5, z+.5',
				'x+.5, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'x+.5, y, z+.5'],
			'C 2 c m':['x, -y, z+.5',
				'x, y, -z+.5',
				'x, -y, -z',
				'x, y, z',
				'x+.5, -y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y+.5, -z',
				'x+.5, y+.5, z'],
			'C c 2 m':['-x, y, z+.5',
				'x, y, -z+.5',
				'-x, y, -z',
				'x, y, z',
				'-x+.5, y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, -z',
				'x+.5, y+.5, z'],
			'A b a 2':['x+.5, -y+.5, z',
				'-x+.5, y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'x+.5, -y, z+.5',
				'-x+.5, y, z+.5',
				'-x, -y+.5, z+.5',
				'x, y+.5, z+.5'],
			'A c 2 a':['x,y,z',
				'-x,y,-z',
				'x+1/2,y,-z+1/2',
				'-x+1/2,y,z+1/2',
				'x,y+1/2,z+1/2',
				'-x,y+1/2,-z+1/2',
				'x+1/2,y+1/2,-z',
				'-x+1/2,y+1/2,z'],
			'B 2 c b':['x, y+.5, -z+.5',
				'x, -y+.5, z+.5',
				'x, -y, -z',
				'x, y, z',
				'x+.5, y+.5, -z',
				'x+.5, -y+.5, z',
				'x+.5, -y, -z+.5',
				'x+.5, y, z+.5'],
			'B b a 2':['-x+.5, y+.5, z',
				'x+.5, -y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'-x, y+.5, z+.5',
				'x, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'x+.5, y, z+.5'],
			'C 2 c b':['x, -y+.5, z+.5',
				'x, y+.5, -z+.5',
				'x, -y, -z',
				'x, y, z',
				'x+.5, -y, z+.5',
				'x+.5, y, -z+.5',
				'x+.5, -y+.5, -z',
				'x+.5, y+.5, z'],
			'C c 2 a':['-x+.5, y, z+.5',
				'x+.5, y, -z+.5',
				'-x, y, -z',
				'x, y, z',
				'-x, y+.5, z+.5',
				'x, y+.5, -z+.5',
				'-x+.5, y+.5, -z',
				'x+.5, y+.5, z'],
			'F 2 m m':['x, -y, z',
				'x, y, -z',
				'x, -y, -z',
				'x, y, z',
				'x, -y+.5, z+.5',
				'x+.5, -y, z+.5',
				'x+.5, -y+.5, z',
				'x, y+.5, -z+.5',
				'x+.5, y, -z+.5',
				'x+.5, y+.5, -z',
				'x, -y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, -y+.5, -z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F m 2 m':['x, y, -z',
				'-x, y, z',
				'-x, y, -z',
				'x, y, z',
				'x, y+.5, -z+.5',
				'x+.5, y, -z+.5',
				'x+.5, y+.5, -z',
				'-x, y+.5, z+.5',
				'-x+.5, y, z+.5',
				'-x+.5, y+.5, z',
				'-x, y+.5, -z+.5',
				'-x+.5, y, -z+.5',
				'-x+.5, y+.5, -z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F 2 d d':['x+.25, -y+.25, z+.25',
				'x+.25, y+.25, -z+.25',
				'x, -y, -z',
				'x, y, z',
				'x+.25, -y+.75, z+.75',
				'x+.75, -y+.25, z+.75',
				'x+.75, -y+.75, z+.25',
				'x+.25, y+.75, -z+.75',
				'x+.75, y+.25, -z+.75',
				'x+.75, y+.75, -z+.25',
				'x, -y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, -y+.5, -z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F d 2 d':['x+.25, y+.25, -z+.25',
				'-x+.25, y+.25, z+.25',
				'-x, y, -z',
				'x, y, z',
				'x+.25, y+.75, -z+.75',
				'x+.75, y+.25, -z+.75',
				'x+.75, y+.75, -z+.25',
				'-x+.25, y+.75, z+.75',
				'-x+.75, y+.25, z+.75',
				'-x+.75, y+.75, z+.25',
				'-x, y+.5, -z+.5',
				'-x+.5, y, -z+.5',
				'-x+.5, y+.5, -z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'I 2 m m':['x, -y, z',
				'x, y, -z',
				'x, -y, -z',
				'x, y, z',
				'x+.5, -y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I m 2 m':['x, y, -z',
				'-x, y, z',
				'-x, y, -z',
				'x, y, z',
				'x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, z+.5',
				'-x+.5, y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I 2 c b':['x,y,z',
				'x,-y,-z',
				'x,y+1/2,-z+1/2',
				'x,-y+1/2,z+1/2',
				'x+1/2,y+1/2,z+1/2',
				'x+1/2,-y+1/2,-z+1/2',
				'x+1/2,y,-z',
				'x+1/2,-y,z'],
			'I c 2 a':['x,y,z',
				'-x,y,-z',
				'x+1/2,y,-z+1/2',
				'-x+1/2,y,z+1/2',
				'x+1/2,y+1/2,z+1/2',
				'-x+1/2,y+1/2,-z+1/2',
				'x,y+1/2,-z',
				'-x,y+1/2,z'],
			'I 2 c m':['x, -y, z+.5',
				'x, y, -z+.5',
				'x, -y, -z',
				'x, y, z',
				'x+.5, -y+.5, z',
				'x+.5, y+.5, -z',
				'x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I 2 m b':['x, y+.5, -z',
				'x, -y+.5, z',
				'x, -y, -z',
				'x, y, z',
				'x+.5, y, -z+.5',
				'x+.5, -y, z+.5',
				'x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I b m 2':['-x, y+.5, z',
				'x, -y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'-x+.5, y, z+.5',
				'x+.5, -y, z+.5',
				'-x+.5, -y+.5, z+.5',
				'x+.5, y+.5, z+.5'],
			'I 2 c m':['x, -y, z+.5',
				'x, y, -z+.5',
				'x, -y, -z',
				'x, y, z',
				'x+.5, -y+.5, z',
				'x+.5, y+.5, -z',
				'x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I m 2 a':['x,y,z',
				'-x,y,-z',
				'x+1/2,y,-z',
				'-x+1/2,y,z',
				'x+1/2,y+1/2,z+1/2',
				'-x+1/2,y+1/2,-z+1/2',
				'x,y+1/2,-z+1/2',
				'-x,y+1/2,z+1/2'],
			'P b m b':['x,y,z',
				'-x,y,-z',
				'-x,-y+1/2,z',
				'x,-y+1/2,-z',
				'-x,-y,-z',
				'x,-y,z',
				'x,y+1/2,-z',
				'-x,y+1/2,z'],
			'P m a a':['x,y,z',
				'x,-y,-z',
				'-x+1/2,-y,z',
				'-x+1/2,y,-z',
				'-x,-y,-z',
				'-x,y,z',
				'x+1/2,y,-z',
				'x+1/2,-y,z'],
			'P b m m':['x, -y+.5, -z',
				'-x, y+.5, -z',
				'x, y, -z',
				'-x, -y, -z',
				'-x, y+.5, z',
				'x, -y+.5, z',
				'-x, -y, z',
				'x, y, z'],
			'P c m m':['x,y,z',
				'x,-y,-z+1/2',
				'-x,y,-z',
				'-x,-y,z+1/2',
				'-x,-y,-z',
				'-x,y,z+1/2',
				'x,-y,z',
				'x,y,-z+1/2'],
			'P m a m':['-x+.5, y, -z',
				'x+.5, -y, -z',
				'x, y, -z',
				'-x, -y, -z',
				'x+.5, -y, z',
				'-x+.5, y, z',
				'-x, -y, z',
				'x, y, z'],
			'P m c m':['-x, y, -z+.5',
				'-x, -y, z+.5',
				'-x, y, z',
				'-x, -y, -z',
				'x, -y, z+.5',
				'x, y, -z+.5',
				'x, -y, -z',
				'x, y, z'],
			'P m m b':['-x, -y+.5, z',
				'-x, y+.5, -z',
				'-x, y, z',
				'-x, -y, -z',
				'x, y+.5, -z',
				'x, -y+.5, z',
				'x, -y, -z',
				'x, y, z'],
			'P b n n':['x+.5, y+.5, -z+.5',
				'x+.5, -y, z+.5',
				'-x, y+.5, z',
				'-x, -y, -z',
				'-x+.5, -y+.5, z+.5',
				'-x+.5, y, -z+.5',
				'x, -y+.5, -z',
				'x, y, z'],
			'P c n n':['x+.5, -y+.5, z+.5',
				'x+.5, y+.5, -z',
				'-x, y, z+.5',
				'-x, -y, -z',
				'-x+.5, y+.5, -z+.5',
				'-x+.5, -y+.5, z',
				'x, -y, -z+.5',
				'x, y, z'],
			'P n a n':['x+.5, y+.5, -z+.5',
				'-x, y+.5, z+.5',
				'x+.5, -y, z',
				'-x, -y, -z',
				'-x+.5, -y+.5, z+.5',
				'x, -y+.5, -z+.5',
				'-x+.5, y, -z',
				'x, y, z'],
			'P n c n':['-x+.5, y+.5, z+.5',
				'x+.5, y+.5, -z',
				'x, -y, z+.5',
				'-x, -y, -z',
				'x+.5, -y+.5, -z+.5',
				'-x+.5, -y+.5, z',
				'-x, y, -z+.5',
				'x, y, z'],
			'P n n b':['x,y,z',
				'-x,-y+1/2,z',
				'x+1/2,-y+1/2,-z+1/2',
				'-x+1/2,y,-z+1/2',
				'-x,-y,-z',
				'x,y+1/2,-z',
				'-x+1/2,y+1/2,z+1/2',
				'x+1/2,-y,z+1/2'],
			'P b m n':['-x+.5, y+.5, z',
				'x+.5, y+.5, -z',
				'x, -y, z',
				'-x, -y, -z',
				'x+.5, -y+.5, -z',
				'-x+.5, -y+.5, z',
				'-x, y, -z',
				'x, y, z'],
			'P c n m':['-x+.5, y, z+.5',
				'x+.5, -y, z+.5',
				'x, y, -z',
				'-x, -y, -z',
				'x+.5, -y, -z+.5',
				'-x+.5, y, -z+.5',
				'-x, -y, z',
				'x, y, z'],
			'P m a n':['x+.5, -y+.5, z',
				'x+.5, y+.5, -z',
				'-x, y, z',
				'-x, -y, -z',
				'-x+.5, y+.5, -z',
				'-x+.5, -y+.5, z',
				'x, -y, -z',
				'x, y, z'],
			'P n c m':['x, -y+.5, z+.5',
				'-x, y+.5, z+.5',
				'x, y, -z',
				'-x, -y, -z',
				'-x, y+.5, -z+.5',
				'x, -y+.5, -z+.5',
				'-x, -y, z',
				'x, y, z'],
			'P n m b':['x, y+.5, -z+.5',
				'-x, y+.5, z+.5',
				'x, -y, z',
				'-x, -y, -z',
				'-x, -y+.5, z+.5',
				'x, -y+.5, -z+.5',
				'-x, y, -z',
				'x, y, z'],
			'P b a a':['x+.5, y, -z',
				'x+.5, -y+.5, z',
				'-x, y+.5, z',
				'-x, -y, -z',
				'-x+.5, -y, z',
				'-x+.5, y+.5, -z',
				'x, -y+.5, -z',
				'x, y, z'],
			'P b a b':['x, y+.5, -z',
				'-x+.5, y+.5, z',
				'x+.5, -y, z',
				'-x, -y, -z',
				'-x, -y+.5, z',
				'x+.5, -y+.5, -z',
				'-x+.5, y, -z',
				'x, y, z'],
			'P b c b':['-x, y+.5, z',
				'x, y+.5, -z+.5',
				'x, -y, z+.5',
				'-x, -y, -z',
				'x, -y+.5, -z',
				'-x, -y+.5, z+.5',
				'-x, y, -z+.5',
				'x, y, z'],
			'P c a a':['x,y,z',
				'x,-y,-z+1/2',
				'-x+1/2,y,-z',
				'-x+1/2,-y,z+1/2',
				'-x,-y,-z',
				'-x,y,z+1/2',
				'x+1/2,-y,z',
				'x+1/2,y,-z+1/2'],
			'P c c b':['x,y,z',
				'-x,-y+1/2,z',
				'x,-y,-z+1/2',
				'-x,y+1/2,-z+1/2',
				'-x,-y,-z',
				'x,y+1/2,-z',
				'-x,y,z+1/2',
				'x,-y+1/2,z+1/2'],
			'P c m a':['x+.5, y, -z+.5',
				'-x+.5, y, z+.5',
				'x, -y, z',
				'-x, -y, -z',
				'-x+.5, -y, z+.5',
				'x+.5, -y, -z+.5',
				'-x, y, -z',
				'x, y, z'],
			'P m c b':['x, -y+.5, z+.5',
				'x, y+.5, -z+.5',
				'-x, y, z',
				'-x, -y, -z',
				'-x, y+.5, -z+.5',
				'-x, -y+.5, z+.5',
				'x, -y, -z',
				'x, y, z'],
			'P b n b':['x, y+.5, -z+.5',
				'-x+.5, y+.5, z',
				'x+.5, -y, z+.5',
				'-x, -y, -z',
				'-x, -y+.5, z+.5',
				'x+.5, -y+.5, -z',
				'-x+.5, y, -z+.5',
				'x, y, z'],
			'P n a a':['x+.5, -y+.5, z',
				'x+.5, y, -z+.5',
				'-x, y+.5, z+.5',
				'-x, -y, -z',
				'-x+.5, y+.5, -z',
				'-x+.5, -y, z+.5',
				'x, -y+.5, -z+.5',
				'x, y, z'],
			'P b m a':['-x+.5, y+.5, z',
				'x+.5, y, -z',
				'x, -y+.5, z',
				'-x, -y, -z',
				'x+.5, -y+.5, -z',
				'-x+.5, -y, z',
				'-x, y+.5, -z',
				'x, y, z'],
			'P c a m':['-x+.5, y, z+.5',
				'x+.5, -y, z',
				'x, y, -z+.5',
				'-x, -y, -z',
				'x+.5, -y, -z+.5',
				'-x+.5, y, -z',
				'-x, -y, z+.5',
				'x, y, z'],
			'P c m b':['x, y+.5, -z+.5',
				'-x, y, z+.5',
				'x, -y+.5, z',
				'-x, -y, -z',
				'-x, -y+.5, z+.5',
				'x, -y, -z+.5',
				'-x, y+.5, -z',
				'x, y, z'],
			'P m a b':['x+.5, -y+.5, z',
				'x, y+.5, -z',
				'-x+.5, y, z',
				'-x, -y, -z',
				'-x+.5, y+.5, -z',
				'-x, -y+.5, z',
				'x+.5, -y, -z',
				'x, y, z'],
			'P m c a':['x+.5, y, -z+.5',
				'x, -y, z+.5',
				'-x+.5, y, z',
				'-x, -y, -z',
				'-x+.5, -y, z+.5',
				'-x, y, -z+.5',
				'x+.5, -y, -z',
				'x, y, z'],
			'P m n n':['x+.5, -y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'-x, y, z',
				'-x, -y, -z',
				'-x+.5, y+.5, -z+.5',
				'-x+.5, -y+.5, z+.5',
				'x, -y, -z',
				'x, y, z'],
			'P n m n':['x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, z+.5',
				'x, -y, z',
				'-x, -y, -z',
				'-x+.5, -y+.5, z+.5',
				'x+.5, -y+.5, -z+.5',
				'-x, y, -z',
				'x, y, z'],
			'P b n a':['-x, y+.5, z',
				'x+.5, y, -z+.5',
				'x+.5, -y+.5, z+.5',
				'-x, -y, -z',
				'x, -y+.5, -z',
				'-x+.5, -y, z+.5',
				'-x+.5, y+.5, -z+.5',
				'x, y, z'],
			'P c a n':['-x, y, z+.5',
				'x+.5, -y+.5, z',
				'x+.5, y+.5, -z+.5',
				'-x, -y, -z',
				'x, -y, -z+.5',
				'-x+.5, y+.5, -z',
				'-x+.5, -y+.5, z+.5',
				'x, y, z'],
			'P c n b':['x, y+.5, -z',
				'-x+.5, y, z+.5',
				'x+.5, -y+.5, z+.5',
				'-x, -y, -z',
				'-x, -y+.5, z',
				'x+.5, -y, -z+.5',
				'-x+.5, y+.5, -z+.5',
				'x, y, z'],
			'P n a b':['x+.5, -y, z',
				'x, y+.5, -z+.5',
				'-x+.5, y+.5, z+.5',
				'-x, -y, -z',
				'-x+.5, y, -z',
				'-x, -y+.5, z+.5',
				'x+.5, -y+.5, -z+.5',
				'x, y, z'],
			'P n c a':['x+.5, y, -z',
				'x, -y+.5, z+.5',
				'-x+.5, y+.5, z+.5',
				'-x, -y, -z',
				'-x+.5, -y, z',
				'-x, y+.5, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'x, y, z'],
			'P c a b':['x+.5, -y+.5, z',
				'x, y+.5, -z+.5',
				'-x+.5, y, z+.5',
				'-x, -y, -z',
				'-x+.5, y+.5, -z',
				'-x, -y+.5, z+.5',
				'x+.5, -y, -z+.5',
				'x, y, z'],
			'P b n m':['-x+.5, y+.5, z',
				'x, y, -z+.5',
				'x+.5, -y+.5, z+.5',
				'-x, -y, -z',
				'x+.5, -y+.5, -z',
				'-x, -y, z+.5',
				'-x+.5, y+.5, -z+.5',
				'x, y, z'],
			'P c m n':['-x+.5, y, z+.5',
				'x, -y+.5, z',
				'x+.5, y+.5, -z+.5',
				'-x, -y, -z',
				'x+.5, -y, -z+.5',
				'-x, y+.5, -z',
				'-x+.5, -y+.5, z+.5',
				'x, y, z'],
			'P m c n':['x, -y+.5, z+.5',
				'-x+.5, y, z',
				'x+.5, y+.5, -z+.5',
				'-x, -y, -z',
				'-x, y+.5, -z+.5',
				'x+.5, -y, -z',
				'-x+.5, -y+.5, z+.5',
				'x, y, z'],
			'P m n b':['x, y+.5, -z+.5',
				'-x+.5, y, z',
				'x+.5, -y+.5, z+.5',
				'-x, -y, -z',
				'-x, -y+.5, z+.5',
				'x+.5, -y, -z',
				'-x+.5, y+.5, -z+.5',
				'x, y, z'],
			'P n a m':['x+.5, -y+.5, z',
				'x, y, -z+.5',
				'-x+.5, y+.5, z+.5',
				'-x, -y, -z',
				'-x+.5, y+.5, -z',
				'-x, -y, z+.5',
				'x+.5, -y+.5, -z+.5',
				'x, y, z'],
			'A m a m':['-x+.5, y, -z',
				'x+.5, -y, -z',
				'x, y, -z',
				'-x, -y, -z',
				'x+.5, -y, z',
				'-x+.5, y, z',
				'-x, -y, z',
				'x, y, z',
				'-x+.5, y+.5, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'x, y+.5, -z+.5',
				'-x, -y+.5, -z+.5',
				'x+.5, -y+.5, z+.5',
				'-x+.5, y+.5, z+.5',
				'-x, -y+.5, z+.5',
				'x, y+.5, z+.5'],
			'A m m a':['-x+.5, -y, z',
				'x+.5, -y, -z',
				'x, -y, z',
				'-x, -y, -z',
				'x+.5, y, -z',
				'-x+.5, y, z',
				'-x, y, -z',
				'x, y, z',
				'-x+.5, -y+.5, z+.5',
				'x+.5, -y+.5, -z+.5',
				'x, -y+.5, z+.5',
				'-x, -y+.5, -z+.5',
				'x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, z+.5',
				'-x, y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'B b m m':['x, -y+.5, -z',
				'-x, y+.5, -z',
				'x, y, -z',
				'-x, -y, -z',
				'-x, y+.5, z',
				'x, -y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'x+.5, -y+.5, -z+.5',
				'-x+.5, y+.5, -z+.5',
				'x+.5, y, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, y+.5, z+.5',
				'x+.5, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'x+.5, y, z+.5'],
			'B m m b':['-x, -y+.5, z',
				'-x, y+.5, -z',
				'-x, y, z',
				'-x, -y, -z',
				'x, y+.5, -z',
				'x, -y+.5, z',
				'x, -y, -z',
				'x, y, z',
				'-x+.5, -y+.5, z+.5',
				'-x+.5, y+.5, -z+.5',
				'-x+.5, y, z+.5',
				'-x+.5, -y, -z+.5',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y+.5, z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, y, z+.5'],
			'C c m m':['x, -y, -z+.5',
				'-x, -y, z+.5',
				'x, -y, z',
				'-x, -y, -z',
				'-x, y, z+.5',
				'x, y, -z+.5',
				'-x, y, -z',
				'x, y, z',
				'x+.5, -y+.5, -z+.5',
				'-x+.5, -y+.5, z+.5',
				'x+.5, -y+.5, z',
				'-x+.5, -y+.5, -z',
				'-x+.5, y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, -z',
				'x+.5, y+.5, z'],
			'A b m a':['x+.5, -y, -z+.5',
				'-x+.5, -y, z+.5',
				'x, -y, z',
				'-x, -y, -z',
				'-x+.5, y, z+.5',
				'x+.5, y, -z+.5',
				'-x, y, -z',
				'x, y, z',
				'x+.5, -y+.5, -z',
				'-x+.5, -y+.5, z',
				'x, -y+.5, z+.5',
				'-x, -y+.5, -z+.5',
				'-x+.5, y+.5, z',
				'x+.5, y+.5, -z',
				'-x, y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'A c a m':['x+.5, -y+.5, -z',
				'-x+.5, y+.5, -z',
				'x, y, -z',
				'-x, -y, -z',
				'-x+.5, y+.5, z',
				'x+.5, -y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'x+.5, -y, -z+.5',
				'-x+.5, y, -z+.5',
				'x, y+.5, -z+.5',
				'-x, -y+.5, -z+.5',
				'-x+.5, y, z+.5',
				'x+.5, -y, z+.5',
				'-x, -y+.5, z+.5',
				'x, y+.5, z+.5'],
			'B b c m':['-x+.5, y+.5, -z',
				'x+.5, -y+.5, -z',
				'x, y, -z',
				'-x, -y, -z',
				'x+.5, -y+.5, z',
				'-x+.5, y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'-x, y+.5, -z+.5',
				'x, -y+.5, -z+.5',
				'x+.5, y, -z+.5',
				'-x+.5, -y, -z+.5',
				'x, -y+.5, z+.5',
				'-x, y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'x+.5, y, z+.5'],
			'B m a b':['-x, y+.5, -z+.5',
				'-x, -y+.5, z+.5',
				'-x, y, z',
				'-x, -y, -z',
				'x, -y+.5, z+.5',
				'x, y+.5, -z+.5',
				'x, -y, -z',
				'x, y, z',
				'-x+.5, y+.5, -z',
				'-x+.5, -y+.5, z',
				'-x+.5, y, z+.5',
				'-x+.5, -y, -z+.5',
				'x+.5, -y+.5, z',
				'x+.5, y+.5, -z',
				'x+.5, -y, -z+.5',
				'x+.5, y, z+.5'],
			'C c m b':['-x+.5, -y, z+.5',
				'x+.5, -y, -z+.5',
				'x, -y, z',
				'-x, -y, -z',
				'x+.5, y, -z+.5',
				'-x+.5, y, z+.5',
				'-x, y, -z',
				'x, y, z',
				'-x, -y+.5, z+.5',
				'x, -y+.5, -z+.5',
				'x+.5, -y+.5, z',
				'-x+.5, -y+.5, -z',
				'x, y+.5, -z+.5',
				'-x, y+.5, z+.5',
				'-x+.5, y+.5, -z',
				'x+.5, y+.5, z'],
			'C m c a':['-x, -y+.5, z+.5',
				'-x, y+.5, -z+.5',
				'-x, y, z',
				'-x, -y, -z',
				'x, y+.5, -z+.5',
				'x, -y+.5, z+.5',
				'x, -y, -z',
				'x, y, z',
				'-x+.5, -y, z+.5',
				'-x+.5, y, -z+.5',
				'-x+.5, y+.5, z',
				'-x+.5, -y+.5, -z',
				'x+.5, y, -z+.5',
				'x+.5, -y, z+.5',
				'x+.5, -y+.5, -z',
				'x+.5, y+.5, z'],
			'A m m m':['x, -y, z',
				'x, y, -z',
				'-x, y, z',
				'-x, -y, -z',
				'-x, y, -z',
				'-x, -y, z',
				'x, -y, -z',
				'x, y, z',
				'x, -y+.5, z+.5',
				'x, y+.5, -z+.5',
				'-x, y+.5, z+.5',
				'-x, -y+.5, -z+.5',
				'-x, y+.5, -z+.5',
				'-x, -y+.5, z+.5',
				'x, -y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'B m m m':['x,y,z',
				'-x,y,-z',
				'-x,-y,z',
				'x,-y,-z',
				'-x,-y,-z',
				'x,-y,z',
				'x,y,-z',
				'-x,y,z',
				'x+1/2,y,z+1/2',
				'-x+1/2,y,-z+1/2',
				'-x+1/2,-y,z+1/2',
				'x+1/2,-y,-z+1/2',
				'-x+1/2,-y,-z+1/2',
				'x+1/2,-y,z+1/2',
				'x+1/2,y,-z+1/2',
				'-x+1/2,y,z+1/2'],
			'A m a a':['x+.5, y, -z',
				'x+.5, -y, z',
				'-x, y, z',
				'-x, -y, -z',
				'-x+.5, -y, z',
				'-x+.5, y, -z',
				'x, -y, -z',
				'x, y, z',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y+.5, z+.5',
				'-x, y+.5, z+.5',
				'-x, -y+.5, -z+.5',
				'-x+.5, -y+.5, z+.5',
				'-x+.5, y+.5, -z+.5',
				'x, -y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'B b m b':['-x, y+.5, z',
				'x, y+.5, -z',
				'x, -y, z',
				'-x, -y, -z',
				'x, -y+.5, -z',
				'-x, -y+.5, z',
				'-x, y, -z',
				'x, y, z',
				'-x+.5, y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y, z+.5',
				'-x+.5, -y, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'-x+.5, -y+.5, z+.5',
				'-x+.5, y, -z+.5',
				'x+.5, y, z+.5'],
			'A b m m':['-x, y+.5, z',
				'x, y+.5, -z',
				'x, -y, z',
				'-x, -y, -z',
				'x, -y+.5, -z',
				'-x, -y+.5, z',
				'-x, y, -z',
				'x, y, z',
				'-x, y, z+.5',
				'x, y, -z+.5',
				'x, -y+.5, z+.5',
				'-x, -y+.5, -z+.5',
				'x, -y, -z+.5',
				'-x, -y, z+.5',
				'-x, y+.5, -z+.5',
				'x, y+.5, z+.5'],
			'A c m m':['-x, y, z+.5',
				'x, -y, z+.5',
				'x, y, -z',
				'-x, -y, -z',
				'x, -y, -z+.5',
				'-x, y, -z+.5',
				'-x, -y, z',
				'x, y, z',
				'-x, y+.5, z',
				'x, -y+.5, z',
				'x, y+.5, -z+.5',
				'-x, -y+.5, -z+.5',
				'x, -y+.5, -z',
				'-x, y+.5, -z',
				'-x, -y+.5, z+.5',
				'x, y+.5, z+.5'],
			'B m a m':['x,y,z',
				'-x,y,-z+1/2',
				'-x,-y,z+1/2',
				'x,-y,-z',
				'-x,-y,-z',
				'x,-y,z+1/2',
				'x,y,-z+1/2',
				'-x,y,z',
				'x+1/2,y,z+1/2',
				'-x+1/2,y,-z',
				'-x+1/2,-y,z',
				'x+1/2,-y,-z+1/2',
				'-x+1/2,-y,-z+1/2',
				'x+1/2,-y,z',
				'x+1/2,y,-z',
				'-x+1/2,y,z+1/2'],
			'B m c m':['x, -y, z+.5',
				'-x, y, z+.5',
				'x, y, -z',
				'-x, -y, -z',
				'-x, y, -z+.5',
				'x, -y, -z+.5',
				'-x, -y, z',
				'x, y, z',
				'x+.5, -y, z',
				'-x+.5, y, z',
				'x+.5, y, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, y, -z',
				'x+.5, -y, -z',
				'-x+.5, -y, z+.5',
				'x+.5, y, z+.5'],
			'C m m a':['x+.5, y, -z',
				'x+.5, -y, z',
				'-x, y, z',
				'-x, -y, -z',
				'-x+.5, -y, z',
				'-x+.5, y, -z',
				'x, -y, -z',
				'x, y, z',
				'x, y+.5, -z',
				'x, -y+.5, z',
				'-x+.5, y+.5, z',
				'-x+.5, -y+.5, -z',
				'-x, -y+.5, z',
				'-x, y+.5, -z',
				'x+.5, -y+.5, -z',
				'x+.5, y+.5, z'],
			'C m m b':['x,y,z',
				'-x+1/2,-y,z',
				'x+1/2,-y,-z',
				'-x,y,-z',
				'-x,-y,-z',
				'x+1/2,y,-z',
				'-x+1/2,y,z',
				'x,-y,z',
				'x+1/2,y+1/2,z',
				'-x,-y+1/2,z',
				'x,-y+1/2,-z',
				'-x+1/2,y+1/2,-z',
				'-x+1/2,-y+1/2,-z',
				'x,y+1/2,-z',
				'-x,y+1/2,z',
				'x+1/2,-y+1/2,z'],
			'I c m a':['-x, y+.5, z',
				'x, y+.5, -z',
				'x, -y, z',
				'-x, -y, -z',
				'x, -y+.5, -z',
				'-x, -y+.5, z',
				'-x, y, -z',
				'x, y, z',
				'-x+.5, y, z+.5',
				'x+.5, y, -z+.5',
				'x+.5, -y+.5, z+.5',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'-x+.5, -y, z+.5',
				'-x+.5, y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I m c b':['x+.5, y, -z',
				'x+.5, -y, z',
				'-x, y, z',
				'-x, -y, -z',
				'-x+.5, -y, z',
				'-x+.5, y, -z',
				'x, -y, -z',
				'x, y, z',
				'x, y+.5, -z+.5',
				'x, -y+.5, z+.5',
				'-x+.5, y+.5, z+.5',
				'-x+.5, -y+.5, -z+.5',
				'-x, -y+.5, z+.5',
				'-x, y+.5, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I c a b':['x,y,z',
				'-x,-y+1/2,z+1/2',
				'x+1/2,-y,-z+1/2',
				'-x+1/2,y+1/2,-z',
				'-x,-y,-z',
				'x,y+1/2,-z+1/2',
				'-x+1/2,y,z+1/2',
				'x+1/2,-y+1/2,z',
				'x+1/2,y+1/2,z+1/2',
				'-x+1/2,-y,z',
				'x,-y+1/2,-z',
				'-x,y,-z+1/2',
				'-x+1/2,-y+1/2,-z+1/2',
				'x+1/2,y,-z',
				'-x,y+1/2,z',
				'x,-y,z+1/2'],
			'I b m m':['-x, -y, z+.5',
				'x, -y, -z+.5',
				'x, -y, z',
				'-x, -y, -z',
				'x, y, -z+.5',
				'-x, y, z+.5',
				'-x, y, -z',
				'x, y, z',
				'-x+.5, -y+.5, z',
				'x+.5, -y+.5, -z',
				'x+.5, -y+.5, z+.5',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, -z',
				'-x+.5, y+.5, z',
				'-x+.5, y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I c m m':['-x, y+.5, -z',
				'x, -y+.5, -z',
				'x, y, -z',
				'-x, -y, -z',
				'x, -y+.5, z',
				'-x, y+.5, z',
				'-x, -y, z',
				'x, y, z',
				'-x+.5, y, -z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, y+.5, -z+.5',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, -y, z+.5',
				'-x+.5, y, z+.5',
				'-x+.5, -y+.5, z+.5',
				'x+.5, y+.5, z+.5'],
			'I m a m':['-x, -y, z+.5',
				'-x, y, -z+.5',
				'-x, y, z',
				'-x, -y, -z',
				'x, y, -z+.5',
				'x, -y, z+.5',
				'x, -y, -z',
				'x, y, z',
				'-x+.5, -y+.5, z',
				'-x+.5, y+.5, -z',
				'-x+.5, y+.5, z+.5',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, -z',
				'x+.5, -y+.5, z',
				'x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'I m c m':['x+.5, -y, -z',
				'-x+.5, y, -z',
				'x, y, -z',
				'-x, -y, -z',
				'-x+.5, y, z',
				'x+.5, -y, z',
				'-x, -y, z',
				'x, y, z',
				'x, -y+.5, -z+.5',
				'-x, y+.5, -z+.5',
				'x+.5, y+.5, -z+.5',
				'-x+.5, -y+.5, -z+.5',
				'-x, y+.5, z+.5',
				'x, -y+.5, z+.5',
				'-x+.5, -y+.5, z+.5',
				'x+.5, y+.5, z+.5'],
			'I m m b':['x+.5, -y, -z',
				'-x+.5, -y, z',
				'x, -y, z',
				'-x, -y, -z',
				'-x+.5, y, z',
				'x+.5, y, -z',
				'-x, y, -z',
				'x, y, z',
				'x, -y+.5, -z+.5',
				'-x, -y+.5, z+.5',
				'x+.5, -y+.5, z+.5',
				'-x+.5, -y+.5, -z+.5',
				'-x, y+.5, z+.5',
				'x, y+.5, -z+.5',
				'-x+.5, y+.5, -z+.5',
				'x+.5, y+.5, z+.5'],
			'C 4 2 21':['-y+.5, x, z',
				'-y+.5, -x, -z',
				'y+.5, -x, z',
				'y+.5, x, -z',
				'-x, y, -z',
				'x, -y, -z',
				'-x, -y, z',
				'x, y, z',
				'-y, x+.5, z',
				'-y, -x+.5, -z',
				'y, -x+.5, z',
				'y, x+.5, -z',
				'-x+.5, y+.5, -z',
				'x+.5, -y+.5, -z',
				'-x+.5, -y+.5, z',
				'x+.5, y+.5, z'],
			'C -4 m 21':['y+.5, x, -z',
				'-y, -x+.5, -z',
				'-y+.5, x, -z',
				'y, -x+.5, -z',
				'x+.5, -y+.5, z',
				'-x, y, z',
				'-x+.5, -y+.5, z',
				'x, y, z',
				'y, x+.5, -z',
				'-y+.5, -x, -z',
				'-y, x+.5, -z',
				'y+.5, -x, -z',
				'x, -y, z',
				'-x+.5, y+.5, z',
				'-x, -y, z',
				'x+.5, y+.5, z'],
			'C -4 2 b':['-y, -x+.5, z',
				'x, -y+.5, -z',
				'y, x+.5, z',
				'-x, y+.5, -z',
				'y, -x, -z',
				'-y, x, -z',
				'-x, -y, z',
				'x, y, z',
				'-y+.5, -x, z',
				'x+.5, -y, -z',
				'y+.5, x, z',
				'-x+.5, y, -z',
				'y+.5, -x+.5, -z',
				'-y+.5, x+.5, -z',
				'-x+.5, -y+.5, z',
				'x+.5, y+.5, z'],
			'F -4 d 2':['-y+.25, -x+.25, -z+.75',
				'y+.25, x+.25, -z+.75',
				'x+.25, -y+.25, z+.75',
				'-x+.25, y+.25, z+.75',
				'y, -x, -z',
				'-y, x, -z',
				'-x, -y, z',
				'x, y, z',
				'-y+.25, -x+.75, -z+.25',
				'-y+.75, -x+.25, -z+.25',
				'-y+.75, -x+.75, -z+.75',
				'y+.25, x+.75, -z+.25',
				'y+.75, x+.25, -z+.25',
				'y+.75, x+.75, -z+.75',
				'x+.25, -y+.75, z+.25',
				'x+.75, -y+.25, z+.25',
				'x+.75, -y+.75, z+.75',
				'-x+.25, y+.75, z+.25',
				'-x+.75, y+.25, z+.25',
				'-x+.75, y+.75, z+.75',
				'y, -x+.5, -z+.5',
				'y+.5, -x, -z+.5',
				'y+.5, -x+.5, -z',
				'-y, x+.5, -z+.5',
				'-y+.5, x, -z+.5',
				'-y+.5, x+.5, -z',
				'-x, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'-x+.5, -y+.5, z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'C 4/m c c':['y, x, z+.5',
				'-y, -x, z+.5',
				'-x, y, z+.5',
				'x, -y, z+.5',
				'-y, x, -z',
				'y, -x, -z',
				'x, y, -z',
				'-x, -y, -z',
				'-y, -x, -z+.5',
				'y, x, -z+.5',
				'x, -y, -z+.5',
				'-x, y, -z+.5',
				'y, -x, z',
				'-y, x, z',
				'-x, -y, z',
				'x, y, z',
				'y+.5, x+.5, z+.5',
				'-y+.5, -x+.5, z+.5',
				'-x+.5, y+.5, z+.5',
				'x+.5, -y+.5, z+.5',
				'-y+.5, x+.5, -z',
				'y+.5, -x+.5, -z',
				'x+.5, y+.5, -z',
				'-x+.5, -y+.5, -z',
				'-y+.5, -x+.5, -z+.5',
				'y+.5, x+.5, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'-x+.5, y+.5, -z+.5',
				'y+.5, -x+.5, z',
				'-y+.5, x+.5, z',
				'-x+.5, -y+.5, z',
				'x+.5, y+.5, z'],
			'F 4/m m m':['x, -y, -z',
				'y, -x, -z',
				'y, x, -z',
				'-x, -y, -z',
				'-x, y, -z',
				'-y, x, -z',
				'-y, -x, -z',
				'x, y, -z',
				'x, -y, z',
				'y, -x, z',
				'y, x, z',
				'-x, -y, z',
				'-x, y, z',
				'-y, x, z',
				'-y, -x, z',
				'x, y, z',
				'x, -y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, -y+.5, -z',
				'y, -x+.5, -z+.5',
				'y+.5, -x, -z+.5',
				'y+.5, -x+.5, -z',
				'y, x+.5, -z+.5',
				'y+.5, x, -z+.5',
				'y+.5, x+.5, -z',
				'-x, -y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, -y+.5, -z',
				'-x, y+.5, -z+.5',
				'-x+.5, y, -z+.5',
				'-x+.5, y+.5, -z',
				'-y, x+.5, -z+.5',
				'-y+.5, x, -z+.5',
				'-y+.5, x+.5, -z',
				'-y, -x+.5, -z+.5',
				'-y+.5, -x, -z+.5',
				'-y+.5, -x+.5, -z',
				'x, y+.5, -z+.5',
				'x+.5, y, -z+.5',
				'x+.5, y+.5, -z',
				'x, -y+.5, z+.5',
				'x+.5, -y, z+.5',
				'x+.5, -y+.5, z',
				'y, -x+.5, z+.5',
				'y+.5, -x, z+.5',
				'y+.5, -x+.5, z',
				'y, x+.5, z+.5',
				'y+.5, x, z+.5',
				'y+.5, x+.5, z',
				'-x, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'-x+.5, -y+.5, z',
				'-x, y+.5, z+.5',
				'-x+.5, y, z+.5',
				'-x+.5, y+.5, z',
				'-y, x+.5, z+.5',
				'-y+.5, x, z+.5',
				'-y+.5, x+.5, z',
				'-y, -x+.5, z+.5',
				'-y+.5, -x, z+.5',
				'-y+.5, -x+.5, z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F 4/m m c':['y, x, -z+.5',
				'-y, -x, -z+.5',
				'-y, x, -z',
				'y, -x, -z',
				'x, -y, -z+.5',
				'-x, y, -z+.5',
				'x, y, -z',
				'-x, -y, -z',
				'-y, -x, z+.5',
				'y, x, z+.5',
				'y, -x, z',
				'-y, x, z',
				'-x, y, z+.5',
				'x, -y, z+.5',
				'-x, -y, z',
				'x, y, z',
				'y, x+.5, -z',
				'y+.5, x, -z',
				'y+.5, x+.5, -z+.5',
				'-y, -x+.5, -z',
				'-y+.5, -x, -z',
				'-y+.5, -x+.5, -z+.5',
				'-y, x+.5, -z+.5',
				'-y+.5, x, -z+.5',
				'-y+.5, x+.5, -z',
				'y, -x+.5, -z+.5',
				'y+.5, -x, -z+.5',
				'y+.5, -x+.5, -z',
				'x, -y+.5, -z',
				'x+.5, -y, -z',
				'x+.5, -y+.5, -z+.5',
				'-x, y+.5, -z',
				'-x+.5, y, -z',
				'-x+.5, y+.5, -z+.5',
				'x, y+.5, -z+.5',
				'x+.5, y, -z+.5',
				'x+.5, y+.5, -z',
				'-x, -y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, -y+.5, -z',
				'-y, -x+.5, z',
				'-y+.5, -x, z',
				'-y+.5, -x+.5, z+.5',
				'y, x+.5, z',
				'y+.5, x, z',
				'y+.5, x+.5, z+.5',
				'y, -x+.5, z+.5',
				'y+.5, -x, z+.5',
				'y+.5, -x+.5, z',
				'-y, x+.5, z+.5',
				'-y+.5, x, z+.5',
				'-y+.5, x+.5, z',
				'-x, y+.5, z',
				'-x+.5, y, z',
				'-x+.5, y+.5, z+.5',
				'x, -y+.5, z',
				'x+.5, -y, z',
				'x+.5, -y+.5, z+.5',
				'-x, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'-x+.5, -y+.5, z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'A 1 2/a 1 s':[	'x+.5, -y+.5, z',
				'-x+.5, y, -z+.5',
				'-x, -y+.5, -z+.5',
				'x, y, z',
				'x+.5, -y, z+.5',
				'-x+.5, y+.5, -z',
				'-x, -y, -z',
				'x, y+.5, z+.5'],
			'C 2 2 21 s':['-x, y, -z',
				'-x, -y, z+.5',
				'x, -y, -z+.5',
				'x, y, z',
				'-x+.5, y+.5, -z',
				'-x+.5, -y+.5, z+.5',
				'x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, z'],
			'P n n n s':['-x+.5, y+.5, z+.5',
				'x+.5, -y+.5, z+.5',
				'x+.5, y+.5, -z+.5',
				'-x+.5, -y+.5, -z+.5',
				'x, -y, -z',
				'-x, y, -z',
				'-x, -y, z',
				'x, y, z'],
			'P n n n z':['-x+.5, -y+.5, z',
				'-x+.5, y, -z+.5',
				'x, -y+.5, -z+.5',
				'-x, -y, -z',
				'x+.5, y+.5, -z',
				'x+.5, -y, z+.5',
				'-x, y+.5, z+.5',
				'x, y, z'],
			'P b a n s':['x+.5, -y+.5, z',
				'-x+.5, y+.5, z',
				'-x, y, -z',
				'x, -y, -z',
				'x+.5, y+.5, -z',
				'-x+.5, -y+.5, -z',
				'-x, -y, z',
				'x, y, z'],
			'P b a n z':['-x, y+.5, z',
				'x+.5, -y, z',
				'x+.5, y+.5, -z',
				'-x, -y, -z',
				'x, -y+.5, -z',
				'-x+.5, y, -z',
				'-x+.5, -y+.5, z',
				'x, y, z'],
			'P c n a s':['x,y,z',
				'-x,y,-z',
				'-x,-y,z',
				'x,-y,-z',
				'-x+1/2,-y,-z+1/2',
				'x+1/2,-y,z+1/2',
				'x+1/2,y,-z+1/2',
				'-x+1/2,y,z+1/2'],
			'P c n a z':['x,y,z',
				'-x+1/2,y,-z+1/2',
				'-x+1/2,-y,z',
				'x,-y,-z+1/2',
				'-x,-y,-z',
				'x+1/2,-y,z+1/2',
				'x+1/2,y,-z',
				'-x,y,z+1/2'],
			'P n c b s':['x,y,z',
				'x,-y,-z',
				'-x,-y,z',
				'-x,y,-z',
				'-x,-y+1/2,-z+1/2',
				'-x,y+1/2,z+1/2',
				'x,y+1/2,-z+1/2',
				'x,-y+1/2,z+1/2'],
			'P n c b z':['x,y,z',
				'x,-y+1/2,-z+1/2',
				'-x,-y+1/2,z',
				'-x,y,-z+1/2',
				'-x,-y,-z',
				'-x,y+1/2,z+1/2',
				'x,y+1/2,-z',
				'x,-y,z+1/2'],
			'P n a n s':['x+.5, y+.5, -z',
				'-x+.5, y+.5, z+.5',
				'x+.5, -y+.5, z',
				'-x+.5, -y+.5, -z+.5',
				'-x, -y, z+.5',
				'x, -y, -z',
				'-x, y, -z+.5',
				'x, y, z'],
			'P m m n s':['x+.5, -y+.5, -z',
				'x+.5, y+.5, -z',
				'x, -y, z',
				'-x, y, z',
				'-x+.5, y+.5, -z',
				'-x+.5, -y+.5, -z',
				'-x, -y, z',
				'x, y, z'],
			'P m m n z':['x+.5, y+.5, -z',
				'-x, y+.5, -z',
				'x+.5, -y, -z',
				'-x, -y, -z',
				'-x+.5, -y+.5, z',
				'x, -y+.5, z',
				'-x+.5, y, z',
				'x, y, z'],
			'P m n m s':['x+.5, -y, -z+.5',
				'x+.5, -y, z+.5',
				'x, y, -z',
				'-x, y, z',
				'-x+.5, -y, z+.5',
				'-x+.5, -y, -z+.5',
				'-x, y, -z',
				'x, y, z'],
			'P m n m z':['x+.5, -y, z+.5',
				'-x, -y, z+.5',
				'x+.5, -y, -z',
				'-x, -y, -z',
				'-x+.5, y, -z+.5',
				'x, y, -z+.5',
				'-x+.5, y, z',
				'x, y, z'],
			'P n m m s':['-x, -y+.5, z+.5',
				'-x, y+.5, z+.5',
				'x, -y, z',
				'x, y, -z',
				'-x, y+.5, -z+.5',
				'-x, -y+.5, -z+.5',
				'x, -y, -z',
				'x, y, z'],
			'P n m m z':['-x, y+.5, z+.5',
				'-x, y+.5, -z',
				'-x, -y, z+.5',
				'-x, -y, -z',
				'x, -y+.5, -z+.5',
				'x, -y+.5, z',
				'x, y, -z+.5',
				'x, y, z'],
			'A b a a s':['x,y,z',
				'x,-y+1/2,-z+1/2',
				'-x,-y,z',
				'-x,y+1/2,-z+1/2',
				'-x+1/2,-y,-z+1/2',
				'-x+1/2,y+1/2,z',
				'x+1/2,y,-z+1/2',
				'x+1/2,-y+1/2,z',
				'x,y+1/2,z+1/2',
				'x,-y,-z',
				'-x,-y+1/2,z+1/2',
				'-x,y,-z',
				'-x+1/2,-y+1/2,-z',
				'-x+1/2,y,z+1/2',
				'x+1/2,y+1/2,-z',
				'x+1/2,-y,z+1/2'],
			'A b a a z':['x,y,z',
				'x,-y+1/2,-z',
				'-x+1/2,-y,z',
				'-x+1/2,y+1/2,-z',
				'-x,-y,-z',
				'-x,y+1/2,z',
				'x+1/2,y,-z',
				'x+1/2,-y+1/2,z',
				'x,y+1/2,z+1/2',
				'x,-y,-z+1/2',
				'-x+1/2,-y+1/2,z+1/2',
				'-x+1/2,y,-z+1/2',
				'-x,-y+1/2,-z+1/2',
				'-x,y,z+1/2',
				'x+1/2,y+1/2,-z+1/2',
				'x+1/2,-y,z+1/2'],
			'A c a a s':['x,y,z',
				'x,-y+1/2,-z+1/2',
				'-x,y,-z',
				'-x,-y+1/2,z+1/2',
				'-x+1/2,-y+1/2,-z',
				'-x+1/2,y,z+1/2',
				'x+1/2,-y+1/2,z',
				'x+1/2,y,-z+1/2',
				'x,y+1/2,z+1/2',
				'x,-y,-z',
				'-x,y+1/2,-z+1/2',
				'-x,-y,z',
				'-x+1/2,-y,-z+1/2',
				'-x+1/2,y+1/2,z',
				'x+1/2,-y,z+1/2',
				'x+1/2,y+1/2,-z'],
			'A c a a z':['x,y,z',
				'x,-y,-z+1/2',
				'-x+1/2,y,-z',
				'-x+1/2,-y,z+1/2',
				'-x,-y,-z',
				'-x,y,z+1/2',
				'x+1/2,-y,z',
				'x+1/2,y,-z+1/2',
				'x,y+1/2,z+1/2',
				'x,-y+1/2,-z',
				'-x+1/2,y+1/2,-z+1/2',
				'-x+1/2,-y+1/2,z',
				'-x,-y+1/2,-z+1/2',
				'-x,y+1/2,z',
				'x+1/2,-y+1/2,z+1/2',
				'x+1/2,y+1/2,-z'],
			'B b a b s':['x,y,z',
				'-x+1/2,y,-z+1/2',
				'-x,-y,z',
				'x+1/2,-y,-z+1/2',
				'-x,-y+1/2,-z+1/2',
				'x+1/2,-y+1/2,z',
				'x,y+1/2,-z+1/2',
				'-x+1/2,y+1/2,z',
				'x+1/2,y,z+1/2',
				'-x,y,-z',
				'-x+1/2,-y,z+1/2',
				'x,-y,-z',
				'-x+1/2,-y+1/2,-z',
				'x,-y+1/2,z+1/2',
				'x+1/2,y+1/2,-z',
				'-x,y+1/2,z+1/2'],
			'B b a b z':['x, -y, z+.5',
				'-x+.5, -y+.5, z+.5',
				'x+.5, -y+.5, -z',
				'-x, -y, -z',
				'-x, y, -z+.5',
				'x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, z',
				'x, y, z',
				'x+.5, -y, z',
				'-x, -y+.5, z',
				'x, -y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, y, -z',
				'x, y+.5, -z',
				'-x, y+.5, z+.5',
				'x+.5, y, z+.5'],
			'B b c b s':['x,y,z',
				'-x+1/2,y,-z+1/2',
				'x,-y,-z',
				'-x+1/2,-y,z+1/2',
				'-x+1/2,-y+1/2,-z',
				'x,-y+1/2,z+1/2',
				'-x+1/2,y+1/2,z',
				'x,y+1/2,-z+1/2',
				'x+1/2,y,z+1/2',
				'-x,y,-z',
				'x+1/2,-y,-z+1/2',
				'-x,-y,z',
				'-x,-y+1/2,-z+1/2',
				'x+1/2,-y+1/2,z',
				'-x,y+1/2,z+1/2',
				'x+1/2,y+1/2,-z'],
			'B b c b z':['x+.5, -y, z',
				'x+.5, -y+.5, -z+.5',
				'-x, -y+.5, z+.5',
				'-x, -y, -z',
				'-x+.5, y, -z',
				'-x+.5, y+.5, z+.5',
				'x, y+.5, -z+.5',
				'x, y, z',
				'x, -y, z+.5',
				'x, -y+.5, -z',
				'-x+.5, -y+.5, z',
				'-x+.5, -y, -z+.5',
				'-x, y, -z+.5',
				'-x, y+.5, z',
				'x+.5, y+.5, -z',
				'x+.5, y, z+.5'],
			'C c c a s':['-x+.5, y, z+.5',
				'x, -y+.5, z+.5',
				'x+.5, y, -z+.5',
				'-x, -y+.5, -z+.5',
				'x+.5, -y+.5, -z',
				'-x, y, -z',
				'-x+.5, -y+.5, z',
				'x, y, z',
				'-x, y+.5, z+.5',
				'x+.5, -y, z+.5',
				'x, y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'x, -y, -z',
				'-x+.5, y+.5, -z',
				'-x, -y, z',
				'x+.5, y+.5, z'],
			'C c c a z':['x, y+.5, -z',
				'-x+.5, y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'-x, -y, -z',
				'-x, -y+.5, z',
				'x+.5, -y+.5, z+.5',
				'-x+.5, y, z+.5',
				'x, y, z',
				'x+.5, y, -z',
				'-x, y, -z+.5',
				'x, -y+.5, -z+.5',
				'-x+.5, -y+.5, -z',
				'-x+.5, -y, z',
				'x, -y, z+.5',
				'-x, y+.5, z+.5',
				'x+.5, y+.5, z'],
			'C c c b s':['x,y,z',
				'-x+1/2,-y+1/2,z',
				'x,-y,-z',
				'-x+1/2,y+1/2,-z',
				'-x+1/2,-y,-z+1/2',
				'x,y+1/2,-z+1/2',
				'-x+1/2,y,z+1/2',
				'x,-y+1/2,z+1/2',
				'x+1/2,y+1/2,z',
				'-x,-y,z',
				'x+1/2,-y+1/2,-z',
				'-x,y,-z',
				'-x,-y+1/2,-z+1/2',
				'x+1/2,y,-z+1/2',
				'-x,y+1/2,z+1/2',
				'x+1/2,-y,z+1/2'],
			'C c c b z':['x,y,z',
				'-x,-y+1/2,z',
				'x,-y,-z+1/2',
				'-x,y+1/2,-z+1/2',
				'-x,-y,-z',
				'x,y+1/2,-z',
				'-x,y,z+1/2',
				'x,-y+1/2,z+1/2',
				'x+1/2,y+1/2,z',
				'-x+1/2,-y,z',
				'x+1/2,-y+1/2,-z+1/2',
				'-x+1/2,y,-z+1/2',
				'-x+1/2,-y+1/2,-z',
				'x+1/2,y,-z',
				'-x+1/2,y+1/2,z+1/2',
				'x+1/2,-y,z+1/2'],
			'C c c e s':['-x+.5, y, z+.5',
				'x, -y+.5, z+.5',
				'x+.5, y, -z+.5',
				'-x, -y+.5, -z+.5',
				'x+.5, -y+.5, -z',
				'-x, y, -z',
				'-x+.5, -y+.5, z',
				'x, y, z',
				'-x, y+.5, z+.5',
				'x+.5, -y, z+.5',
				'x, y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'x, -y, -z',
				'-x+.5, y+.5, -z',
				'-x, -y, z',
				'x+.5, y+.5, z'],
			'F d d d s':['x+.25, y+.25, -z+.25',
				'-x+.25, y+.25, z+.25',
				'-x, -y, z',
				'x, -y, -z',
				'x+.25, -y+.25, z+.25',
				'-x+.25, -y+.25, -z+.25',
				'-x, y, -z',
				'x, y, z',
				'x+.25, y+.75, -z+.75',
				'x+.75, y+.25, -z+.75',
				'x+.75, y+.75, -z+.25',
				'-x+.25, y+.75, z+.75',
				'-x+.75, y+.25, z+.75',
				'-x+.75, y+.75, z+.25',
				'-x, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'-x+.5, -y+.5, z',
				'x, -y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, -y+.5, -z',
				'x+.25, -y+.75, z+.75',
				'x+.75, -y+.25, z+.75',
				'x+.75, -y+.75, z+.25',
				'-x+.25, -y+.75, -z+.75',
				'-x+.75, -y+.25, -z+.75',
				'-x+.75, -y+.75, -z+.25',
				'-x, y+.5, -z+.5',
				'-x+.5, y, -z+.5',
				'-x+.5, y+.5, -z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F d d d z':['x+.75, y+.75, -z',
				'x+.75, -y, z+.75',
				'-x, y+.75, z+.75',
				'-x, -y, -z',
				'-x+.25, -y+.25, z',
				'-x+.25, y, -z+.25',
				'x, -y+.25, -z+.25',
				'x, y, z',
				'x+.75, y+.25, -z+.5',
				'x+.25, y+.75, -z+.5',
				'x+.25, y+.25, -z',
				'x+.75, -y+.5, z+.25',
				'x+.25, -y, z+.25',
				'x+.25, -y+.5, z+.75',
				'-x, y+.25, z+.25',
				'-x+.5, y+.75, z+.25',
				'-x+.5, y+.25, z+.75',
				'-x, -y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, -y+.5, -z',
				'-x+.25, -y+.75, z+.5',
				'-x+.75, -y+.25, z+.5',
				'-x+.75, -y+.75, z',
				'-x+.25, y+.5, -z+.75',
				'-x+.75, y, -z+.75',
				'-x+.75, y+.5, -z+.25',
				'x, -y+.75, -z+.75',
				'x+.5, -y+.25, -z+.75',
				'x+.5, -y+.75, -z+.25',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'P 42/n s':['y+.5, -x+.5, z+.5',
				'-y+.5, x+.5, z+.5',
				'y, -x, -z',
				'-y, x, -z',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, -z+.5',
				'-x, -y, z',
				'x, y, z'],
			'P 42/n z':['-y+.5, x, -z+.5',
				'y, -x+.5, -z+.5',
				'x+.5, y+.5, -z',
				'-x, -y, -z',
				'y+.5, -x, z+.5',
				'-y, x+.5, z+.5',
				'-x+.5, -y+.5, z',
				'x, y, z'],
			'P 4/n s':['y+.5, -x+.5, z',
				'-y+.5, x+.5, z',
				'y, -x, -z',
				'-y, x, -z',
				'-x+.5, -y+.5, -z',
				'x+.5, y+.5, -z',
				'-x, -y, z',
				'x, y, z'],
			'P 4/n z':['-y, x+.5, -z',
				'y+.5, -x, -z',
				'x+.5, y+.5, -z',
				'-x, -y, -z',
				'y, -x+.5, z',
				'-y+.5, x, z',
				'-x+.5, -y+.5, z',
				'x, y, z'],
			'I 41/a s':['y, -x+.5, z+.25',
				'-y, x+.5, z+.25',
				'y, -x, -z',
				'-y, x, -z',
				'-x, -y+.5, -z+.25',
				'x, y+.5, -z+.25',
				'-x, -y, z',
				'x, y, z',
				'y+.5, -x, z+.75',
				'-y+.5, x, z+.75',
				'y+.5, -x+.5, -z+.5',
				'-y+.5, x+.5, -z+.5',
				'-x+.5, -y, -z+.75',
				'x+.5, y, -z+.75',
				'-x+.5, -y+.5, z+.5',
				'x+.5, y+.5, z+.5'],
			'I 41/a z':['-y+.75, x+.75, -z+.75',
				'y+.25, -x+.75, -z+.75',
				'x, y+.5, -z',
				'-x, -y, -z',
				'y+.25, -x+.25, z+.25',
				'-y+.75, x+.25, z+.25',
				'-x, -y+.5, z',
				'x, y, z',
				'-y+.25, x+.25, -z+.25',
				'y+.75, -x+.25, -z+.25',
				'x+.5, y, -z+.5',
				'-x+.5, -y+.5, -z+.5',
				'y+.75, -x+.75, z+.75',
				'-y+.25, x+.75, z+.75',
				'-x+.5, -y, z+.5',
				'x+.5, y+.5, z+.5'],
			'P 4/n b m s':['y+.5, x+.5, z',
				'-y+.5, -x+.5, z',
				'y, x, -z',
				'-y, -x, -z',
				'y+.5, -x+.5, -z',
				'-y+.5, x+.5, -z',
				'y, -x, z',
				'-y, x, z',
				'x+.5, -y+.5, z',
				'-x+.5, y+.5, z',
				'x, -y, -z',
				'-x, y, -z',
				'-x+.5, -y+.5, -z',
				'x+.5, y+.5, -z',
				'-x, -y, z',
				'x, y, z'],
			'P 4/n b m z':['y+.5, x+.5, z',
				'y, -x+.5, z',
				'-y+.5, x, z',
				'-y, -x, z',
				'-y+.5, -x+.5, -z',
				'-y, x+.5, -z',
				'y+.5, -x, -z',
				'y, x, -z',
				'x+.5, y+.5, -z',
				'-x+.5, y, -z',
				'x, -y+.5, -z',
				'-x, -y, -z',
				'-x+.5, -y+.5, z',
				'x+.5, -y, z',
				'-x, y+.5, z',
				'x, y, z'],
			'P 4/n n c s':['y+.5, x+.5, z+.5',
				'-y+.5, -x+.5, z+.5',
				'y, x, -z',
				'-y, -x, -z',
				'y+.5, -x+.5, -z+.5',
				'-y+.5, x+.5, -z+.5',
				'y, -x, z',
				'-y, x, z',
				'x+.5, -y+.5, z+.5',
				'-x+.5, y+.5, z+.5',
				'x, -y, -z',
				'-x, y, -z',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, -z+.5',
				'-x, -y, z',
				'x, y, z'],
			'P 4/n n c z':['-y, x+.5, -z',
				'y+.5, -x, -z',
				'y+.5, x+.5, z+.5',
				'-y, -x, z+.5',
				'y, -x+.5, z',
				'-y+.5, x, z',
				'-y+.5, -x+.5, -z+.5',
				'y, x, -z+.5',
				'x+.5, -y, z+.5',
				'-x, y+.5, z+.5',
				'x+.5, y+.5, -z',
				'-x, -y, -z',
				'-x+.5, y, -z+.5',
				'x, -y+.5, -z+.5',
				'-x+.5, -y+.5, z',
				'x, y, z'],
			'P 4/n m m s':['-y+.5, -x+.5, z',
				'y+.5, x+.5, z',
				'-y, -x, -z',
				'y, x, -z',
				'y+.5, -x+.5, z',
				'-y+.5, x+.5, z',
				'y, -x, -z',
				'-y, x, -z',
				'x+.5, -y+.5, -z',
				'-x+.5, y+.5, -z',
				'x, -y, z',
				'-x, y, z',
				'-x+.5, -y+.5, -z',
				'x+.5, y+.5, -z',
				'-x, -y, z',
				'x, y, z'],
			'P 4/n m m z':['y+.5, x+.5, -z',
				'-y, x+.5, -z',
				'y+.5, -x, -z',
				'-y, -x, -z',
				'x+.5, y+.5, -z',
				'-x, y+.5, -z',
				'x+.5, -y, -z',
				'-x, -y, -z',
				'-y+.5, -x+.5, z',
				'y, -x+.5, z',
				'-y+.5, x, z',
				'y, x, z',
				'-x+.5, -y+.5, z',
				'x, -y+.5, z',
				'-x+.5, y, z',
				'x, y, z'],
			'P 4/n c c s':['y+.5, x+.5, z+.5',
				'y+.5, -x+.5, z',
				'-y, -x, -z+.5',
				'y, -x, -z',
				'-y+.5, -x+.5, z+.5',
				'-y+.5, x+.5, z',
				'y, x, -z+.5',
				'-y, x, -z',
				'x+.5, -y+.5, -z+.5',
				'-x+.5, -y+.5, -z',
				'x, -y, z+.5',
				'-x, -y, z',
				'-x+.5, y+.5, -z+.5',
				'x+.5, y+.5, -z',
				'-x, y, z+.5',
				'x, y, z'],
			'P 4/n c c z':['y+.5, x+.5, -z+.5',
				'-y, x+.5, -z',
				'y+.5, -x, -z',
				'-y, -x, -z+.5',
				'x+.5, y+.5, -z',
				'-x, y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'-x, -y, -z',
				'-y+.5, -x+.5, z+.5',
				'y, -x+.5, z',
				'-y+.5, x, z',
				'y, x, z+.5',
				'-x+.5, -y+.5, z',
				'x, -y+.5, z+.5',
				'-x+.5, y, z+.5',
				'x, y, z'],
			'P 42/n b c s':['y+.5, -x+.5, z+.5',
				'y+.5, x+.5, -z',
				'y, x, z+.5',
				'y, -x, -z',
				'-y+.5, x+.5, z+.5',
				'-y+.5, -x+.5, -z',
				'-y, -x, z+.5',
				'-y, x, -z',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, -y+.5, z',
				'x, -y, -z+.5',
				'-x, -y, z',
				'x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, z',
				'-x, y, -z+.5',
				'x, y, z'],
			'P 42/n b c z':['y, x, -z+.5',
				'-y, x+.5, -z+.5',
				'y+.5, -x, -z+.5',
				'-y+.5, -x+.5, -z+.5',
				'x+.5, y+.5, -z',
				'-x+.5, y, -z',
				'x, -y+.5, -z',
				'-x, -y, -z',
				'-y, -x, z+.5',
				'y, -x+.5, z+.5',
				'-y+.5, x, z+.5',
				'y+.5, x+.5, z+.5',
				'-x+.5, -y+.5, z',
				'x+.5, -y, z',
				'-x, y+.5, z',
				'x, y, z'],
			'P 42/n n m s':['-y+.5, -x+.5, -z+.5',
				'y+.5, x+.5, -z+.5',
				'-y, -x, z',
				'y, x, z',
				'y+.5, -x+.5, z+.5',
				'-y+.5, x+.5, z+.5',
				'y, -x, -z',
				'-y, x, -z',
				'x+.5, -y+.5, z+.5',
				'-x+.5, y+.5, z+.5',
				'x, -y, -z',
				'-x, y, -z',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, -z+.5',
				'-x, -y, z',
				'x, y, z'],
			'P 42/n n m z':['y, x, -z',
				'y+.5, -x, -z+.5',
				'-y, x+.5, -z+.5',
				'-y+.5, -x+.5, -z',
				'-y, -x, z',
				'-y+.5, x, z+.5',
				'y, -x+.5, z+.5',
				'y+.5, x+.5, z',
				'x+.5, y+.5, -z',
				'-x+.5, y, -z+.5',
				'x, -y+.5, -z+.5',
				'-x, -y, -z',
				'-x+.5, -y+.5, z',
				'x+.5, -y, z+.5',
				'-x, y+.5, z+.5',
				'x, y, z'],
			'P 42/n m c s':['-y+.5, -x+.5, z+.5',
				'y+.5, x+.5, z+.5',
				'-y, -x, -z',
				'y, x, -z',
				'y+.5, -x+.5, z+.5',
				'-y+.5, x+.5, z+.5',
				'y, -x, -z',
				'-y, x, -z',
				'x+.5, -y+.5, -z+.5',
				'-x+.5, y+.5, -z+.5',
				'x, -y, z',
				'-x, y, z',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, y+.5, -z+.5',
				'-x, -y, z',
				'x, y, z'],
			'P 42/n m c z':['y+.5, x+.5, -z+.5',
				'-y, x+.5, -z+.5',
				'y+.5, -x, -z+.5',
				'-y, -x, -z+.5',
				'x+.5, y+.5, -z',
				'-x, y+.5, -z',
				'x+.5, -y, -z',
				'-x, -y, -z',
				'-y+.5, -x+.5, z+.5',
				'y, -x+.5, z+.5',
				'-y+.5, x, z+.5',
				'y, x, z+.5',
				'-x+.5, -y+.5, z',
				'x, -y+.5, z',
				'-x+.5, y, z',
				'x, y, z'],
			'P 42/n c m s':['y+.5, -x+.5, z+.5',
				'y+.5, x+.5, z',
				'y, x, -z+.5',
				'y, -x, -z',
				'-y+.5, x+.5, z+.5',
				'-y+.5, -x+.5, z',
				'-y, -x, -z+.5',
				'-y, x, -z',
				'-x+.5, -y+.5, -z+.5',
				'x+.5, -y+.5, -z',
				'x, -y, z+.5',
				'-x, -y, z',
				'x+.5, y+.5, -z+.5',
				'-x+.5, y+.5, -z',
				'-x, y, z+.5',
				'x, y, z'],
			'P 42/n c m z':['y+.5, x+.5, -z',
				'y+.5, -x, -z+.5',
				'-y, x+.5, -z+.5',
				'-y, -x, -z',
				'x+.5, y+.5, -z',
				'-x, y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'-x, -y, -z',
				'-y+.5, -x+.5, z',
				'-y+.5, x, z+.5',
				'y, -x+.5, z+.5',
				'y, x, z',
				'-x+.5, -y+.5, z',
				'x, -y+.5, z+.5',
				'-x+.5, y, z+.5',
				'x, y, z'],
			'I 41/a m d s':['y, -x+.5, z+.25',
				'-y, x+.5, z+.25',
				'y, -x, -z',
				'-y, x, -z',
				'-y, -x+.5, z+.25',
				'y, x+.5, z+.25',
				'-y, -x, -z',
				'y, x, -z',
				'x, -y+.5, -z+.25',
				'-x, y+.5, -z+.25',
				'x, -y, z',
				'-x, y, z',
				'-x, -y+.5, -z+.25',
				'x, y+.5, -z+.25',
				'-x, -y, z',
				'x, y, z',
				'y+.5, -x, z+.75',
				'-y+.5, x, z+.75',
				'y+.5, -x+.5, -z+.5',
				'-y+.5, x+.5, -z+.5',
				'-y+.5, -x, z+.75',
				'y+.5, x, z+.75',
				'-y+.5, -x+.5, -z+.5',
				'y+.5, x+.5, -z+.5',
				'x+.5, -y, -z+.75',
				'-x+.5, y, -z+.75',
				'x+.5, -y+.5, z+.5',
				'-x+.5, y+.5, z+.5',
				'-x+.5, -y, -z+.75',
				'x+.5, y, -z+.75',
				'-x+.5, -y+.5, z+.5',
				'x+.5, y+.5, z+.5'],
			'I 41/a m d z':['y+.25, x+.75, -z+.25',
				'y+.25, -x+.75, -z+.25',
				'x, y+.5, -z',
				'x, -y, -z',
				'-y+.75, x+.75, -z+.25',
				'-y+.75, -x+.75, -z+.25',
				'-x, y+.5, -z',
				'-x, -y, -z',
				'-y+.75, -x+.25, z+.75',
				'-y+.75, x+.25, z+.75',
				'-x, -y+.5, z',
				'-x, y, z',
				'y+.25, -x+.25, z+.75',
				'y+.25, x+.25, z+.75',
				'x, -y+.5, z',
				'x, y, z',
				'y+.75, x+.25, -z+.75',
				'y+.75, -x+.25, -z+.75',
				'x+.5, y, -z+.5',
				'x+.5, -y+.5, -z+.5',
				'-y+.25, x+.25, -z+.75',
				'-y+.25, -x+.25, -z+.75',
				'-x+.5, y, -z+.5',
				'-x+.5, -y+.5, -z+.5',
				'-y+.25, -x+.75, z+.25',
				'-y+.25, x+.75, z+.25',
				'-x+.5, -y, z+.5',
				'-x+.5, y+.5, z+.5',
				'y+.75, -x+.75, z+.25',
				'y+.75, x+.75, z+.25',
				'x+.5, -y, z+.5',
				'x+.5, y+.5, z+.5'],
			'I 41/a c d s':['-y+.5, -x, z+.25',
				'y+.5, -x, z+.75',
				'-y, -x, -z+.5',
				'y, -x, -z',
				'y+.5, x, z+.25',
				'-y+.5, x, z+.75',
				'y, x, -z+.5',
				'-y, x, -z',
				'-x, y+.5, -z+.75',
				'-x, -y+.5, -z+.25',
				'-x, y, z+.5',
				'-x, -y, z',
				'x, -y+.5, -z+.75',
				'x, y+.5, -z+.25',
				'x, -y, z+.5',
				'x, y, z',
				'-y, -x+.5, z+.75',
				'y, -x+.5, z+.25',
				'-y+.5, -x+.5, -z',
				'y+.5, -x+.5, -z+.5',
				'y, x+.5, z+.75',
				'-y, x+.5, z+.25',
				'y+.5, x+.5, -z',
				'-y+.5, x+.5, -z+.5',
				'-x+.5, y, -z+.25',
				'-x+.5, -y, -z+.75',
				'-x+.5, y+.5, z',
				'-x+.5, -y+.5, z+.5',
				'x+.5, -y, -z+.25',
				'x+.5, y, -z+.75',
				'x+.5, -y+.5, z',
				'x+.5, y+.5, z+.5'],
			'I 41/a c d z':['y+.25, x+.75, -z+.75',
				'-y+.75, x+.75, -z+.25',
				'x, y+.5, -z',
				'-x, y+.5, -z+.5',
				'-y+.75, -x+.25, z+.25',
				'y+.25, -x+.25, z+.75',
				'-x, -y+.5, z',
				'x, -y+.5, z+.5',
				'y+.25, -x+.75, -z+.25',
				'-y+.75, -x+.75, -z+.75',
				'x, -y, -z+.5',
				'-x, -y, -z',
				'-y+.75, x+.25, z+.75',
				'y+.25, x+.25, z+.25',
				'-x, y, z+.5',
				'x, y, z',
				'y+.75, x+.25, -z+.25',
				'-y+.25, x+.25, -z+.75',
				'x+.5, y, -z+.5',
				'-x+.5, y, -z',
				'-y+.25, -x+.75, z+.75',
				'y+.75, -x+.75, z+.25',
				'-x+.5, -y, z+.5',
				'x+.5, -y, z',
				'y+.75, -x+.25, -z+.75',
				'-y+.25, -x+.25, -z+.25',
				'x+.5, -y+.5, -z',
				'-x+.5, -y+.5, -z+.5',
				'-y+.25, x+.75, z+.25',
				'y+.75, x+.75, z+.75',
				'-x+.5, y+.5, z',
				'x+.5, y+.5, z+.5'],
			'P n -3 s':['-z+.5, x+.5, y+.5',
				'z+.5, x+.5, -y+.5',
				'z+.5, -x+.5, y+.5',
				'-z+.5, -x+.5, -y+.5',
				'y+.5, -z+.5, x+.5',
				'-y+.5, z+.5, x+.5',
				'y+.5, z+.5, -x+.5',
				'-y+.5, -z+.5, -x+.5',
				'x+.5, y+.5, -z+.5',
				'x+.5, -y+.5, z+.5',
				'-x+.5, y+.5, z+.5',
				'-x+.5, -y+.5, -z+.5',
				'z, -x, -y',
				'-z, -x, y',
				'-z, x, -y',
				'z, x, y',
				'-y, z, -x',
				'y, -z, -x',
				'-y, -z, x',
				'y, z, x',
				'-x, -y, z',
				'-x, y, -z',
				'x, -y, -z',
				'x, y, z'],
			'P n -3 z':['-z, x+.5, y+.5',
				'z+.5, x+.5, -y',
				'z+.5, -x, y+.5',
				'-z, -x, -y',
				'y+.5, -z, x+.5',
				'-y, z+.5, x+.5',
				'y+.5, z+.5, -x',
				'-y, -z, -x',
				'x+.5, y+.5, -z',
				'x+.5, -y, z+.5',
				'-x, y+.5, z+.5',
				'-x, -y, -z',
				'z, -x+.5, -y+.5',
				'-z+.5, -x+.5, y',
				'-z+.5, x, -y+.5',
				'z, x, y',
				'-y+.5, z, -x+.5',
				'y, -z+.5, -x+.5',
				'-y+.5, -z+.5, x',
				'y, z, x',
				'-x+.5, -y+.5, z',
				'-x+.5, y, -z+.5',
				'x, -y+.5, -z+.5',
				'x, y, z'],
			'F d -3 s':['-z+.25, x+.25, y+.25',
				'z+.25, -x+.25, y+.25',
				'z+.25, x+.25, -y+.25',
				'-z+.25, -x+.25, -y+.25',
				'z, -x, -y',
				'-z, x, -y',
				'-z, -x, y',
				'z, x, y',
				'y+.25, -z+.25, x+.25',
				'y+.25, z+.25, -x+.25',
				'-y+.25, z+.25, x+.25',
				'-y+.25, -z+.25, -x+.25',
				'-y, z, -x',
				'-y, -z, x',
				'y, -z, -x',
				'y, z, x',
				'x+.25, y+.25, -z+.25',
				'-x+.25, y+.25, z+.25',
				'x+.25, -y+.25, z+.25',
				'-x+.25, -y+.25, -z+.25',
				'-x, -y, z',
				'x, -y, -z',
				'-x, y, -z',
				'x, y, z',
				'-z+.25, x+.75, y+.75',
				'-z+.75, x+.25, y+.75',
				'-z+.75, x+.75, y+.25',
				'z+.25, -x+.75, y+.75',
				'z+.75, -x+.25, y+.75',
				'z+.75, -x+.75, y+.25',
				'z+.25, x+.75, -y+.75',
				'z+.75, x+.25, -y+.75',
				'z+.75, x+.75, -y+.25',
				'-z+.25, -x+.75, -y+.75',
				'-z+.75, -x+.25, -y+.75',
				'-z+.75, -x+.75, -y+.25',
				'z, -x+.5, -y+.5',
				'z+.5, -x, -y+.5',
				'z+.5, -x+.5, -y',
				'-z, x+.5, -y+.5',
				'-z+.5, x, -y+.5',
				'-z+.5, x+.5, -y',
				'-z, -x+.5, y+.5',
				'-z+.5, -x, y+.5',
				'-z+.5, -x+.5, y',
				'z, x+.5, y+.5',
				'z+.5, x, y+.5',
				'z+.5, x+.5, y',
				'y+.25, -z+.75, x+.75',
				'y+.75, -z+.25, x+.75',
				'y+.75, -z+.75, x+.25',
				'y+.25, z+.75, -x+.75',
				'y+.75, z+.25, -x+.75',
				'y+.75, z+.75, -x+.25',
				'-y+.25, z+.75, x+.75',
				'-y+.75, z+.25, x+.75',
				'-y+.75, z+.75, x+.25',
				'-y+.25, -z+.75, -x+.75',
				'-y+.75, -z+.25, -x+.75',
				'-y+.75, -z+.75, -x+.25',
				'-y, z+.5, -x+.5',
				'-y+.5, z, -x+.5',
				'-y+.5, z+.5, -x',
				'-y, -z+.5, x+.5',
				'-y+.5, -z, x+.5',
				'-y+.5, -z+.5, x',
				'y, -z+.5, -x+.5',
				'y+.5, -z, -x+.5',
				'y+.5, -z+.5, -x',
				'y, z+.5, x+.5',
				'y+.5, z, x+.5',
				'y+.5, z+.5, x',
				'x+.25, y+.75, -z+.75',
				'x+.75, y+.25, -z+.75',
				'x+.75, y+.75, -z+.25',
				'-x+.25, y+.75, z+.75',
				'-x+.75, y+.25, z+.75',
				'-x+.75, y+.75, z+.25',
				'x+.25, -y+.75, z+.75',
				'x+.75, -y+.25, z+.75',
				'x+.75, -y+.75, z+.25',
				'-x+.25, -y+.75, -z+.75',
				'-x+.75, -y+.25, -z+.75',
				'-x+.75, -y+.75, -z+.25',
				'-x, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'-x+.5, -y+.5, z',
				'x, -y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, -y+.5, -z',
				'-x, y+.5, -z+.5',
				'-x+.5, y, -z+.5',
				'-x+.5, y+.5, -z',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F d -3 z':['-z, x+.75, y+.75',
				'z+.75, x+.75, -y',
				'z+.75, -x, y+.75',
				'-z, -x, -y',
				'y+.75, -z, x+.75',
				'-y, z+.75, x+.75',
				'y+.75, z+.75, -x',
				'-y, -z, -x',
				'x+.75, y+.75, -z',
				'x+.75, -y, z+.75',
				'-x, y+.75, z+.75',
				'-x, -y, -z',
				'z, -x+.25, -y+.25',
				'-z+.25, -x+.25, y',
				'-z+.25, x, -y+.25',
				'z, x, y',
				'-y+.25, z, -x+.25',
				'y, -z+.25, -x+.25',
				'-y+.25, -z+.25, x',
				'y, z, x',
				'-x+.25, -y+.25, z',
				'-x+.25, y, -z+.25',
				'x, -y+.25, -z+.25',
				'x, y, z',
				'-z, x+.25, y+.25',
				'-z+.5, x+.75, y+.25',
				'-z+.5, x+.25, y+.75',
				'z+.75, x+.25, -y+.5',
				'z+.25, x+.75, -y+.5',
				'z+.25, x+.25, -y',
				'z+.75, -x+.5, y+.25',
				'z+.25, -x, y+.25',
				'z+.25, -x+.5, y+.75',
				'-z, -x+.5, -y+.5',
				'-z+.5, -x, -y+.5',
				'-z+.5, -x+.5, -y',
				'y+.75, -z+.5, x+.25',
				'y+.25, -z, x+.25',
				'y+.25, -z+.5, x+.75',
				'-y, z+.25, x+.25',
				'-y+.5, z+.75, x+.25',
				'-y+.5, z+.25, x+.75',
				'y+.75, z+.25, -x+.5',
				'y+.25, z+.75, -x+.5',
				'y+.25, z+.25, -x',
				'-y, -z+.5, -x+.5',
				'-y+.5, -z, -x+.5',
				'-y+.5, -z+.5, -x',
				'x+.75, y+.25, -z+.5',
				'x+.25, y+.75, -z+.5',
				'x+.25, y+.25, -z',
				'x+.75, -y+.5, z+.25',
				'x+.25, -y, z+.25',
				'x+.25, -y+.5, z+.75',
				'-x, y+.25, z+.25',
				'-x+.5, y+.75, z+.25',
				'-x+.5, y+.25, z+.75',
				'-x, -y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, -y+.5, -z',
				'z, -x+.75, -y+.75',
				'z+.5, -x+.25, -y+.75',
				'z+.5, -x+.75, -y+.25',
				'-z+.25, -x+.75, y+.5',
				'-z+.75, -x+.25, y+.5',
				'-z+.75, -x+.75, y',
				'-z+.25, x+.5, -y+.75',
				'-z+.75, x, -y+.75',
				'-z+.75, x+.5, -y+.25',
				'z, x+.5, y+.5',
				'z+.5, x, y+.5',
				'z+.5, x+.5, y',
				'-y+.25, z+.5, -x+.75',
				'-y+.75, z, -x+.75',
				'-y+.75, z+.5, -x+.25',
				'y, -z+.75, -x+.75',
				'y+.5, -z+.25, -x+.75',
				'y+.5, -z+.75, -x+.25',
				'-y+.25, -z+.75, x+.5',
				'-y+.75, -z+.25, x+.5',
				'-y+.75, -z+.75, x',
				'y, z+.5, x+.5',
				'y+.5, z, x+.5',
				'y+.5, z+.5, x',
				'-x+.25, -y+.75, z+.5',
				'-x+.75, -y+.25, z+.5',
				'-x+.75, -y+.75, z',
				'-x+.25, y+.5, -z+.75',
				'-x+.75, y, -z+.75',
				'-x+.75, y+.5, -z+.25',
				'x, -y+.75, -z+.75',
				'x+.5, -y+.25, -z+.75',
				'x+.5, -y+.75, -z+.25',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'P n -3 n s':['x,y,z',
				'-x,-y,z',
				'-x,y,-z',
				'x,-y,-z',
				'z,x,y',
				'z,-x,-y',
				'-z,-x,y',
				'-z,x,-y',
				'y,z,x',
				'-y,z,-x',
				'y,-z,-x',
				'-y,-z,x',
				'y,x,-z',
				'-y,-x,-z',
				'y,-x,z',
				'-y,x,z',
				'x,z,-y',
				'-x,z,y',
				'-x,-z,-y',
				'x,-z,y',
				'z,y,-x',
				'z,-y,x',
				'-z,y,x',
				'-z,-y,-x',
				'-x+1/2,-y+1/2,-z+1/2',
				'x+1/2,y+1/2,-z+1/2',
				'x+1/2,-y+1/2,z+1/2',
				'-x+1/2,y+1/2,z+1/2',
				'-z+1/2,-x+1/2,-y+1/2',
				'-z+1/2,x+1/2,y+1/2',
				'z+1/2,x+1/2,-y+1/2',
				'z+1/2,-x+1/2,y+1/2',
				'-y+1/2,-z+1/2,-x+1/2',
				'y+1/2,-z+1/2,x+1/2',
				'-y+1/2,z+1/2,x+1/2',
				'y+1/2,z+1/2,-x+1/2',
				'-y+1/2,-x+1/2,z+1/2',
				'y+1/2,x+1/2,z+1/2',
				'-y+1/2,x+1/2,-z+1/2',
				'y+1/2,-x+1/2,-z+1/2',
				'-x+1/2,-z+1/2,y+1/2',
				'x+1/2,-z+1/2,-y+1/2',
				'x+1/2,z+1/2,y+1/2',
				'-x+1/2,z+1/2,-y+1/2',
				'-z+1/2,-y+1/2,x+1/2',
				'-z+1/2,y+1/2,-x+1/2',
				'z+1/2,-y+1/2,-x+1/2',
				'z+1/2,y+1/2,x+1/2'],
			'P n -3 n z':['-y+.5, x, z',
				'y, x, -z+.5',
				'y, -x+.5, z',
				'-y+.5, -x+.5, -z+.5',
				'-z, x+.5, y+.5',
				'z+.5, x+.5, -y',
				'z+.5, -x, y+.5',
				'-z, -x, -y',
				'z, -y+.5, x',
				'-z+.5, y, x',
				'z, y, -x+.5',
				'-z+.5, -y+.5, -x+.5',
				'y+.5, -z, x+.5',
				'-y, z+.5, x+.5',
				'y+.5, z+.5, -x',
				'-y, -z, -x',
				'x, z, -y+.5',
				'x, -z+.5, y',
				'-x+.5, z, y',
				'-x+.5, -z+.5, -y+.5',
				'x+.5, y+.5, -z',
				'x+.5, -y, z+.5',
				'-x, y+.5, z+.5',
				'-x, -y, -z',
				'y+.5, -x, -z',
				'-y, -x, z+.5',
				'-y, x+.5, -z',
				'y+.5, x+.5, z+.5',
				'z, -x+.5, -y+.5',
				'-z+.5, -x+.5, y',
				'-z+.5, x, -y+.5',
				'z, x, y',
				'-z, y+.5, -x',
				'z+.5, -y, -x',
				'-z, -y, x+.5',
				'z+.5, y+.5, x+.5',
				'-y+.5, z, -x+.5',
				'y, -z+.5, -x+.5',
				'-y+.5, -z+.5, x',
				'y, z, x',
				'-x, -z, y+.5',
				'-x, z+.5, -y',
				'x+.5, -z, -y',
				'x+.5, z+.5, y+.5',
				'-x+.5, -y+.5, z',
				'-x+.5, y, -z+.5',
				'x, -y+.5, -z+.5',
				'x, y, z'],
			'P n -3 m s':['y+.5, x+.5, -z+.5',
				'z+.5, x+.5, -y+.5',
				'z+.5, y+.5, -x+.5',
				'y+.5, z+.5, -x+.5',
				'x+.5, z+.5, -y+.5',
				'x+.5, y+.5, -z+.5',
				'y+.5, -x+.5, z+.5',
				'z+.5, -x+.5, y+.5',
				'z+.5, -y+.5, x+.5',
				'y+.5, -z+.5, x+.5',
				'x+.5, -z+.5, y+.5',
				'x+.5, -y+.5, z+.5',
				'-y+.5, x+.5, z+.5',
				'-z+.5, x+.5, y+.5',
				'-z+.5, y+.5, x+.5',
				'-y+.5, z+.5, x+.5',
				'-x+.5, z+.5, y+.5',
				'-x+.5, y+.5, z+.5',
				'-y+.5, -x+.5, -z+.5',
				'-z+.5, -x+.5, -y+.5',
				'-z+.5, -y+.5, -x+.5',
				'-y+.5, -z+.5, -x+.5',
				'-x+.5, -z+.5, -y+.5',
				'-x+.5, -y+.5, -z+.5',
				'-y, -x, z',
				'-z, -x, y',
				'-z, -y, x',
				'-y, -z, x',
				'-x, -z, y',
				'-x, -y, z',
				'-y, x, -z',
				'-z, x, -y',
				'-z, y, -x',
				'-y, z, -x',
				'-x, z, -y',
				'-x, y, -z',
				'y, -x, -z',
				'z, -x, -y',
				'z, -y, -x',
				'y, -z, -x',
				'x, -z, -y',
				'x, -y, -z',
				'y, x, z',
				'z, x, y',
				'z, y, x',
				'y, z, x',
				'x, z, y',
				'x, y, z'],
			'P n -3 m z':['-y, x+.5, z+.5',
				'y+.5, x+.5, -z',
				'y+.5, -x, z+.5',
				'-y, -x, -z',
				'-z, x+.5, y+.5',
				'z+.5, x+.5, -y',
				'z+.5, -x, y+.5',
				'-z, -x, -y',
				'z+.5, -y, x+.5',
				'-z, y+.5, x+.5',
				'z+.5, y+.5, -x',
				'-z, -y, -x',
				'y+.5, -z, x+.5',
				'-y, z+.5, x+.5',
				'y+.5, z+.5, -x',
				'-y, -z, -x',
				'x+.5, z+.5, -y',
				'x+.5, -z, y+.5',
				'-x, z+.5, y+.5',
				'-x, -z, -y',
				'x+.5, y+.5, -z',
				'x+.5, -y, z+.5',
				'-x, y+.5, z+.5',
				'-x, -y, -z',
				'y, -x+.5, -z+.5',
				'-y+.5, -x+.5, z',
				'-y+.5, x, -z+.5',
				'y, x, z',
				'z, -x+.5, -y+.5',
				'-z+.5, -x+.5, y',
				'-z+.5, x, -y+.5',
				'z, x, y',
				'-z+.5, y, -x+.5',
				'z, -y+.5, -x+.5',
				'-z+.5, -y+.5, x',
				'z, y, x',
				'-y+.5, z, -x+.5',
				'y, -z+.5, -x+.5',
				'-y+.5, -z+.5, x',
				'y, z, x',
				'-x+.5, -z+.5, y',
				'-x+.5, z, -y+.5',
				'x, -z+.5, -y+.5',
				'x, z, y',
				'-x+.5, -y+.5, z',
				'-x+.5, y, -z+.5',
				'x, -y+.5, -z+.5',
				'x, y, z'],
			'F d -3 m s':['z+.25, y+.25, -x+.25',
				'y+.25, x+.25, -z+.25',
				'x+.25, z+.25, -y+.25',
				'z+.25, x+.25, -y+.25',
				'y+.25, z+.25, -x+.25',
				'x+.25, y+.25, -z+.25',
				'z+.25, -y+.25, x+.25',
				'y+.25, -x+.25, z+.25',
				'x+.25, -z+.25, y+.25',
				'z+.25, -x+.25, y+.25',
				'y+.25, -z+.25, x+.25',
				'x+.25, -y+.25, z+.25',
				'-z+.25, y+.25, x+.25',
				'-y+.25, x+.25, z+.25',
				'-x+.25, z+.25, y+.25',
				'-z+.25, x+.25, y+.25',
				'-y+.25, z+.25, x+.25',
				'-x+.25, y+.25, z+.25',
				'-z+.25, -y+.25, -x+.25',
				'-y+.25, -x+.25, -z+.25',
				'-x+.25, -z+.25, -y+.25',
				'-z+.25, -x+.25, -y+.25',
				'-y+.25, -z+.25, -x+.25',
				'-x+.25, -y+.25, -z+.25',
				'-z, -y, x',
				'-y, -x, z',
				'-x, -z, y',
				'-z, -x, y',
				'-y, -z, x',
				'-x, -y, z',
				'-z, y, -x',
				'-y, x, -z',
				'-x, z, -y',
				'-z, x, -y',
				'-y, z, -x',
				'-x, y, -z',
				'z, -y, -x',
				'y, -x, -z',
				'x, -z, -y',
				'z, -x, -y',
				'y, -z, -x',
				'x, -y, -z',
				'z, y, x',
				'y, x, z',
				'x, z, y',
				'z, x, y',
				'y, z, x',
				'x, y, z',
				'z+.25, y+.75, -x+.75',
				'z+.75, y+.25, -x+.75',
				'z+.75, y+.75, -x+.25',
				'y+.25, x+.75, -z+.75',
				'y+.75, x+.25, -z+.75',
				'y+.75, x+.75, -z+.25',
				'x+.25, z+.75, -y+.75',
				'x+.75, z+.25, -y+.75',
				'x+.75, z+.75, -y+.25',
				'z+.25, x+.75, -y+.75',
				'z+.75, x+.25, -y+.75',
				'z+.75, x+.75, -y+.25',
				'y+.25, z+.75, -x+.75',
				'y+.75, z+.25, -x+.75',
				'y+.75, z+.75, -x+.25',
				'x+.25, y+.75, -z+.75',
				'x+.75, y+.25, -z+.75',
				'x+.75, y+.75, -z+.25',
				'z+.25, -y+.75, x+.75',
				'z+.75, -y+.25, x+.75',
				'z+.75, -y+.75, x+.25',
				'y+.25, -x+.75, z+.75',
				'y+.75, -x+.25, z+.75',
				'y+.75, -x+.75, z+.25',
				'x+.25, -z+.75, y+.75',
				'x+.75, -z+.25, y+.75',
				'x+.75, -z+.75, y+.25',
				'z+.25, -x+.75, y+.75',
				'z+.75, -x+.25, y+.75',
				'z+.75, -x+.75, y+.25',
				'y+.25, -z+.75, x+.75',
				'y+.75, -z+.25, x+.75',
				'y+.75, -z+.75, x+.25',
				'x+.25, -y+.75, z+.75',
				'x+.75, -y+.25, z+.75',
				'x+.75, -y+.75, z+.25',
				'-z+.25, y+.75, x+.75',
				'-z+.75, y+.25, x+.75',
				'-z+.75, y+.75, x+.25',
				'-y+.25, x+.75, z+.75',
				'-y+.75, x+.25, z+.75',
				'-y+.75, x+.75, z+.25',
				'-x+.25, z+.75, y+.75',
				'-x+.75, z+.25, y+.75',
				'-x+.75, z+.75, y+.25',
				'-z+.25, x+.75, y+.75',
				'-z+.75, x+.25, y+.75',
				'-z+.75, x+.75, y+.25',
				'-y+.25, z+.75, x+.75',
				'-y+.75, z+.25, x+.75',
				'-y+.75, z+.75, x+.25',
				'-x+.25, y+.75, z+.75',
				'-x+.75, y+.25, z+.75',
				'-x+.75, y+.75, z+.25',
				'-z+.25, -y+.75, -x+.75',
				'-z+.75, -y+.25, -x+.75',
				'-z+.75, -y+.75, -x+.25',
				'-y+.25, -x+.75, -z+.75',
				'-y+.75, -x+.25, -z+.75',
				'-y+.75, -x+.75, -z+.25',
				'-x+.25, -z+.75, -y+.75',
				'-x+.75, -z+.25, -y+.75',
				'-x+.75, -z+.75, -y+.25',
				'-z+.25, -x+.75, -y+.75',
				'-z+.75, -x+.25, -y+.75',
				'-z+.75, -x+.75, -y+.25',
				'-y+.25, -z+.75, -x+.75',
				'-y+.75, -z+.25, -x+.75',
				'-y+.75, -z+.75, -x+.25',
				'-x+.25, -y+.75, -z+.75',
				'-x+.75, -y+.25, -z+.75',
				'-x+.75, -y+.75, -z+.25',
				'-z, -y+.5, x+.5',
				'-z+.5, -y, x+.5',
				'-z+.5, -y+.5, x',
				'-y, -x+.5, z+.5',
				'-y+.5, -x, z+.5',
				'-y+.5, -x+.5, z',
				'-x, -z+.5, y+.5',
				'-x+.5, -z, y+.5',
				'-x+.5, -z+.5, y',
				'-z, -x+.5, y+.5',
				'-z+.5, -x, y+.5',
				'-z+.5, -x+.5, y',
				'-y, -z+.5, x+.5',
				'-y+.5, -z, x+.5',
				'-y+.5, -z+.5, x',
				'-x, -y+.5, z+.5',
				'-x+.5, -y, z+.5',
				'-x+.5, -y+.5, z',
				'-z, y+.5, -x+.5',
				'-z+.5, y, -x+.5',
				'-z+.5, y+.5, -x',
				'-y, x+.5, -z+.5',
				'-y+.5, x, -z+.5',
				'-y+.5, x+.5, -z',
				'-x, z+.5, -y+.5',
				'-x+.5, z, -y+.5',
				'-x+.5, z+.5, -y',
				'-z, x+.5, -y+.5',
				'-z+.5, x, -y+.5',
				'-z+.5, x+.5, -y',
				'-y, z+.5, -x+.5',
				'-y+.5, z, -x+.5',
				'-y+.5, z+.5, -x',
				'-x, y+.5, -z+.5',
				'-x+.5, y, -z+.5',
				'-x+.5, y+.5, -z',
				'z, -y+.5, -x+.5',
				'z+.5, -y, -x+.5',
				'z+.5, -y+.5, -x',
				'y, -x+.5, -z+.5',
				'y+.5, -x, -z+.5',
				'y+.5, -x+.5, -z',
				'x, -z+.5, -y+.5',
				'x+.5, -z, -y+.5',
				'x+.5, -z+.5, -y',
				'z, -x+.5, -y+.5',
				'z+.5, -x, -y+.5',
				'z+.5, -x+.5, -y',
				'y, -z+.5, -x+.5',
				'y+.5, -z, -x+.5',
				'y+.5, -z+.5, -x',
				'x, -y+.5, -z+.5',
				'x+.5, -y, -z+.5',
				'x+.5, -y+.5, -z',
				'z, y+.5, x+.5',
				'z+.5, y, x+.5',
				'z+.5, y+.5, x',
				'y, x+.5, z+.5',
				'y+.5, x, z+.5',
				'y+.5, x+.5, z',
				'x, z+.5, y+.5',
				'x+.5, z, y+.5',
				'x+.5, z+.5, y',
				'z, x+.5, y+.5',
				'z+.5, x, y+.5',
				'z+.5, x+.5, y',
				'y, z+.5, x+.5',
				'y+.5, z, x+.5',
				'y+.5, z+.5, x',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F d -3 m z':['-z, y+.75, x+.75',
				'z+.75, -y, x+.75',
				'z+.75, y+.75, -x',
				'-z, -y, -x',
				'y+.75, x+.75, -z',
				'-y, x+.75, z+.75',
				'y+.75, -x, z+.75',
				'-y, -x, -z',
				'x+.75, -z, y+.75',
				'x+.75, z+.75, -y',
				'-x, z+.75, y+.75',
				'-x, -z, -y',
				'-z, x+.75, y+.75',
				'z+.75, x+.75, -y',
				'z+.75, -x, y+.75',
				'-z, -x, -y',
				'y+.75, -z, x+.75',
				'-y, z+.75, x+.75',
				'y+.75, z+.75, -x',
				'-y, -z, -x',
				'x+.75, y+.75, -z',
				'x+.75, -y, z+.75',
				'-x, y+.75, z+.75',
				'-x, -y, -z',
				'z, -y+.25, -x+.25',
				'-z+.25, y, -x+.25',
				'-z+.25, -y+.25, x',
				'z, y, x',
				'-y+.25, -x+.25, z',
				'y, -x+.25, -z+.25',
				'-y+.25, x, -z+.25',
				'y, x, z',
				'-x+.25, z, -y+.25',
				'-x+.25, -z+.25, y',
				'x, -z+.25, -y+.25',
				'x, z, y',
				'z, -x+.25, -y+.25',
				'-z+.25, -x+.25, y',
				'-z+.25, x, -y+.25',
				'z, x, y',
				'-y+.25, z, -x+.25',
				'y, -z+.25, -x+.25',
				'-y+.25, -z+.25, x',
				'y, z, x',
				'-x+.25, -y+.25, z',
				'-x+.25, y, -z+.25',
				'x, -y+.25, -z+.25',
				'x, y, z',
				'-z, y+.25, x+.25',
				'-z+.5, y+.75, x+.25',
				'-z+.5, y+.25, x+.75',
				'z+.75, -y+.5, x+.25',
				'z+.25, -y, x+.25',
				'z+.25, -y+.5, x+.75',
				'z+.75, y+.25, -x+.5',
				'z+.25, y+.75, -x+.5',
				'z+.25, y+.25, -x',
				'-z, -y+.5, -x+.5',
				'-z+.5, -y, -x+.5',
				'-z+.5, -y+.5, -x',
				'y+.75, x+.25, -z+.5',
				'y+.25, x+.75, -z+.5',
				'y+.25, x+.25, -z',
				'-y, x+.25, z+.25',
				'-y+.5, x+.75, z+.25',
				'-y+.5, x+.25, z+.75',
				'y+.75, -x+.5, z+.25',
				'y+.25, -x, z+.25',
				'y+.25, -x+.5, z+.75',
				'-y, -x+.5, -z+.5',
				'-y+.5, -x, -z+.5',
				'-y+.5, -x+.5, -z',
				'x+.75, -z+.5, y+.25',
				'x+.25, -z, y+.25',
				'x+.25, -z+.5, y+.75',
				'x+.75, z+.25, -y+.5',
				'x+.25, z+.75, -y+.5',
				'x+.25, z+.25, -y',
				'-x, z+.25, y+.25',
				'-x+.5, z+.75, y+.25',
				'-x+.5, z+.25, y+.75',
				'-x, -z+.5, -y+.5',
				'-x+.5, -z, -y+.5',
				'-x+.5, -z+.5, -y',
				'-z, x+.25, y+.25',
				'-z+.5, x+.75, y+.25',
				'-z+.5, x+.25, y+.75',
				'z+.75, x+.25, -y+.5',
				'z+.25, x+.75, -y+.5',
				'z+.25, x+.25, -y',
				'z+.75, -x+.5, y+.25',
				'z+.25, -x, y+.25',
				'z+.25, -x+.5, y+.75',
				'-z, -x+.5, -y+.5',
				'-z+.5, -x, -y+.5',
				'-z+.5, -x+.5, -y',
				'y+.75, -z+.5, x+.25',
				'y+.25, -z, x+.25',
				'y+.25, -z+.5, x+.75',
				'-y, z+.25, x+.25',
				'-y+.5, z+.75, x+.25',
				'-y+.5, z+.25, x+.75',
				'y+.75, z+.25, -x+.5',
				'y+.25, z+.75, -x+.5',
				'y+.25, z+.25, -x',
				'-y, -z+.5, -x+.5',
				'-y+.5, -z, -x+.5',
				'-y+.5, -z+.5, -x',
				'x+.75, y+.25, -z+.5',
				'x+.25, y+.75, -z+.5',
				'x+.25, y+.25, -z',
				'x+.75, -y+.5, z+.25',
				'x+.25, -y, z+.25',
				'x+.25, -y+.5, z+.75',
				'-x, y+.25, z+.25',
				'-x+.5, y+.75, z+.25',
				'-x+.5, y+.25, z+.75',
				'-x, -y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, -y+.5, -z',
				'z, -y+.75, -x+.75',
				'z+.5, -y+.25, -x+.75',
				'z+.5, -y+.75, -x+.25',
				'-z+.25, y+.5, -x+.75',
				'-z+.75, y, -x+.75',
				'-z+.75, y+.5, -x+.25',
				'-z+.25, -y+.75, x+.5',
				'-z+.75, -y+.25, x+.5',
				'-z+.75, -y+.75, x',
				'z, y+.5, x+.5',
				'z+.5, y, x+.5',
				'z+.5, y+.5, x',
				'-y+.25, -x+.75, z+.5',
				'-y+.75, -x+.25, z+.5',
				'-y+.75, -x+.75, z',
				'y, -x+.75, -z+.75',
				'y+.5, -x+.25, -z+.75',
				'y+.5, -x+.75, -z+.25',
				'-y+.25, x+.5, -z+.75',
				'-y+.75, x, -z+.75',
				'-y+.75, x+.5, -z+.25',
				'y, x+.5, z+.5',
				'y+.5, x, z+.5',
				'y+.5, x+.5, z',
				'-x+.25, z+.5, -y+.75',
				'-x+.75, z, -y+.75',
				'-x+.75, z+.5, -y+.25',
				'-x+.25, -z+.75, y+.5',
				'-x+.75, -z+.25, y+.5',
				'-x+.75, -z+.75, y',
				'x, -z+.75, -y+.75',
				'x+.5, -z+.25, -y+.75',
				'x+.5, -z+.75, -y+.25',
				'x, z+.5, y+.5',
				'x+.5, z, y+.5',
				'x+.5, z+.5, y',
				'z, -x+.75, -y+.75',
				'z+.5, -x+.25, -y+.75',
				'z+.5, -x+.75, -y+.25',
				'-z+.25, -x+.75, y+.5',
				'-z+.75, -x+.25, y+.5',
				'-z+.75, -x+.75, y',
				'-z+.25, x+.5, -y+.75',
				'-z+.75, x, -y+.75',
				'-z+.75, x+.5, -y+.25',
				'z, x+.5, y+.5',
				'z+.5, x, y+.5',
				'z+.5, x+.5, y',
				'-y+.25, z+.5, -x+.75',
				'-y+.75, z, -x+.75',
				'-y+.75, z+.5, -x+.25',
				'y, -z+.75, -x+.75',
				'y+.5, -z+.25, -x+.75',
				'y+.5, -z+.75, -x+.25',
				'-y+.25, -z+.75, x+.5',
				'-y+.75, -z+.25, x+.5',
				'-y+.75, -z+.75, x',
				'y, z+.5, x+.5',
				'y+.5, z, x+.5',
				'y+.5, z+.5, x',
				'-x+.25, -y+.75, z+.5',
				'-x+.75, -y+.25, z+.5',
				'-x+.75, -y+.75, z',
				'-x+.25, y+.5, -z+.75',
				'-x+.75, y, -z+.75',
				'-x+.75, y+.5, -z+.25',
				'x, -y+.75, -z+.75',
				'x+.5, -y+.25, -z+.75',
				'x+.5, -y+.75, -z+.25',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F d -3 c s':['z+.5, y+.5, x+.5',
				'z, -y, -x+.5',
				'-z+.5, y, -x',
				'-z, -y+.5, x',
				'-x+.5, z, -y',
				'x+.5, z+.5, y+.5',
				'x, -z, -y+.5',
				'-x, -z+.5, y',
				'y, -x, -z+.5',
				'-y+.5, x, -z',
				'y+.5, x+.5, z+.5',
				'-y, -x+.5, z',
				'y+.75, z+.25, -x+.25',
				'-y+.25, z+.75, x+.25',
				'y+.25, -z+.25, x+.75',
				'-y+.75, -z+.75, -x+.75',
				'z+.25, -x+.25, y+.75',
				'z+.75, x+.25, -y+.25',
				'-z+.25, x+.75, y+.25',
				'-z+.75, -x+.75, -y+.75',
				'-x+.25, y+.75, z+.25',
				'x+.25, -y+.25, z+.75',
				'x+.75, y+.25, -z+.25',
				'-x+.75, -y+.75, -z+.75',
				'-z+.25, -y+.25, -x+.25',
				'-z+.75, y+.75, x+.25',
				'z+.25, -y+.75, x+.75',
				'z+.75, y+.25, -x+.75',
				'x+.25, -z+.75, y+.75',
				'-x+.25, -z+.25, -y+.25',
				'-x+.75, z+.75, y+.25',
				'x+.75, z+.25, -y+.75',
				'-y+.75, x+.75, z+.25',
				'y+.25, -x+.75, z+.75',
				'-y+.25, -x+.25, -z+.25',
				'y+.75, x+.25, -z+.75',
				'-y, -z+.5, x+.5',
				'y+.5, -z, -x+.5',
				'-y+.5, z+.5, -x',
				'y, z, x',
				'-z+.5, x+.5, -y',
				'-z, -x+.5, y+.5',
				'z+.5, -x, -y+.5',
				'z, x, y',
				'x+.5, -y, -z+.5',
				'-x+.5, y+.5, -z',
				'-x, -y+.5, z+.5',
				'x, y, z',
				'z+.5, y, x',
				'z, y+.5, x',
				'z, y, x+.5',
				'z, -y+.5, -x',
				'z+.5, -y, -x',
				'z+.5, -y+.5, -x+.5',
				'-z+.5, y+.5, -x+.5',
				'-z, y, -x+.5',
				'-z, y+.5, -x',
				'-z, -y, x+.5',
				'-z+.5, -y+.5, x+.5',
				'-z+.5, -y, x',
				'-x+.5, z+.5, -y+.5',
				'-x, z, -y+.5',
				'-x, z+.5, -y',
				'x+.5, z, y',
				'x, z+.5, y',
				'x, z, y+.5',
				'x, -z+.5, -y',
				'x+.5, -z, -y',
				'x+.5, -z+.5, -y+.5',
				'-x, -z, y+.5',
				'-x+.5, -z+.5, y+.5',
				'-x+.5, -z, y',
				'y, -x+.5, -z',
				'y+.5, -x, -z',
				'y+.5, -x+.5, -z+.5',
				'-y+.5, x+.5, -z+.5',
				'-y, x, -z+.5',
				'-y, x+.5, -z',
				'y+.5, x, z',
				'y, x+.5, z',
				'y, x, z+.5',
				'-y, -x, z+.5',
				'-y+.5, -x+.5, z+.5',
				'-y+.5, -x, z',
				'y+.75, z+.75, -x+.75',
				'y+.25, z+.25, -x+.75',
				'y+.25, z+.75, -x+.25',
				'-y+.25, z+.25, x+.75',
				'-y+.75, z+.75, x+.75',
				'-y+.75, z+.25, x+.25',
				'y+.25, -z+.75, x+.25',
				'y+.75, -z+.25, x+.25',
				'y+.75, -z+.75, x+.75',
				'-y+.75, -z+.25, -x+.25',
				'-y+.25, -z+.75, -x+.25',
				'-y+.25, -z+.25, -x+.75',
				'z+.25, -x+.75, y+.25',
				'z+.75, -x+.25, y+.25',
				'z+.75, -x+.75, y+.75',
				'z+.75, x+.75, -y+.75',
				'z+.25, x+.25, -y+.75',
				'z+.25, x+.75, -y+.25',
				'-z+.25, x+.25, y+.75',
				'-z+.75, x+.75, y+.75',
				'-z+.75, x+.25, y+.25',
				'-z+.75, -x+.25, -y+.25',
				'-z+.25, -x+.75, -y+.25',
				'-z+.25, -x+.25, -y+.75',
				'-x+.25, y+.25, z+.75',
				'-x+.75, y+.75, z+.75',
				'-x+.75, y+.25, z+.25',
				'x+.25, -y+.75, z+.25',
				'x+.75, -y+.25, z+.25',
				'x+.75, -y+.75, z+.75',
				'x+.75, y+.75, -z+.75',
				'x+.25, y+.25, -z+.75',
				'x+.25, y+.75, -z+.25',
				'-x+.75, -y+.25, -z+.25',
				'-x+.25, -y+.75, -z+.25',
				'-x+.25, -y+.25, -z+.75',
				'-z+.25, -y+.75, -x+.75',
				'-z+.75, -y+.25, -x+.75',
				'-z+.75, -y+.75, -x+.25',
				'-z+.75, y+.25, x+.75',
				'-z+.25, y+.75, x+.75',
				'-z+.25, y+.25, x+.25',
				'z+.25, -y+.25, x+.25',
				'z+.75, -y+.75, x+.25',
				'z+.75, -y+.25, x+.75',
				'z+.75, y+.75, -x+.25',
				'z+.25, y+.25, -x+.25',
				'z+.25, y+.75, -x+.75',
				'x+.25, -z+.25, y+.25',
				'x+.75, -z+.75, y+.25',
				'x+.75, -z+.25, y+.75',
				'-x+.25, -z+.75, -y+.75',
				'-x+.75, -z+.25, -y+.75',
				'-x+.75, -z+.75, -y+.25',
				'-x+.75, z+.25, y+.75',
				'-x+.25, z+.75, y+.75',
				'-x+.25, z+.25, y+.25',
				'x+.75, z+.75, -y+.25',
				'x+.25, z+.25, -y+.25',
				'x+.25, z+.75, -y+.75',
				'-y+.75, x+.25, z+.75',
				'-y+.25, x+.75, z+.75',
				'-y+.25, x+.25, z+.25',
				'y+.25, -x+.25, z+.25',
				'y+.75, -x+.75, z+.25',
				'y+.75, -x+.25, z+.75',
				'-y+.25, -x+.75, -z+.75',
				'-y+.75, -x+.25, -z+.75',
				'-y+.75, -x+.75, -z+.25',
				'y+.75, x+.75, -z+.25',
				'y+.25, x+.25, -z+.25',
				'y+.25, x+.75, -z+.75',
				'-y, -z, x',
				'-y+.5, -z+.5, x',
				'-y+.5, -z, x+.5',
				'y+.5, -z+.5, -x',
				'y, -z, -x',
				'y, -z+.5, -x+.5',
				'-y+.5, z, -x+.5',
				'-y, z+.5, -x+.5',
				'-y, z, -x',
				'y, z+.5, x+.5',
				'y+.5, z, x+.5',
				'y+.5, z+.5, x',
				'-z+.5, x, -y+.5',
				'-z, x+.5, -y+.5',
				'-z, x, -y',
				'-z, -x, y',
				'-z+.5, -x+.5, y',
				'-z+.5, -x, y+.5',
				'z+.5, -x+.5, -y',
				'z, -x, -y',
				'z, -x+.5, -y+.5',
				'z, x+.5, y+.5',
				'z+.5, x, y+.5',
				'z+.5, x+.5, y',
				'x+.5, -y+.5, -z',
				'x, -y, -z',
				'x, -y+.5, -z+.5',
				'-x+.5, y, -z+.5',
				'-x, y+.5, -z+.5',
				'-x, y, -z',
				'-x, -y, z',
				'-x+.5, -y+.5, z',
				'-x+.5, -y, z+.5',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'F d -3 c z':['-z, y+.75, x+.25',
				'z+.75, -y, x+.25',
				'z+.75, y+.75, -x+.5',
				'-z, -y, -x+.5',
				'y+.75, x+.75, -z+.5',
				'-y, x+.75, z+.25',
				'y+.75, -x, z+.25',
				'-y, -x, -z+.5',
				'x+.75, -z, y+.25',
				'x+.75, z+.75, -y+.5',
				'-x, z+.75, y+.25',
				'-x, -z, -y+.5',
				'z, -y+.25, -x+.75',
				'-z+.25, y, -x+.75',
				'-z+.25, -y+.25, x+.5',
				'z, y, x+.5',
				'-y+.25, -x+.25, z+.5',
				'y, -x+.25, -z+.75',
				'-y+.25, x, -z+.75',
				'y, x, z+.5',
				'-x+.25, z, -y+.75',
				'-x+.25, -z+.25, y+.5',
				'x, -z+.25, -y+.75',
				'x, z, y+.5',
				'-z, x+.75, y+.75',
				'z+.75, x+.75, -y',
				'z+.75, -x, y+.75',
				'-z, -x, -y',
				'y+.75, -z, x+.75',
				'-y, z+.75, x+.75',
				'y+.75, z+.75, -x',
				'-y, -z, -x',
				'x+.75, y+.75, -z',
				'x+.75, -y, z+.75',
				'-x, y+.75, z+.75',
				'-x, -y, -z',
				'z, -x+.25, -y+.25',
				'-z+.25, -x+.25, y',
				'-z+.25, x, -y+.25',
				'z, x, y',
				'-y+.25, z, -x+.25',
				'y, -z+.25, -x+.25',
				'-y+.25, -z+.25, x',
				'y, z, x',
				'-x+.25, -y+.25, z',
				'-x+.25, y, -z+.25',
				'x, -y+.25, -z+.25',
				'x, y, z',
				'-z, y+.25, x+.75',
				'-z+.5, y+.75, x+.75',
				'-z+.5, y+.25, x+.25',
				'z+.75, -y+.5, x+.75',
				'z+.25, -y, x+.75',
				'z+.25, -y+.5, x+.25',
				'z+.75, y+.25, -x',
				'z+.25, y+.75, -x',
				'z+.25, y+.25, -x+.5',
				'-z, -y+.5, -x',
				'-z+.5, -y, -x',
				'-z+.5, -y+.5, -x+.5',
				'y+.75, x+.25, -z',
				'y+.25, x+.75, -z',
				'y+.25, x+.25, -z+.5',
				'-y, x+.25, z+.75',
				'-y+.5, x+.75, z+.75',
				'-y+.5, x+.25, z+.25',
				'y+.75, -x+.5, z+.75',
				'y+.25, -x, z+.75',
				'y+.25, -x+.5, z+.25',
				'-y, -x+.5, -z',
				'-y+.5, -x, -z',
				'-y+.5, -x+.5, -z+.5',
				'x+.75, -z+.5, y+.75',
				'x+.25, -z, y+.75',
				'x+.25, -z+.5, y+.25',
				'x+.75, z+.25, -y',
				'x+.25, z+.75, -y',
				'x+.25, z+.25, -y+.5',
				'-x, z+.25, y+.75',
				'-x+.5, z+.75, y+.75',
				'-x+.5, z+.25, y+.25',
				'-x, -z+.5, -y',
				'-x+.5, -z, -y',
				'-x+.5, -z+.5, -y+.5',
				'z, -y+.75, -x+.25',
				'z+.5, -y+.25, -x+.25',
				'z+.5, -y+.75, -x+.75',
				'-z+.25, y+.5, -x+.25',
				'-z+.75, y, -x+.25',
				'-z+.75, y+.5, -x+.75',
				'-z+.25, -y+.75, x',
				'-z+.75, -y+.25, x',
				'-z+.75, -y+.75, x+.5',
				'z, y+.5, x',
				'z+.5, y, x',
				'z+.5, y+.5, x+.5',
				'-y+.25, -x+.75, z',
				'-y+.75, -x+.25, z',
				'-y+.75, -x+.75, z+.5',
				'y, -x+.75, -z+.25',
				'y+.5, -x+.25, -z+.25',
				'y+.5, -x+.75, -z+.75',
				'-y+.25, x+.5, -z+.25',
				'-y+.75, x, -z+.25',
				'-y+.75, x+.5, -z+.75',
				'y, x+.5, z',
				'y+.5, x, z',
				'y+.5, x+.5, z+.5',
				'-x+.25, z+.5, -y+.25',
				'-x+.75, z, -y+.25',
				'-x+.75, z+.5, -y+.75',
				'-x+.25, -z+.75, y',
				'-x+.75, -z+.25, y',
				'-x+.75, -z+.75, y+.5',
				'x, -z+.75, -y+.25',
				'x+.5, -z+.25, -y+.25',
				'x+.5, -z+.75, -y+.75',
				'x, z+.5, y',
				'x+.5, z, y',
				'x+.5, z+.5, y+.5',
				'-z, x+.25, y+.25',
				'-z+.5, x+.75, y+.25',
				'-z+.5, x+.25, y+.75',
				'z+.75, x+.25, -y+.5',
				'z+.25, x+.75, -y+.5',
				'z+.25, x+.25, -y',
				'z+.75, -x+.5, y+.25',
				'z+.25, -x, y+.25',
				'z+.25, -x+.5, y+.75',
				'-z, -x+.5, -y+.5',
				'-z+.5, -x, -y+.5',
				'-z+.5, -x+.5, -y',
				'y+.75, -z+.5, x+.25',
				'y+.25, -z, x+.25',
				'y+.25, -z+.5, x+.75',
				'-y, z+.25, x+.25',
				'-y+.5, z+.75, x+.25',
				'-y+.5, z+.25, x+.75',
				'y+.75, z+.25, -x+.5',
				'y+.25, z+.75, -x+.5',
				'y+.25, z+.25, -x',
				'-y, -z+.5, -x+.5',
				'-y+.5, -z, -x+.5',
				'-y+.5, -z+.5, -x',
				'x+.75, y+.25, -z+.5',
				'x+.25, y+.75, -z+.5',
				'x+.25, y+.25, -z',
				'x+.75, -y+.5, z+.25',
				'x+.25, -y, z+.25',
				'x+.25, -y+.5, z+.75',
				'-x, y+.25, z+.25',
				'-x+.5, y+.75, z+.25',
				'-x+.5, y+.25, z+.75',
				'-x, -y+.5, -z+.5',
				'-x+.5, -y, -z+.5',
				'-x+.5, -y+.5, -z',
				'z, -x+.75, -y+.75',
				'z+.5, -x+.25, -y+.75',
				'z+.5, -x+.75, -y+.25',
				'-z+.25, -x+.75, y+.5',
				'-z+.75, -x+.25, y+.5',
				'-z+.75, -x+.75, y',
				'-z+.25, x+.5, -y+.75',
				'-z+.75, x, -y+.75',
				'-z+.75, x+.5, -y+.25',
				'z, x+.5, y+.5',
				'z+.5, x, y+.5',
				'z+.5, x+.5, y',
				'-y+.25, z+.5, -x+.75',
				'-y+.75, z, -x+.75',
				'-y+.75, z+.5, -x+.25',
				'y, -z+.75, -x+.75',
				'y+.5, -z+.25, -x+.75',
				'y+.5, -z+.75, -x+.25',
				'-y+.25, -z+.75, x+.5',
				'-y+.75, -z+.25, x+.5',
				'-y+.75, -z+.75, x',
				'y, z+.5, x+.5',
				'y+.5, z, x+.5',
				'y+.5, z+.5, x',
				'-x+.25, -y+.75, z+.5',
				'-x+.75, -y+.25, z+.5',
				'-x+.75, -y+.75, z',
				'-x+.25, y+.5, -z+.75',
				'-x+.75, y, -z+.75',
				'-x+.75, y+.5, -z+.25',
				'x, -y+.75, -z+.75',
				'x+.5, -y+.25, -z+.75',
				'x+.5, -y+.75, -z+.25',
				'x, y+.5, z+.5',
				'x+.5, y, z+.5',
				'x+.5, y+.5, z'],
			'R 3 h':['-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'-x+y+.6666, -x+.3333, z+.3333',
				'-x+y+.3333, -x+.6666, z+.6666',
				'-y+.6666, x-y+.3333, z+.3333',
				'-y+.3333, x-y+.6666, z+.6666',
				'x+.6666, y+.3333, z+.3333',
				'x+.3333, y+.6666, z+.6666'],
			'R 3 r':['z, x, y',
				'y, z, x',
				'x, y, z'],
			'R -3 h':['x-y, x, -z',
				'y, -x+y, -z',
				'-x, -y, -z',
				'-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'x-y+.6666, x+.3333, -z+.3333',
				'x-y+.3333, x+.6666, -z+.6666',
				'y+.6666, -x+y+.3333, -z+.3333',
				'y+.3333, -x+y+.6666, -z+.6666',
				'-x+.6666, -y+.3333, -z+.3333',
				'-x+.3333, -y+.6666, -z+.6666',
				'-x+y+.6666, -x+.3333, z+.3333',
				'-x+y+.3333, -x+.6666, z+.6666',
				'-y+.6666, x-y+.3333, z+.3333',
				'-y+.3333, x-y+.6666, z+.6666',
				'x+.6666, y+.3333, z+.3333',
				'x+.3333, y+.6666, z+.6666'],
			'R -3 r':['-z, -x, -y',
				'-y, -z, -x',
				'-x, -y, -z',
				'z, x, y',
				'y, z, x',
				'x, y, z'],
			'R 3 2 h':['-x, -x+y, -z',
				'x-y, -y, -z',
				'y, x, -z',
				'-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'-x+.6666, -x+y+.3333, -z+.3333',
				'-x+.3333, -x+y+.6666, -z+.6666',
				'x-y+.6666, -y+.3333, -z+.3333',
				'x-y+.3333, -y+.6666, -z+.6666',
				'y+.6666, x+.3333, -z+.3333',
				'y+.3333, x+.6666, -z+.6666',
				'-x+y+.6666, -x+.3333, z+.3333',
				'-x+y+.3333, -x+.6666, z+.6666',
				'-y+.6666, x-y+.3333, z+.3333',
				'-y+.3333, x-y+.6666, z+.6666',
				'x+.6666, y+.3333, z+.3333',
				'x+.3333, y+.6666, z+.6666'],
			'R 3 2 r':['-z, -y, -x',
				'z, x, y',
				'-x, -z, -y',
				'y, z, x',
				'-y, -x, -z',
				'x, y, z'],
			'R 3 m h':['-x+y, y, z',
				'x, x-y, z',
				'-y, -x, z',
				'-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'-x+y+.6666, y+.3333, z+.3333',
				'-x+y+.3333, y+.6666, z+.6666',
				'x+.6666, x-y+.3333, z+.3333',
				'x+.3333, x-y+.6666, z+.6666',
				'-y+.6666, -x+.3333, z+.3333',
				'-y+.3333, -x+.6666, z+.6666',
				'-x+y+.6666, -x+.3333, z+.3333',
				'-x+y+.3333, -x+.6666, z+.6666',
				'-y+.6666, x-y+.3333, z+.3333',
				'-y+.3333, x-y+.6666, z+.6666',
				'x+.6666, y+.3333, z+.3333',
				'x+.3333, y+.6666, z+.6666'],
			'R 3 m hr':['-x+y, y, z',
				'x, x-y, z',
				'-y, -x, z',
				'-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'-x+y+.3333, y+.6666, z+.3333',
				'-x+y+.6666, y+.3333, z+.6666',
				'x+.3333, x-y+.6666, z+.3333',
				'x+.6666, x-y+.3333, z+.6666',
				'-y+.3333, -x+.6666, z+.3333',
				'-y+.6666, -x+.3333, z+.6666',
				'-x+y+.3333, -x+.6666, z+.3333',
				'-x+y+.6666, -x+.3333, z+.6666',
				'-y+.3333, x-y+.6666, z+.3333',
				'-y+.6666, x-y+.3333, z+.6666',
				'x+.3333, y+.6666, z+.3333',
				'x+.6666, y+.3333, z+.6666'],
			'R 3 m r':['z, y, x',
				'z, x, y',
				'x, z, y',
				'y, z, x',
				'y, x, z',
				'x, y, z'],
			'R 3 c h':['-x+y, y, z+.5',
				'x, x-y, z+.5',
				'-y, -x, z+.5',
				'-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'-x+y+.6666, y+.3333, z+.8333',
				'-x+y+.3333, y+.6666, z+.1666',
				'x+.6666, x-y+.3333, z+.8333',
				'x+.3333, x-y+.6666, z+.1666',
				'-y+.6666, -x+.3333, z+.8333',
				'-y+.3333, -x+.6666, z+.1666',
				'-x+y+.6666, -x+.3333, z+.3333',
				'-x+y+.3333, -x+.6666, z+.6666',
				'-y+.6666, x-y+.3333, z+.3333',
				'-y+.3333, x-y+.6666, z+.6666',
				'x+.6666, y+.3333, z+.3333',
				'x+.3333, y+.6666, z+.6666'],
			'R 3 c r':['z+.5, y+.5, x+.5',
				'z, x, y',
				'x+.5, z+.5, y+.5',
				'y, z, x',
				'y+.5, x+.5, z+.5',
				'x, y, z'],
			'R -3 m h':['x-y, -y, -z',
				'-x, -x+y, -z',
				'y, x, -z',
				'x-y, x, -z',
				'y, -x+y, -z',
				'-x, -y, -z',
				'-x+y, y, z',
				'x, x-y, z',
				'-y, -x, z',
				'-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'x-y+.6666, -y+.3333, -z+.3333',
				'x-y+.3333, -y+.6666, -z+.6666',
				'-x+.6666, -x+y+.3333, -z+.3333',
				'-x+.3333, -x+y+.6666, -z+.6666',
				'y+.6666, x+.3333, -z+.3333',
				'y+.3333, x+.6666, -z+.6666',
				'x-y+.6666, x+.3333, -z+.3333',
				'x-y+.3333, x+.6666, -z+.6666',
				'y+.6666, -x+y+.3333, -z+.3333',
				'y+.3333, -x+y+.6666, -z+.6666',
				'-x+.6666, -y+.3333, -z+.3333',
				'-x+.3333, -y+.6666, -z+.6666',
				'-x+y+.6666, y+.3333, z+.3333',
				'-x+y+.3333, y+.6666, z+.6666',
				'x+.6666, x-y+.3333, z+.3333',
				'x+.3333, x-y+.6666, z+.6666',
				'-y+.6666, -x+.3333, z+.3333',
				'-y+.3333, -x+.6666, z+.6666',
				'-x+y+.6666, -x+.3333, z+.3333',
				'-x+y+.3333, -x+.6666, z+.6666',
				'-y+.6666, x-y+.3333, z+.3333',
				'-y+.3333, x-y+.6666, z+.6666',
				'x+.6666, y+.3333, z+.3333',
				'x+.3333, y+.6666, z+.6666'],
			'R -3 m hr':['x-y, -y, -z',
				'-x, -x+y, -z',
				'y, x, -z',
				'x-y, x, -z',
				'y, -x+y, -z',
				'-x, -y, -z',
				'-x+y, y, z',
				'x, x-y, z',
				'-y, -x, z',
				'-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'x-y+.3333, -y+.6666, -z+.3333',
				'x-y+.6666, -y+.3333, -z+.6666',
				'-x+.3333, -x+y+.6666, -z+.3333',
				'-x+.6666, -x+y+.3333, -z+.6666',
				'y+.3333, x+.6666, -z+.3333',
				'y+.6666, x+.3333, -z+.6666',
				'x-y+.3333, x+.6666, -z+.3333',
				'x-y+.6666, x+.3333, -z+.6666',
				'y+.3333, -x+y+.6666, -z+.3333',
				'y+.6666, -x+y+.3333, -z+.6666',
				'-x+.3333, -y+.6666, -z+.3333',
				'-x+.6666, -y+.3333, -z+.6666',
				'-x+y+.3333, y+.6666, z+.3333',
				'-x+y+.6666, y+.3333, z+.6666',
				'x+.3333, x-y+.6666, z+.3333',
				'x+.6666, x-y+.3333, z+.6666',
				'-y+.3333, -x+.6666, z+.3333',
				'-y+.6666, -x+.3333, z+.6666',
				'-x+y+.3333, -x+.6666, z+.3333',
				'-x+y+.6666, -x+.3333, z+.6666',
				'-y+.3333, x-y+.6666, z+.3333',
				'-y+.6666, x-y+.3333, z+.6666',
				'x+.3333, y+.6666, z+.3333',
				'x+.6666, y+.3333, z+.6666'],
			'R -3 m r':['-z, -y, -x',
				'-z, -x, -y',
				'-x, -z, -y',
				'-y, -z, -x',
				'-y, -x, -z',
				'-x, -y, -z',
				'z, y, x',
				'z, x, y',
				'x, z, y',
				'y, z, x',
				'y, x, z',
				'x, y, z'],
			'R -3 c h':['x-y, -y, -z+.5',
				'-x, -x+y, -z+.5',
				'y, x, -z+.5',
				'x-y, x, -z',
				'y, -x+y, -z',
				'-x, -y, -z',
				'-x+y, y, z+.5',
				'x, x-y, z+.5',
				'-y, -x, z+.5',
				'-x+y, -x, z',
				'-y, x-y, z',
				'x, y, z',
				'x-y+.6666, -y+.3333, -z+.8333',
				'x-y+.3333, -y+.6666, -z+.1666',
				'-x+.6666, -x+y+.3333, -z+.8333',
				'-x+.3333, -x+y+.6666, -z+.1666',
				'y+.6666, x+.3333, -z+.8333',
				'y+.3333, x+.6666, -z+.1666',
				'x-y+.6666, x+.3333, -z+.3333',
				'x-y+.3333, x+.6666, -z+.6666',
				'y+.6666, -x+y+.3333, -z+.3333',
				'y+.3333, -x+y+.6666, -z+.6666',
				'-x+.6666, -y+.3333, -z+.3333',
				'-x+.3333, -y+.6666, -z+.6666',
				'-x+y+.6666, y+.3333, z+.8333',
				'-x+y+.3333, y+.6666, z+.1666',
				'x+.6666, x-y+.3333, z+.8333',
				'x+.3333, x-y+.6666, z+.1666',
				'-y+.6666, -x+.3333, z+.8333',
				'-y+.3333, -x+.6666, z+.1666',
				'-x+y+.6666, -x+.3333, z+.3333',
				'-x+y+.3333, -x+.6666, z+.6666',
				'-y+.6666, x-y+.3333, z+.3333',
				'-y+.3333, x-y+.6666, z+.6666',
				'x+.6666, y+.3333, z+.3333',
				'x+.3333, y+.6666, z+.6666'],
			'R -3 c r':['-x+.5, -z+.5, -y+.5',
				'-z+.5, -y+.5, -x+.5',
				'-y+.5, -x+.5, -z+.5',
				'x+.5, z+.5, y+.5',
				'z+.5, y+.5, x+.5',
				'y+.5, x+.5, z+.5',
				'-z, -x, -y',
				'-y, -z, -x',
				'-x, -y, -z',
				'z, x, y',
				'y, z, x',
				'x, y, z']
            }

            
			
			
